public cssbWar3EntityCreate( szClassName[32], szModel[64], Float:fOrigin[3], iMoveType, iSolidType, Float:fLife ) 
{

	new ent = create_entity( "info_target" );
	entity_set_string( ent, EV_SZ_classname, szClassName );

	entity_set_model( ent, szModel );
	entity_set_origin( ent, fOrigin );

	entity_set_int( ent, EV_INT_movetype, iMoveType );
	entity_set_int( ent, EV_INT_solid, iSolidType );

	if ( fLife )
	{
		new arg_write[1];
		arg_write[0] = ent;

		new task = TASK_TEMPENTITY + ent;

		set_task( fLife, "cssbWar3EntityRemove", task, arg_write, 1 );
	}

	return ( ent );
}

public cssbWar3EntityRemove( arg_read[1] ) 
{
	new ent = arg_read[0];

	if ( is_valid_ent( ent ) )
		remove_entity( ent );

	return PLUGIN_HANDLED;
}

public cssbWar3EntityRemoveClass( szClassname[32], owner ) 
{

	new ent = find_ent_by_class( -1, szClassname );

	while ( ent > 0 )
	{
		if ( ( !owner || entity_get_edict( ent, EV_ENT_owner ) == owner ) && cssbWar3EntityValid( ent ) )
		{
			new task = TASK_TEMPENTITY + ent;
			remove_task( task, 0 );

			remove_entity( ent );

			ent = find_ent_by_class( -1, szClassname );
		}

		else
		{
			ent = find_ent_by_class( ent, szClassname );
		}
	}

	return PLUGIN_HANDLED;
}

public cssbWar3EntityValid( ent ) 
{

	// Don't want to look up info for an invalid ent

	if ( !is_valid_ent( ent ) )
		return ( false );

	// Entities that war3x creates

	new szWar3Entities[][64] = { "IMPALE_CLAW", "SLEEP_Z" };

	new szClassName[64];
	entity_get_string( ent, EV_SZ_classname, szClassName, 63 );

	// See if this class is in our list

	for ( new i = 0; i < sizeof( szWar3Entities ); i++ )
	{
		if ( equal( szClassName, szWar3Entities[i] ) )
			return ( true );
	}

	return ( false );
}