
#define ValidT(%1) ( is_user_alive(%1) && get_user_team(%1) == TEAM_T )

const NADE_TYPE_CAMPO = 6545

new Float:CampoColors[ 3 ] = { 0.0 , 180.0 , 255.0  }

new TrailColor[ 3 ] = { 000, 180, 255 }
new Float:Maxs[ 3 ] = { 100.0 , 100.0 , 100.0 }
new Float:Mins[ 3 ] = { -100.0, -100.0, -100.0 }

new const model[] = "models/warcraft3/aura8.mdl"
new const sprite_grenade_trail[] = "sprites/laserbeam.spr"
new entclas[] = "campo_grenade_forze"

new g_trailSpr

const Float:Push = 15.0

public give_fsgCT(player) 
{
			if( !user_has_weapon( player, CSW_SMOKEGRENADE ) )
				give_item(player,"weapon_smokegrenade")
				
				gBomb[player] = true
}
public fw_PlayerKilled(victim, attacker, shouldgib)
{
	if( gBomb[victim] ) 
		gBomb[victim] = false
		
	if( gBombT[victim] ) 
		gBombT[victim] = false
}

public fw_ThinkGrenade(entity) 
{   
	
	if(!pev_valid(entity)) return HAM_IGNORED
	
	static Float:dmgtime   
	pev(entity, pev_dmgtime, dmgtime)
	
	if (dmgtime > get_gametime())
		return HAM_IGNORED   
	
	switch (pev(entity, PEV_NADE_TYPE))
	{
		case NADE_TYPE_CAMPO: // Infection Bomb
		{
			crear_ent(entity)
			remove_entity(entity)
			return HAM_SUPERCEDE
		}
	}
	
	return HAM_IGNORED
}


public fw_SetModel2(entity, const model[]) 
{	
	static Float:dmgtime
	pev(entity, pev_dmgtime, dmgtime)
	
	if (dmgtime == 0.0)
		return FMRES_IGNORED;
		
	new owner = pev(entity, pev_owner)
		
	if ( is_user_connected(owner) )
	{
	if (ITEM_Has(owner, ITEM_HEART_INFERNAL ) > ITEM_NONE || fWorkTalismanPassive(owner, arrTalismanActive[owner] == TALISMAN_ITEM_HEART_INFERNAL))
	{
	gBomb[owner] = false;
	return FMRES_IGNORED;
	}
	
	if (equal(model[7], "w_sm", 4) && !(ITEM_Has(owner, ITEM_HEART_INFERNAL ) > ITEM_NONE || fWorkTalismanPassive(owner, arrTalismanActive[owner] == TALISMAN_ITEM_HEART_INFERNAL)))
	{				
		if( is_user_alive(owner) && gBomb[owner] ) 
		{			
			
			fm_set_rendering(entity, kRenderFxGlowShell, 000, 255, 255, kRenderNormal, 16)
			
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_BEAMFOLLOW) // TE id
			write_short(entity) // entity
			write_short(g_trailSpr) // sprite
			write_byte(10) // life
			write_byte(10) // width
			write_byte(TrailColor[ 0 ]) // r
			write_byte(TrailColor[ 1 ]) // g
			write_byte(TrailColor[ 2 ]) // b
			write_byte(500) // brightness
			message_end()
			
			set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_CAMPO)
			
			gBomb[owner] = false
			return FMRES_SUPERCEDE
		}
	}
	}
	else
	{
	return FMRES_IGNORED
	}
	
	return FMRES_IGNORED
}

public crear_ent(id) 
{
	// Create entitity
	new iEntity = create_entity("info_target")

	if(!is_valid_ent(iEntity))
		return PLUGIN_HANDLED
	
	new Float: Origin[3] 
	entity_get_vector(id, EV_VEC_origin, Origin) 
	
	entity_set_string(iEntity, EV_SZ_classname, entclas)
	
	entity_set_vector(iEntity, EV_VEC_origin, Origin)
	entity_set_model(iEntity, model)
	entity_set_int(iEntity, EV_INT_solid, SOLID_TRIGGER)
	entity_set_size(iEntity, Mins, Maxs )
	entity_set_int(iEntity, EV_INT_renderfx, kRenderFxGlowShell)
	entity_set_int(iEntity, EV_INT_rendermode, kRenderTransAlpha)
	entity_set_float(iEntity, EV_FL_renderamt, 50.0)
	
	entity_set_vector(iEntity, EV_VEC_rendercolor, CampoColors)
	
	set_task(get_pcvar_float(CVAR_wc3_sg_time), "DeleteEntity", TASK_POLE_CT + iEntity)
	
	return PLUGIN_CONTINUE;
}

public DeleteEntity(iEntity)
{
	if ( iEntity >= TASK_POLE_CT )
	{
		iEntity -= TASK_POLE_CT;
	}

	if(pev_valid(iEntity))
	{
	remove_entity( iEntity )
	}
}

public fw_touch1(ent, touched)
{
	if ( !pev_valid(ent) || !is_user_alive(touched) )
	return FMRES_IGNORED;
	
	static entclass[32];
	pev(ent, pev_model, entclass, 31);
	
	new classname[32];
	pev(ent, pev_classname, classname, sizeof classname - 1);
	
	
	if (equali(classname, "campo_grenade_forze"))
	{
	if ( strcmp( entclass, model ) == 0 )
	{
		if( ValidT(touched) )
		{
			static Float:pos_ptr[3], Float:pos_ptd[3]
			
			pev(ent, pev_origin, pos_ptr)
			pev(touched, pev_origin, pos_ptd)
			
			for(new i = 0; i < 3; i++)
			{
				pos_ptd[i] -= pos_ptr[i]
				pos_ptd[i] *= Push
			}
			set_pev(touched, pev_velocity, pos_ptd)
			set_pev(touched, pev_impulse, pos_ptd)
		}
	}
	}
	return FMRES_IGNORED
}

public remove_poleCT() 
{
	new polect  = find_ent_by_class(-1, entclas)
	while(polect) 
	{
		remove_entity(polect)
		polect = find_ent_by_class(-1, entclas)
	}
}
