InfernalSkillsOffensive( iAttacker, iVictim ,iHitPlace)
{
    if(!is_user_alive( iAttacker ) || !is_user_alive(iVictim))
	return;

    static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_ILLUZION );
	if( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
	if(random_float( 0.0, 1.0 ) <= p_illuzion[iSkillLevel-1] )
	{
		if(iHitPlace==HIT_HEAD)
		{
			new Float:aAngle[3];
			pev(iVictim, pev_view_ofs, aAngle);
			aAngle[0] = 250.0;
			aAngle[1] = 0.0;
			aAngle[2] = 0.0;
			set_pev(iVictim, pev_angles, aAngle);
			set_pev(iVictim, pev_fixangle, 1);
		}	
	}
	}
}

public UltimateInfernalHells( idUser )
{
	if ( !is_user_alive(idUser) || p_data_b[idUser][PB_ISFROZENSKILL] == true || !p_data_b[idUser][PB_ISCONNECTED] || p_data_b[idUser][PB_HEXED])
		return;
	
	if(is_user_alive(idUser) && g_InfernaliK == false)
	{
    set_task( ring_time_Inferno, "InfernalHellsEffect", TASK_HELLS + idUser, _, _, "a", num_ring_Inferno );
	Create_BarTime( idUser, floatround(ring_time_Inferno * float(num_ring_Inferno)), 0 );
	}
	
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
}

public InfernalHellsEffect(idUser)
{
    if ( idUser >= TASK_HELLS )
	{
		idUser -= TASK_HELLS;
	}
	
	if(!is_user_alive( idUser ))
	return;


    new vVictimOrigin[3],vAxisOrigin[3], vNewOrigin[3];
	get_user_origin( idUser, vVictimOrigin );
	
	vNewOrigin[0] = vVictimOrigin[0];
	vNewOrigin[1] = vVictimOrigin[1];
	vNewOrigin[2] = vVictimOrigin[2] - 16;

	vAxisOrigin[2] = vVictimOrigin[2] + ring_range_Inferno;
	Create_TE_BEAMCYLINDER( vNewOrigin, vNewOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 10, 0, 184, 134, 11, 255, 0 );

    new players[32], numberofplayers, targetid, targetorigin[3], origin[3];
	new iTeam = get_user_team( idUser );
	

	get_user_origin( idUser, origin );
	get_players( players, numberofplayers, "a" );
	for ( new i = 0; i < numberofplayers; i++ )
	{
		targetid = players[i];
		
		// User is on the iAttacker's team
		if ( p_data_b[targetid][PB_ISCONNECTED] && get_user_team( targetid ) != iTeam && idUser != targetid)
		{
			if ( is_user_alive( targetid ) )
			{
				get_user_origin( targetid, targetorigin );
				
				new iDamage = ring_dmg_Inferno;
			
				// User is close enough
				if ( get_distance(origin, targetorigin) < ring_range_Inferno )
				{
					if ( get_user_health( targetid ) - iDamage >= 0)
					{	
					    if(ITEM_Has(targetid, ITEM_NECKLACE) > ITEM_NONE 
						|| (fWorkTalismanPassive(targetid,arrTalismanActive[targetid]) == TALISMAN_ITEM_NECKLACE && arrTalismanNecklaceNum[targetid] > 0) || p_data_b[targetid][PB_WARDENBLINK] == true)
						{
						WC3_Damage( targetid, idUser, 0, CSW_HELLS, 0);
						ITEM_RemoveCharge( targetid, ITEM_NECKLACE );
						ULT_Blocked( idUser );
						return;
						}
						else
						{
						WC3_Damage( targetid, idUser, iDamage, CSW_HELLS, 0);
						emit_sound( targetid, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE_BURNING], 0.5, ATTN_NORM, 0, PITCH_NORM );
						new vTargetOrigin[3];
	                    get_user_origin( targetid, vTargetOrigin );
						Create_TE_EXPLOSION( vTargetOrigin, vTargetOrigin, g_iSprites[SPR_BURNING], 30, 24, 4 );
						Create_ScreenShake( targetid, (10<<12), (3<<12), (6<<12) );
						}
					}
				}
			}
		}
	}
}
