new MG_DAMAGE 	=  20;		// Damage done by Unstable Concoction
new MG_RADIUS	=  370;		// Damage done by Unstable Concoction
new dmg_ult_spmage = 4;
new Float:mg_time_r_ing_h = 0.5;
new num_u_r_ing = 20;
new mg_hp_regen_fg = 50;
new Float:stealing_plot_mage_s = 2.0;
new Float:stealing_plot_mage_sp = 1.0;

public MAGE_HEALING( idUser )
{
	if ( task_exists( idUser + TASK_MAGE_H ) == 0 )
	{
		_MAGE_HEALING( idUser );
	}
}

public _MAGE_HEALING(idUser)
{
	
	if ( idUser >= TASK_MAGE_H )
	{
		idUser -= TASK_MAGE_H;
	}
	
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	if ( !is_user_alive(idUser) )
	{
		return;
	}
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_1_MAGE );

	if ( iSkillLevel > 0 && p_data_b[idUser][PB_ISFROZENSKILL] == false )
    {
		
	if ( is_user_alive( idUser ) )
	{
		set_task( p_mage_skill1[iSkillLevel-1], "MAGE_HEALING", TASK_MAGE_H + idUser );
	}
	
	if ( get_user_health( idUser ) < get_user_maxhealth( idUser ) )
	{
	if ( get_user_health( idUser ) + mg_hp_regen_fg > get_user_maxhealth( idUser ) )
	{
	set_user_health( idUser, get_user_maxhealth( idUser ) );
	}
	else
	{
	set_user_health( idUser, get_user_health( idUser ) + mg_hp_regen_fg );
	
	new origin[3]      
	get_user_origin( idUser, origin ) 
	Create_TE_EXPLOSION( origin, origin, g_iSprites[SPR_NEW_SPR2], 20, 24, 4 );
	}
	}
	}
	
	return;
}

public MGG_PlaceSerpentWard( idUser )
{

	MGGG_PlaceSerpentWard( idUser );
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );

}

public MGGG_PlaceSerpentWard( idUser )
{
	new parm[5], origin[3]

	get_user_origin( idUser, origin );
	parm[0] = origin[0];
	parm[1] = origin[1];
	parm[2] = origin[2];
	parm[3] = idUser;
	parm[4] = get_user_team( idUser );

	_MGG_DrawSerpentWard( parm );
	
	set_task( mg_time_r_ing_h, "_MGG_DrawSerpentWard", TASK_LIGHT + idUser, parm, 5, "a", num_u_r_ing );
}
public _MGG_DrawSerpentWard( parm[5] )
{

	if ( !WC3_Check() )
	{
		return;
	}

	new idUser = parm[3];

	// User is no longer connected, stop drawing wards
	if( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	static start[3], end[3], origin[3], vAxisOrigin[3];
	
	origin[0] = parm[0];
	origin[1] = parm[1];
	origin[2] = parm[2];
	
	new radius = floatround( 65.0 / 5.0 * 5 );
	Create_TE_DLIGHT( origin, radius, random_num(0, 255), random_num(0, 255), random_num(0, 255), 10, 4 );

	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_FIREBALL], (random_num(0,20) + 20), 12, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_DEATHCOIL], (random_num(0,20) + 20), 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_BLACKFIRE], (random_num(0,20) + 20), 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_BURNFIRE], (random_num(0,20) + 20), 24, 0 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_SHADOWSTRIKE], 5, 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	vAxisOrigin[2] = origin[2] + 10;
	
	Create_TE_BEAMCYLINDER( origin, end, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 10, 0, random_num(0, 255), random_num(0, 255), random_num(0, 255), 255, 0 );
	
	start[0] = origin[0];
	start[1] = origin[1];
	start[2] = origin[2] - 16;
			
	vAxisOrigin[2] = origin[2] + MG_RADIUS;
	
	Create_TE_BEAMCYLINDER( origin, start, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 20, 0, 0, 255, 0, 255, 0 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_FIREBALL], (random_num(0,20) + 20), 12, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_DEATHCOIL], (random_num(0,20) + 20), 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_BLACKFIRE], (random_num(0,20) + 20), 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_BURNFIRE], (random_num(0,20) + 20), 24, 0 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	Create_TE_EXPLOSION( end, end, g_iSprites[SPR_SHADOWSTRIKE], 5, 24, 4 );
	
	end[0] = origin[0] - random_num( -333, 333 );
	end[1] = origin[1] - random_num( -333, 333 );
	end[2] = origin[2] - random_num( -333, 333 );
	
	vAxisOrigin[2] = origin[2] + 10;
	
	Create_TE_BEAMCYLINDER( origin, end, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 10, 10, 0, random_num(0, 255), random_num(0, 255), random_num(0, 255), 255, 0 );

	// Now lets check and see if any players are near that need to be damaged
	new players[32], numberofplayers;
	new targetid, targetorigin[3];

	get_players( players, numberofplayers, "a" );
	
	for ( new i = 0; i < numberofplayers; i++ )
	{
		targetid = players[i];

		if ( parm[4] != get_user_team( targetid ) )
		{
			get_user_origin( targetid, targetorigin );

			if ( get_distance( origin, targetorigin ) < MG_RADIUS )
			{
				if(ITEM_Has(targetid, ITEM_NECKLACE) > ITEM_NONE || (fWorkTalismanPassive(targetid, arrTalismanActive[targetid]) == TALISMAN_ITEM_NECKLACE && arrTalismanNecklaceNum[targetid] > 0) || p_data_b[targetid][PB_WARDENBLINK] == true)
				{
				ITEM_RemoveCharge( targetid, ITEM_NECKLACE );
				ULT_Blocked( idUser );
				return;
				}
				else
				{
				WC3_Damage( targetid, idUser, dmg_ult_spmage, CSW_SERPENTWARD, -1 );
				Create_ScreenShake( targetid, (10<<12), (3<<12), (6<<12) );
				Create_ScreenFade( targetid, (1<<12), (1<<10), (1<<12), random_num(0, 255), random_num(0, 255), random_num(0, 255), 180 );
				
				if(random_float( 0.0, 1.0 ) <= 0.400 )
				{
				new Float:aAngle[3];
				pev(targetid, pev_view_ofs, aAngle);
				aAngle[0] = 250.0;
				aAngle[1] = 0.0;
				aAngle[2] = 0.0;
				set_pev(targetid, pev_angles, aAngle);
				set_pev(targetid, pev_fixangle, 1);
				}
				
				if(random_float( 0.0, 1.0 ) <= 0.400 )
				{
				new Float:aAngle[3];
				pev(targetid, pev_view_ofs, aAngle);
				aAngle[0] = -250.0;
				aAngle[1] = 0.0;
				aAngle[2] = 0.0;
				set_pev(targetid, pev_angles, aAngle);
				set_pev(targetid, pev_fixangle, 1);
				}
				
				if(random_float( 0.0, 1.0 ) <= 0.300 )
				{
				new Float:vVelocity[3];
				entity_get_vector( targetid, EV_VEC_velocity, vVelocity );

				vVelocity[2] = random_float(200.0, 400.0 );

				entity_set_vector( targetid, EV_VEC_velocity, vVelocity );
				}
				
				}
			}
		}
	}

	return;
}



public Mage_SkillsOffensive3( iAttacker, iVictim, iHitPlace )
{
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_3_MAGE );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if ( random_float(0.0,1.0 ) <= p_mage_skill3[iSkillLevel-1] )		
		{
					set_pev(iVictim,pev_maxspeed,stealing_plot_mage_sp)
					new Float:angle[3]
					angle[0]= 60.0
					angle[1]= 160.0
					angle[2]= 160.0
					entity_set_vector(iVictim, EV_VEC_angles, angle)
					set_task(stealing_plot_mage_s,"UnParal",iVictim)
		}		
	}
	
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_2_MAGE );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false)
	{
		if ( random_float(MIN_PERCENT_SHADOW, MAX_PERCENT_SHADOW ) <= p_mage_skill2[iSkillLevel-1] )		
		{	
			new vOrigin[3], pos[3], end[3]; 

            get_user_origin( iVictim, vOrigin); 

            pos[ 0 ] = vOrigin[ 0 ]; 
            pos[ 1 ] = vOrigin[ 1 ]; 
            pos[ 2 ] = vOrigin[ 2 ] + 600; 

            end[0] = vOrigin[0] 
            end[1] = vOrigin[1] 
            end[2] = vOrigin[2] - 600
			
			Create_TE_SPRITETRAIL( pos, end, g_iSprites[WC3_SPRITE_3], 40, 15, 4, 2, 5 );

			// Damage the user
			WC3_Damage( iVictim, iAttacker, MG_DAMAGE, CSW_MAGEE, iHitPlace );
		}
	}
}	

public UnParal(idUser)
{
	if(!is_user_alive(idUser))
	return;
	
	SHARED_SetSpeed( idUser );
	
	return;
}

public UnParal_m(idUser)
{
	if ( idUser >= TASK_MAGE_N )
	{
		idUser -= TASK_MAGE_N;
	}

	if(!is_user_alive(idUser))
	return;
	
	SHARED_SetSpeed( idUser );
	
	return;
}

public UnParal2(idUser)
{
	if ( idUser >= TASK_TANK_ONN )
	{
		idUser -= TASK_TANK_ONN;
	}

	if(!is_user_alive(idUser))
	return;
	
	SHARED_SetSpeed( idUser );
	
	return;
}

public UnParal3(idUser)
{
	if ( idUser >= TASK_TPD )
	{
		idUser -= TASK_TPD;
	}

	if(!is_user_alive(idUser))
	return;
	
	SHARED_SetSpeed( idUser );
	
	return;
}	

