/*
*	Race: Meater Functions
*/

#define ALLOWED_WEAPONS	2

new g_PudgeHealthAuraGiven[33];
new g_allowedWeapons[ALLOWED_WEAPONS] = {CSW_KNIFE, CSW_C4}

public fPudgeRestart(idUser)
{
    if(!is_user_alive(idUser))
	return;

    static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel(idUser, SKILL_MASTER_PUDGE);
	if( iSkillLevel > 0 )
	g_hooksLeft[idUser] = p_pudge_hooks[iSkillLevel-1];
	else
	g_hooksLeft[idUser] = 0;
}

PudgeHealingSurfers( idUser )
{
	if ( !is_user_alive( idUser ) )
	{
		return;
	}

	static iSkillLevel;
	new PudgeHealthGiven, iHealth;
 	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_PUDGE_WAVE );
 	
	// Already given
	PudgeHealthGiven = g_PudgeHealthAuraGiven[idUser];
		
	// Then the user has devotion aura
	if ( iSkillLevel > 0 )
	{
		g_PudgeHealthAuraGiven[idUser] = p_pudge_health * iSkillLevel;
	}
	else
	{
		g_PudgeHealthAuraGiven[idUser] = 0;
	}
 
	iHealth = get_user_health( idUser );
	
	if (iHealth + PudgeHealthGiven < 0)
	{
		set_user_health( idUser, 1 );
 	}
	
	set_user_health( idUser, iHealth + PudgeHealthGiven );

}

public forward_trace_attack()
{
	new victim = read_data(1);
	new attacker = read_data(2);
	new where = read_data(5);
	
	if(!is_user_alive(attacker) || (get_tr2(where, TR_iHitgroup) == HIT_HEAD) || p_data[attacker][P_RACE] != RACE_PUDGE)
	{
		drag_end(victim);
	}
}

public newSpawn(id)
{
    if(!is_user_alive(id))
	return;

    if (g_hooked[id])
        drag_end(id);
}

// Курильщик Выпускает Язык
public drag_start(id)
{        
	new Float:SmokerCooulDown; 
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel(id, SKILL_MASTER_PUDGE);
	
	if (is_user_alive(id) && iSkillLevel > 0 && !g_drag_i[id] && p_data_b[id][PB_ISFROZENSKILL] == false) 
	{  
        SmokerCooulDown = 0.0;

        if (!is_user_alive(id)) 
		{
             format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"DRAG_IN_DEATH");		
			cssbColoredPrint(id, szMessage);
            return PLUGIN_HANDLED
        }

        if (g_hooksLeft[id] <= 0) 
		{
            format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"DRAG_ZERO");		
			cssbColoredPrint(id, szMessage);
            return PLUGIN_HANDLED
        }

        if (get_gametime() - g_lastHook[id] < SmokerCooulDown) 
		{
			format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"DRAG_WAIT", floatround( SmokerCooulDown - (get_gametime() - g_lastHook[id]) ));		
			cssbColoredPrint(id, szMessage);
            return PLUGIN_HANDLED;
        }
        
        new hooktarget, body;
        get_user_aiming(id, hooktarget, body);
        
        if (is_user_alive(hooktarget)) 
		{
            if (get_user_team(hooktarget) != get_user_team(id))
            {
                g_hooked[id] = hooktarget;
				emit_sound( id, CHAN_STATIC, g_szSounds[SOUND_FRESH_MEAT], 1.0, ATTN_NORM, 0, PITCH_NORM );
            }
            else
            {
                format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			    LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			    LANG_PLAYER,"DRAG_IN_YOUR_TEAM");		
		    	cssbColoredPrint(id, szMessage);
				
                return PLUGIN_HANDLED;
            }
            
            new parm[2];
            parm[0] = id;
            parm[1] = hooktarget;

            set_task(0.1, "smoker_reelin", id, parm, 2, "b");
            harpoon_target(parm);
            
            g_hooksLeft[id]--;
			
            format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"DRAG_MESSAGE_USE",
			g_hooksLeft[id]);		
			cssbColoredPrint(id, szMessage);
			
            g_drag_i[id] = true;
            g_unable2move[hooktarget] = true
        } 
		else 
		{
            g_hooked[id] = 33;
            noTarget(id)
			//client_cmd(id,"mp3 play sound/warcraft3/smoker/csWarcraftSmokerDrag") 
            //g_drag_i[id] = true;
            g_hooksLeft[id]--
			
			format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"DRAG_MESSAGE_USE",
			g_hooksLeft[id]);		
			cssbColoredPrint(id, szMessage);
        }
    }
    else
        return PLUGIN_HANDLED
    
    return PLUGIN_CONTINUE
}

// Тянем жертву к курильщику
public smoker_reelin(parm[])
{
    new idAttacker = parm[0]
    new idVictim = parm[1]

    if (!g_hooked[idAttacker] || !is_user_alive(idVictim) || !is_user_alive(idAttacker))
    {
        drag_end(idAttacker)
        return;
    }

    new Float:fl_Velocity[3]
    new idOrigin[3], vicOrigin[3]

    get_user_origin(idVictim, vicOrigin)
    get_user_origin(idAttacker, idOrigin)

    new distance = get_distance(idOrigin, vicOrigin)

    if (distance > 1) 
	{
		new Float:fDragSpeed;
		fDragSpeed = 120.0;
		
        new Float:fl_Time = distance / fDragSpeed;

        fl_Velocity[0] = (idOrigin[0] - vicOrigin[0]) / fl_Time;
        fl_Velocity[1] = (idOrigin[1] - vicOrigin[1]) / fl_Time;
        fl_Velocity[2] = (idOrigin[2] - vicOrigin[2]) / fl_Time;
    } 
	else 
	{
        fl_Velocity[0] = 0.0;
        fl_Velocity[1] = 0.0;
        fl_Velocity[2] = 0.0;
    }

    entity_set_vector(idVictim, EV_VEC_velocity, fl_Velocity) //<- rewritten. now uses engine
}

// Конец драга
public drag_end(id) 
{ 
    if(!is_user_alive(id))
	return;
 
    g_hooked[id] = 0
    beam_remove(id)
    remove_task(id)
    
    if (g_drag_i[id])
        g_lastHook[id] = get_gametime()
    
    g_drag_i[id] = false
    g_unable2move[id] = false
}

// Смокер умирает, убираем язык
public smoker_death()
{
    new id = read_data(2)
    
    beam_remove(id)
    
    if (g_hooked[id])
        drag_end(id)
}

// Считывание Урона
public fw_TakeDamage(victim, inflictor, attacker, Float:damage) 
{
    new sDamageToStop;
	sDamageToStop = 500;
	
	if (is_user_alive(attacker) && ( sDamageToStop > 0 ) && is_user_alive(victim))
	{
		g_ovr_dmg[victim] = g_ovr_dmg[victim] + floatround(damage);
		if (g_ovr_dmg[victim] >= sDamageToStop)
		{
			g_ovr_dmg[victim] = 0
			drag_end(victim)
			return HAM_IGNORED;
		}
	}

	return HAM_IGNORED;
}

public fw_PlayerPreThink(id)
{
    if (!is_user_alive(id))
        return FMRES_IGNORED
    
    new button = get_user_button(id)
    new oldbutton = get_user_oldbutton(id)
    
    if (g_bind_use[id] && p_data[id][P_RACE] == RACE_PUDGE)
    {
        if (!(oldbutton & IN_USE) && (button & IN_USE))
            drag_start(id)
        
        if ((oldbutton & IN_USE) && !(button & IN_USE))
            drag_end(id)
    }
    
    if (!g_drag_i[id]) 
	{
        g_unable2move[id] = false
    }
        
    if (g_unable2move[id])
    {
        set_pev(id, pev_maxspeed, 1.0)
    }
    
    return PLUGIN_CONTINUE
}


public harpoon_target(parm[]) // set beam (ex. tongue:) if target is player
{
    new id = parm[0]
    new hooktarget = parm[1]

    message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
    write_byte(8)    // TE_BEAMENTS
    write_short(id)
    write_short(hooktarget)
    write_short(g_Line)    // sprite index
    write_byte(0)    // start frame
    write_byte(0)    // framerate
    write_byte(200)    // life
    write_byte(30)    // width
    write_byte(1)    // noise
    write_byte(155)    // r, g, b
    write_byte(155)    // r, g, b
    write_byte(55)    // r, g, b
    write_byte(90)    // brightness
    write_byte(10)    // speed
    message_end()
}

public noTarget(id) // set beam if target isn't player
{
    new endorigin[3]

    get_user_origin(id, endorigin, 3)

    message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
    write_byte( TE_BEAMENTPOINT ); // TE_BEAMENTPOINT
    write_short(id)
    write_coord(endorigin[0])
    write_coord(endorigin[1])
    write_coord(endorigin[2])
    write_short(g_Line) // sprite index
    write_byte(0)    // start frame
    write_byte(0)    // framerate
    write_byte(8)    // life
    write_byte(10)    // width
    write_byte(1)    // noise
    write_byte(155)    // r, g, b
    write_byte(155)    // r, g, b
    write_byte(55)    // r, g, b
    write_byte(75)    // brightness
    write_byte(0)    // speed
    message_end()
}

public beam_remove(id) // remove beam
{
    message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
    write_byte(99)    //TE_KILLBEAM
    write_short(id)    //entity
    message_end()
}

PudgeSkillsOffensive( iAttacker, iVictim )
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_X_DAMAGE );
	if( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
	WC3_Damage(iVictim, iAttacker, p_pudge_damage[iSkillLevel-1], CSW_PUDGE_SHOT, 0);
	SHARED_GlowShell(iVictim,255,0,0,4.5);
	}
}

public MM_ULT_FREEZE( iCaster, iTarget )
{

    if(!is_user_alive(iCaster) || !is_user_alive(iTarget))
	return;

	new origin[3];
    get_user_origin(iTarget, origin, 0);
	
	if ( !SHARED_IsPlayerSlowed( iTarget ) )
		{		

			p_data_b[iTarget][PB_STUNNED] = true;
			SHARED_SetSpeed( iTarget );
			
			set_task( FREEZE_HOLD_TIME, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iTarget );

			// Make the user glow!
			SHARED_Glow( iTarget, 0, 255, 255, 100 );
			
			// Create a screen fade
			Create_ScreenFade( iTarget, (1<<10), (1<<10), (1<<12), 0, 0, 120, 100 )
			
			new vVictimOrigin[3],vAxisOrigin[3];
			get_user_origin( iTarget, vVictimOrigin );

			vAxisOrigin[2] += vVictimOrigin[2] + 150;
			Create_TE_BEAMCYLINDER( vVictimOrigin, vVictimOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 4, 60, 0, 41, 138, 255, 200, 0 );
			
			emit_sound( iCaster, CHAN_STATIC, g_szSounds[SOUND_PUDGE_SCREAM], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
		}   

	    ULT_ResetCooldown( iCaster, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
}
