new g_Tank_Armor[33];
new g_Tank_Speed[33];
new Float:time_ult_tank = 10.0;
new Float:speed_ult_tank = 190.0;
new heavy_sea_dmg = 10;
new heavy_sea_r = 300;
new Float:time_h_tank = 2.0;
new dmg_hex = 7;
new block_ult_radius_tank = 300;

public Tanker_Ultimate(idUser)
{
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	if(!is_user_alive(idUser))
	return;
	
	if(is_user_alive(idUser))
	{
	
	new bool:bCanBlockUltimate = false;
 
	new iOrigin[3], iPlayersOrigin[3], players[32], idWorldPlayer, numberofplayers;
	get_user_origin( idUser, iOrigin );
 
	get_players( players, numberofplayers, "a" );
	for ( new i = 0; i < numberofplayers; i++ )
	{
	idWorldPlayer = players[i];
	get_user_origin( idWorldPlayer, iPlayersOrigin );
		if( get_distance( iOrigin, iPlayersOrigin ) < block_ult_radius_tank )
		{
			if( get_user_team( idUser ) != get_user_team( idWorldPlayer ) )
			{
				if( ULT_CanUserBlockUlt( idWorldPlayer ) )
				{
					bCanBlockUltimate = true;
				}
			}
		}
	}
	
	if( bCanBlockUltimate == true )
	{
		ULT_Blocked( idUser );
		ULT_RemoveCharge(idWorldPlayer)
		ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	}
	
	if( bCanBlockUltimate == false )
	{
	g_Tank_Armor[idUser] = 1;
	g_Tank_Speed[idUser] = 1;
	set_pev(idUser, pev_maxspeed, speed_ult_tank);
	set_task(time_ult_tank,"UnArmorTank",TASK_TANK_O + idUser);
	ULT_Icon( idUser, ICON_FLASH );
	//effects
	set_task(1.0,"Tank_Ult_Eff",TASK_TANK_ON + idUser);
	set_task(4.0,"Tank_Ult_Eff",TASK_TANK_ON + idUser);
	set_task(7.0,"Tank_Ult_Eff",TASK_TANK_ON + idUser);
	set_task(10.0,"Tank_Ult_Eff",TASK_TANK_ON + idUser);
	set_task(time_ult_tank,"Tank_Ult_Eff",TASK_TANK_ON + idUser);
	set_task(time_ult_tank,"UnParal2",TASK_TANK_ONN + idUser);
	Create_BarTime(idUser, floatround(time_ult_tank), 0);
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ), false );
	}
	}
	
	return;
}
public Tank_Ult_Eff(id)
{
	if ( id >= TASK_TANK_ON )
	{
		id -= TASK_TANK_ON;
	}
	
	if(!is_user_alive(id))
	return;
	
	new origin[3]      
	get_user_origin( id, origin ) 
	Create_TE_EXPLOSION( origin, origin, g_iSprites[SPR_NEW_SPR4], 15, 24, 4 );
}	

public UnArmorTank(idUser)
{
	if ( idUser >= TASK_TANK_O )
	{
		idUser -= TASK_TANK_O;
	}
	
	if ( !p_data_b[idUser][PB_ISCONNECTED])
	{
		return;
	}
	
	ULT_Icon( idUser, ICON_HIDE );
	
	g_Tank_Armor[idUser] = 0;
	g_Tank_Speed[idUser] = 0;
	
	return;
}	

Tanker_SkillsOffensive1( iAttacker, iVictim )
{
	if ( !p_data_b[iAttacker][PB_ISCONNECTED] || !p_data_b[iVictim][PB_ISCONNECTED] )
	{
		return;
	}
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_1_TANKER );
	
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
	WC3_Damage( iVictim, iAttacker, p_tanker_skill1[iSkillLevel-1], CSW_IMMOLATE, -1 )
	}
	
}

public Tanker_SkillsOffensive3( iAttacker, iVictim )
{
	if ( !p_data_b[iAttacker][PB_ISCONNECTED] || !p_data_b[iVictim][PB_ISCONNECTED] )
	{
		return;
	}
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_3_TANKER );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{	
		if ( random_float(0.0, 1.0 ) <= p_tanker_skill3[iSkillLevel-1] )		
		{
			new vOrigin[3], vInitOrigin[3], vAxisOrigin[3], i;
			get_user_origin( iAttacker, vOrigin );
			vInitOrigin[0] = vOrigin[0];
			vInitOrigin[1] = vOrigin[1];
			vInitOrigin[2] = vOrigin[2] - 16;

			vAxisOrigin[0] = vOrigin[0];
			vAxisOrigin[1] = vOrigin[1];
			vAxisOrigin[2] = vOrigin[2] + heavy_sea_r;
			for ( i = 0; i < 200; i += 25 )
			{
				Create_TE_BEAMCYLINDER( vOrigin, vInitOrigin, vAxisOrigin, g_iSprites[SPR_NEW_SPR6], 0, 0, 10, 20, 0, 188, 220, 255, 255, 0 );

				vInitOrigin[2] += 25;
			}
			new team = get_user_team( iVictim );
			new players[32], numberofplayers, vTargetOrigin[3];
			get_players(players, numberofplayers, "a");
			for( i = 0; i < numberofplayers; i++ )
			{
				if ( is_user_alive( players[i] ) )
				{
					if ( get_user_team( players[i] ) != team )
					{
						get_user_origin( players[i], vTargetOrigin );

						if ( get_distance( vOrigin, vTargetOrigin ) <= heavy_sea_r )
						{
							if(players[i]!=iAttacker)
							{
								WC3_Damage( players[i], iAttacker, heavy_sea_dmg, CSW_CONCOCTION, 0 );
								Create_TE_EXPLOSION( vTargetOrigin, vTargetOrigin, g_iSprites[SPR_NEW_SPR5], 15, 24, 4 );
							}	
						
						}
					}
				}
			}
		}
	}
}	
	
	
public Tanker_SkillsOffensive2( iAttacker, iVictim )
{
	if ( !p_data_b[iAttacker][PB_ISCONNECTED] || !p_data_b[iVictim][PB_ISCONNECTED] )
	{
		return;
	}
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_2_TANKER );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{	
		if ( random_float(0.0,1.0 ) <= p_tanker_skill2[iSkillLevel-1] )		
		{
					p_data_b[iVictim][PB_HEXED] = true
					p_data_b[iVictim][PB_SLOWED] = true;
					SHARED_SetSpeed( iVictim );
					SHARED_SetGravity( iVictim );
					SHARED_INVIS_Set( iVictim );
					set_task( time_h_tank, "_SH_RemoveHex", TASK_HEX + iVictim );
					emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_HEX], 1.0, ATTN_NORM, 0, PITCH_NORM );
					WC3_Damage( iVictim, iAttacker, dmg_hex, CSW_IMMOLATE, -1 )	
		}
	}
}	