public TechiesPrecache()
{
	TechiesSPR1 = precache_model("sprites/warcraft3/snow.spr");
	TechiesSPR2 = precache_model("sprites/zerogxplode.spr");
	//Techies bomb models
	precache_model(szModelNameLandMine)
	precache_model(szModelNameStasisTrap)
	precache_model(szModelNameDetonateMine)
	
}	

public Wc3_TechiesBomb(idUser)
{
	if(!is_user_alive(idUser)) return;
	new Float:get_time = get_gametime()
	if (get_time - g_ShowAbilityTechies[idUser] < TECHIES_MENU_PERIOD)
	{
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
					LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
					LANG_PLAYER,"TECHIES_ABILITY_NO_TIME",
					floatround(TECHIES_MENU_PERIOD - (get_time - g_ShowAbilityTechies[idUser])));

		cssbColoredPrint(idUser, szMessage);
		return;
	}
	new msg[250];
    formatex(msg, charsmax(msg), "%L",LANG_PLAYER,"WC3_MENU_TECHIESBOMB")
	new menu = menu_create(msg,"Wc3_TechiesBomb_handler") 
	static iSkillLevel1,iSkillLevel2,iSkillLevel3;
	iSkillLevel1 = SM_GetSkillLevel( idUser, SKILL_LAND_MINES  );
	iSkillLevel2 = SM_GetSkillLevel( idUser, SKILL_STASIS_TRAP );
	iSkillLevel3 = SM_GetSkillLevel( idUser, ULTIMATE_DETONATE );
	if(iSkillLevel1 > 0)
	{
		formatex(msg, charsmax(msg), "%L^t^t^t-^t^t^t(%d/%d)",LANG_PLAYER,"SKILL_135",g_iGoblinTechiesBomb[idUser][BOMB_LAND_MINES],p_land_mines[iSkillLevel1-1])
		menu_additem(menu, msg, "1")
	}
	else
	{
		formatex(msg, charsmax(msg), "\d%L",LANG_PLAYER,"SKILL_135")
		menu_additem(menu, msg, "1")
	}	
	if(iSkillLevel2 > 0)
	{
		formatex(msg, charsmax(msg), "%L^t^t^t-^t^t^t(%d/%d)",LANG_PLAYER,"SKILL_136",g_iGoblinTechiesBomb[idUser][BOMB_STASIS_TRAP],p_stasis_trap[iSkillLevel2-1])
		menu_additem(menu, msg, "2")
	}	
	else
	{
		formatex(msg, charsmax(msg), "\d%L",LANG_PLAYER,"SKILL_136")
		menu_additem(menu, msg, "2")
	}
	if(iSkillLevel3 > 0)
	{
		formatex(msg, charsmax(msg), "%L^t^t^t-^t^t^t(%d/%d)",LANG_PLAYER,"SKILL_138",g_iGoblinTechiesBomb[idUser][BOMB_DETONATE],p_detonate_mines)
		menu_additem(menu, msg, "3")
	}
	else
	{
		formatex(msg, charsmax(msg), "\d%L",LANG_PLAYER,"SKILL_138")
		menu_additem(menu, msg, "3")
	}
	formatex(msg,charsmax(msg),"%L",LANG_PLAYER,"WC3_MENU_EXIT")
	menu_setprop(menu, MPROP_EXITNAME, msg)
	menu_display(idUser,menu, 0);
}	

public Wc3_TechiesBomb_handler( id, menu, item ) 
{ 
    if( item == MENU_EXIT ) 
    { 
        menu_destroy( menu ); 
        return PLUGIN_HANDLED; 
    } 
    new data[6], iName[64]; 
    new access, callback; 
     
    menu_item_getinfo( menu, item, access, data,5, iName, 63, callback ); 
    new key = str_to_num( data ); 
	static iSkillLevel1,iSkillLevel2,iSkillLevel3;
	iSkillLevel1 = SM_GetSkillLevel( id, SKILL_LAND_MINES  );
	iSkillLevel2 = SM_GetSkillLevel( id, SKILL_STASIS_TRAP );
	iSkillLevel3 = SM_GetSkillLevel( id, ULTIMATE_DETONATE );
	g_ShowAbilityTechies[id] = get_gametime();
    switch( key ) 
    { 
		case 1:
		{
			if(iSkillLevel1 ==0)
			{
				show_cssb_message(id,"WC3_NO_BOMB_TECHIES") 
				return PLUGIN_HANDLED; 
			}
			if(g_iGoblinTechiesBomb[id][BOMB_LAND_MINES] >= p_land_mines[iSkillLevel1-1])
			{
				show_cssb_message(id,"TECHIES_BOMB_MAX") 
				return PLUGIN_HANDLED; 
			}	
			g_iGoblinTechiesBomb[id][BOMB_LAND_MINES]++
			TechiesBombCreate(id,BOMB_LAND_MINES)
		}
		case 2:
		{
			if(iSkillLevel2 ==0)
			{
				show_cssb_message(id,"WC3_NO_BOMB_TECHIES") 
				return PLUGIN_HANDLED; 
			}
			if(g_iGoblinTechiesBomb[id][BOMB_STASIS_TRAP] >= p_stasis_trap[iSkillLevel2-1])
			{
				show_cssb_message(id,"TECHIES_BOMB_MAX") 
				return PLUGIN_HANDLED;
			}	
			g_iGoblinTechiesBomb[id][BOMB_STASIS_TRAP]++
			TechiesBombCreate(id,BOMB_STASIS_TRAP)
		
		}
		case 3:
		{
			if(iSkillLevel3 ==0)
			{
				show_cssb_message(id,"WC3_NO_BOMB_TECHIES") 
				return PLUGIN_HANDLED; 
			}
			if(g_iGoblinTechiesBomb[id][BOMB_DETONATE] >= p_detonate_mines)
			{
				show_cssb_message(id,"TECHIES_BOMB_MAX") 
				return PLUGIN_HANDLED;
			}
			g_iGoblinTechiesBomb[id][BOMB_DETONATE]++
			TechiesBombCreate(id,BOMB_DETONATE)
		}
		
	}
	return PLUGIN_HANDLED
}	

public TechiesSuicide(idUser)
{
	if ( g_iSuicideTechies[idUser] )
	{
		WC3_KillUser( idUser, 0, 0 );
			
		g_iSuicideTechies[idUser] = false
	}

	else
	{
		g_iSuicideTechies[idUser] = true
		WC3_StatusText( idUser, TXT_BLINK_CENTER, "%L", LANG_PLAYER, "SUICIDE_BOMB_ARMED" );
	}
}	


Techies_Suicide(idUser)
{

	// If we ult while changing teams, you will kill your old teammates, we don't want that!!
	if ( p_data_b[idUser][PB_CHANGINGTEAM] )
	{
		return;
	}

	// Play the undead explosion sound!!!
	emit_sound( idUser, CHAN_STATIC, g_szSounds[SOUND_SUICIDE], 1.0, ATTN_NORM, 0, PITCH_NORM );

	new parm[5], vOrigin[3];
	get_user_origin( idUser, vOrigin );

	parm[0] = idUser;
	parm[1] = 6;
	parm[2] = vOrigin[0];
	parm[3] = vOrigin[1];
	parm[4] = vOrigin[2];

	// Set up the tasks to damage + draw effects
	set_task( 0.5, "_Techies_SuicideExplode", TASK_EXPLOSION + idUser, parm, 5 );
	set_task( 0.5, "_Techies_SuicideBlastCircles", TASK_BEAMCYLINDER + idUser, parm, 5 );
	
	// Create an implosion effect where they died
	Create_TE_IMPLOSION( vOrigin, 100, 20, 5 );
	
}

public _Techies_SuicideExplode( parm[5] )
{
	new idUser = parm[0];

	if ( get_pcvar_num( CVAR_wc3_psychostats ) )
	{
		new WEAPON = CSW_BOMB - CSW_WAR3_MIN;

		iStatsShots[idUser][WEAPON]++;
	}

	new vOrigin[3], vPosition[3];
	vOrigin[0] = parm[2];
	vOrigin[1] = parm[3];
	vOrigin[2] = parm[4];

	vPosition[0] = vOrigin[0] + random_num( -100, 100 );
	vPosition[1] = vOrigin[1] + random_num( -100, 100 );
	vPosition[2] = vOrigin[2] + random_num( -50, 50 );
	
	Create_TE_EXPLOSION( vOrigin, vPosition, g_iSprites[SPR_FIREBALL], (random_num(0,20) + 20), 12, TE_EXPLFLAG_NONE );
	
	// This doesn't look correct in Day of Defeat, so lets only do it for CS/CZ
	if ( g_MOD == GAME_CSTRIKE || g_MOD == GAME_CZERO )
	{
		Create_TE_Smoke( vOrigin, vPosition, g_iSprites[SPR_SMOKE], 60, 10 );
	}

	new players[32], numberofplayers;
	get_players( players, numberofplayers, "a" );

	new i, iTargetID, vTargetOrigin[3], iDamage, iDistance;
	new iMultiplier = ( TECHIES_EXPLOSION_MAX_DAMAGE * TECHIES_EXPLOSION_MAX_DAMAGE ) / TECHIES_EXPLOSION_RANGE;
	new iTeam = get_user_team( idUser );
	
	// Check all players and see if they should be damaged
	for ( i = 0; i < numberofplayers; i++ )
	{
		iTargetID = players[i];
		
		// Get origin of target
		get_user_origin( iTargetID, vTargetOrigin );

		// Get distance in b/t target and caster
		iDistance = get_distance( vOrigin, vTargetOrigin );
		
		// Make sure this user is close enough to do damage + isn't immune + isn't on the same team + isn't already immune to all damage
		if ( iDistance < TECHIES_EXPLOSION_RANGE && iTeam != get_user_team( iTargetID ))
		{

			
				// Calculate the damage to be done
			iDamage = ( TECHIES_EXPLOSION_RANGE - iDistance) * iMultiplier;
			static iSkillLevel;
			iSkillLevel = SM_GetSkillLevel( idUser, SKILL_SUICIDE  );
			if(iSkillLevel > 0)
			{
				iDamage = floatround(float(iDamage) * p_techies_suicide[iSkillLevel-1])
			}	
			iDamage = sqroot( iDamage );
				
				// Damage them!!!!
			WC3_Damage( iTargetID, idUser, iDamage, CSW_BOMB, -1 );
				
				// Lets shake up their screen a bit
			Create_ScreenShake( iTargetID, (1<<14), (1<<13), (1<<14) );
			
		}
	
	}
	--parm[1];
	
	// Lets keep going if we have some left!
	if ( parm[1] > 0 )
	{
		set_task( 0.1, "_Techies_SuicideExplode", TASK_EXPLOSION + idUser, parm, 5 );
	}
}

// Draw the blast circles
public _Techies_SuicideBlastCircles( parm[5] )
{
	new vOrigin[3], vPosition[3];

	vOrigin[0] = parm[2];
	vOrigin[1] = parm[3];
	vOrigin[2] = parm[4] - 16;

	vPosition[0] = vOrigin[0];
	vPosition[1] = vOrigin[1];
	vPosition[2] = vOrigin[2] + TECHIES_EXPLOSION_BLAST_RADIUS;

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_iSprites[SPR_SHOCKWAVE], 0, 0, 6, 16, 0, 188, 220, 255, 255, 0 );

	vOrigin[2] = ( vOrigin[2] - TECHIES_EXPLOSION_BLAST_RADIUS ) + ( TECHIES_EXPLOSION_BLAST_RADIUS / 2 );

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_iSprites[SPR_SHOCKWAVE], 0, 0, 6, 16, 0, 188, 220, 255, 255, 0 );
}


public Techies_Bomb_Detonate(idUser)
{
	DetonateTechiesBombUltimate(idUser)
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
}	


public TechiesBombCreate(idUser,Type)
{
	new Float:origin[ 3 ]	
	entity_get_vector( idUser, EV_VEC_origin,origin )
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))
	switch(Type)
	{
		case BOMB_LAND_MINES:
		{
			set_pev(ent, pev_classname, szClassNameLandMine)
			show_cssb_message(idUser,"WC3_PLANT_LAND_MINES") 
			engfunc(EngFunc_SetModel, ent, szModelNameLandMine)
			
		}
		case BOMB_STASIS_TRAP:
		{
			set_pev(ent, pev_classname, szClassNameStasisTrap)
			show_cssb_message(idUser,"WC3_PLANT_STASIS_TRAP") 
			engfunc(EngFunc_SetModel, ent, szModelNameStasisTrap)
		}
		case BOMB_DETONATE:
		{
			set_pev(ent, pev_classname, szClassNameDetonateMine)
			show_cssb_message(idUser,"WC3_PLANT_DETONATE_MINE") 
			engfunc(EngFunc_SetModel, ent, szModelNameDetonateMine)
		}	
	}
	origin[ 2 ] -= 100.0
	entity_set_origin( ent, origin )
	origin[ 2 ] += 120.0
	entity_set_origin( idUser, origin )
	set_pev(ent, pev_solid, 2)
	set_pev(ent, pev_takedamage, 1.0)
	set_pev(ent, pev_health, 9999.0)
	set_pev(ent, pev_iuser2, idUser );
	engfunc(EngFunc_SetSize, ent, Float:{ -4.0, -4.0, 0.0 }, Float:{ 4.0, 4.0, 4.0 } )
	engfunc(EngFunc_SetOrigin, ent, origin)
	engfunc(EngFunc_DropToFloor, ent)
	
	switch(Type)
	{
		case BOMB_LAND_MINES:
		{
			static iSkillLevel;
			iSkillLevel = SM_GetSkillLevel( idUser, SKILL_LAND_MINES );
			
			if(TechiesBombInvisibility)
			{
				if(iSkillLevel >= TECHIES_SKILL_LEVEL_INVIS_MINE)
				{
					set_entity_visibility(ent, 0)
				}
			}
			else set_entity_visibility(ent, 1)
			
		}
		case BOMB_STASIS_TRAP:
		{
			static iSkillLevel;
			iSkillLevel = SM_GetSkillLevel( idUser, SKILL_STASIS_TRAP );
			
			if(TechiesBombInvisibility)
			{
				if(iSkillLevel >= TECHIES_SKILL_LEVEL_INVIS_MINE)
				{
					set_entity_visibility(ent, 0)
				}
			}
			else set_entity_visibility(ent, 1)
			
		}
		case BOMB_DETONATE:
		{
			if(TechiesBombInvisibility)set_entity_visibility(ent, 0)
			else set_entity_visibility(ent, 1)
		}	
	}
}	
	


public touchPlayerBomb(idEntityTouched, idUserTouch)//добавлена в loot.inl (public player_Touch(idEntityTouched, idUserTouch))
{

	if (!pev_valid(idEntityTouched) || !is_user_alive(idUserTouch))
		return FMRES_IGNORED;
	
	new classname[32];
	pev(idEntityTouched, pev_classname, classname, sizeof classname - 1);
	
	if (equali(classname, szClassNameLandMine))
	{
		new owner = pev( idEntityTouched, pev_iuser2 )
		if(pev_valid(owner))
		{
			if(cs_get_user_team(idUserTouch)!=cs_get_user_team(owner))
			{
				new Float:origin[ 3 ]	
				entity_get_vector( idEntityTouched, EV_VEC_origin,origin )
				create_explosion(origin,idEntityTouched,TechiesSPR2,BOMB_LAND_MINES)
			}
		}

	}
	if (equali(classname, szClassNameStasisTrap))
	{	
		new owner = pev( idEntityTouched, pev_iuser2 )
		if(pev_valid(owner))
		{
			if(cs_get_user_team(idUserTouch)!=cs_get_user_team(owner))
			{
				new Float:origin[ 3 ]	
				entity_get_vector( idEntityTouched, EV_VEC_origin,origin )
				create_explosion(origin,idEntityTouched,TechiesSPR1,BOMB_STASIS_TRAP)
			}
		}
	}
	return FMRES_IGNORED;
}
	
	
RemoveAllMine()
{	
	new nextitem  = find_ent_by_class(-1, szClassNameLandMine);
	while(nextitem)
	{
		remove_entity(nextitem);
		nextitem = find_ent_by_class(-1, szClassNameLandMine);
	}
	new nextitem2  = find_ent_by_class(-1, szClassNameStasisTrap);
	while(nextitem2)
	{
		remove_entity(nextitem2);
		nextitem2 = find_ent_by_class(-1, szClassNameStasisTrap);
	}
	new nextitem3  = find_ent_by_class(-1, szClassNameDetonateMine);
	while(nextitem3)
	{
		remove_entity(nextitem3);
		nextitem3 = find_ent_by_class(-1, szClassNameDetonateMine);
	}
}	
//Удаление мин игрока
public RemoveAllmines( idUser )
{
	new ent = -1
	while((ent = find_ent_by_class(ent , szClassNameLandMine)) != 0)
	{
		new owner = pev( ent, pev_iuser2 )
		if(pev_valid(owner)==pev_valid(idUser))
		{
			remove_entity(ent)
		}	
	}	
	while((ent = find_ent_by_class(ent , szClassNameStasisTrap)) != 0)
	{
		new owner = pev( ent, pev_iuser2 )
		if(pev_valid(owner)==pev_valid(idUser))
		{
			remove_entity(ent)
		}	
	}	
	while((ent = find_ent_by_class(ent , szClassNameDetonateMine)) != 0)
	{
		new owner = pev( ent, pev_iuser2 )
		if(pev_valid(owner)==pev_valid(idUser))
		{
			remove_entity(ent)
		}	
	}	
}


public DetonateTechiesBombUltimate(idUser)
{
	new ent = -1
	while((ent = find_ent_by_class(ent , szClassNameDetonateMine)) != 0)
	{
		new owner = pev( ent, pev_iuser2 )
		if(owner==idUser)
		{
				new Float:origin[ 3 ]	
				entity_get_vector( ent, EV_VEC_origin,origin )
				create_explosion(origin,ent,TechiesSPR2,BOMB_DETONATE)
		}	
	}	
	g_iGoblinTechiesBomb[idUser][BOMB_DETONATE] = 0;
}	



//Explode
stock create_explosion(const Float:origin[3],ent,sprite,type)
{
	new Float:EntOrigin[3];
	new EntiOrigin[3];
    pev(ent, pev_origin, EntOrigin)
	EntiOrigin[0] = floatround(EntOrigin[0]);
	EntiOrigin[1] = floatround(EntOrigin[1]);
	EntiOrigin[2] = floatround(EntOrigin[2]);
	new owner = pev( ent, pev_iuser2 )
	switch(type)
	{
		case BOMB_LAND_MINES:
		{
			new players[32], numberofplayers;
			new targetid, targetorigin[3];

			get_players( players, numberofplayers, "a" );
	
			for ( new i = 0; i < numberofplayers; i++ )
			{
				targetid = players[i];
				if(pev_valid(targetid) && pev_valid(owner))
				{
					if ( cs_get_user_team(owner) != cs_get_user_team( targetid ) )
					{
						get_user_origin( targetid, targetorigin );
						
						if ( get_distance( EntiOrigin, targetorigin ) < RADUIS_BOMB_DAMAGE )
						{
							WC3_Damage( targetid, owner, TECHIES_BOMB_DAMAGE_LAND_MINES, CSW_BOMB, -1 );
						}
					}
				}	
			}		
			if(pev_valid(owner))show_cssb_message(owner,"WC3_BOOM_LAND_MINES") 
		}	
		
		case BOMB_STASIS_TRAP:
		{
			new players[32], numberofplayers;
			new targetid, targetorigin[3];

			get_players( players, numberofplayers, "a" );
	
			for ( new i = 0; i < numberofplayers; i++ )
			{
				targetid = players[i];
				if(pev_valid(targetid) && pev_valid(owner))
				{
					if ( cs_get_user_team(owner) != cs_get_user_team( targetid ) )
					{
						get_user_origin( targetid, targetorigin );
						
						if ( get_distance( EntiOrigin, targetorigin ) < RADUIS_BOMB_DAMAGE )
						{
							p_data_b[targetid][PB_HEXED] = true
							p_data_b[targetid][PB_SLOWED] = true;
								
							// Slow the user's speed
							SHARED_SetSpeed( targetid );

							// Set the user's gravity
							SHARED_SetGravity( targetid );

							// Set the user's rendering
							SHARED_INVIS_Set( targetid );
							set_task( TECHIES_STASIS_TRAP_TIME ,"_Techies_RemoveHex", TASK_TECHIESHEX + targetid );						
							emit_sound( targetid, CHAN_STATIC, g_szSounds[SOUND_HEX], 1.0, ATTN_NORM, 0, PITCH_NORM );
						}
					}
				}	
			}								
			if(pev_valid(owner))show_cssb_message(owner,"WC3_BOOM_STASIS_TRAP") 
		}
		case BOMB_DETONATE:
		{
			new players[32], numberofplayers;
			new targetid, targetorigin[3];

			get_players( players, numberofplayers, "a" );
	
			for ( new i = 0; i < numberofplayers; i++ )
			{
				targetid = players[i];
				if(pev_valid(targetid) && pev_valid(owner))
				{
					if ( cs_get_user_team(owner) != cs_get_user_team( targetid ) )
					{
						get_user_origin( targetid, targetorigin );
						
						if ( get_distance( EntiOrigin, targetorigin ) < RADUIS_BOMB_DAMAGE )
						{
							WC3_Damage( targetid, owner, TECHIES_BOMB_DAMAGE_DETONATE, CSW_BOMB, -1 );
						}
					}
				}	
			}
			if(pev_valid(owner))show_cssb_message(owner,"WC3_BOOM_DETONATE") 
		}
	}	
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(99)
	write_short(ent)
	message_end()
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(3)
	write_coord(floatround(origin[0]))
	write_coord(floatround(origin[1]))
	write_coord(floatround(origin[2]))
	write_short(sprite)
	write_byte(50)
	write_byte(15)
	write_byte(0)
	message_end()
	
	if(pev_valid(ent))remove_entity(ent)

} 


public _Techies_RemoveHex( idUser )
{
	
	idUser -= TASK_TECHIESHEX;

	if( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return PLUGIN_HANDLED;
	}
	
	p_data_b[idUser][PB_CAN_RENDER] = true;
	p_data_b[idUser][PB_HEXED]		= false;
	
	if ( is_user_alive( idUser ) )
	{
		// Reset the user's speed
		SHARED_ResetMaxSpeed( idUser );

		// Reset the user's gravity
		SHARED_SetGravity( idUser );

		// Reset the user's rendering
		SHARED_INVIS_Set( idUser );

		// Reset the user's devotion aura
		HU_DevotionAura( idUser );

		emit_sound( idUser, CHAN_STATIC, g_szSounds[SOUND_HEX], 1.0, ATTN_NORM, 0, PITCH_NORM );
	}

	return PLUGIN_HANDLED;
}

	


		
