public Zeus_Ultimate(idUser)
{
	new iTeam = get_user_team( idUser );
	new players[32], numberofplayers, i, iTargetID;
	new bool:Succ_Use;
	get_players( players, numberofplayers, "a" );

	for ( i = 0; i < numberofplayers; i++ )
	{
		iTargetID = players[i];

		if ( get_user_team( iTargetID ) != iTeam && get_user_team(iTargetID) !=3 )
		{
			if ( ULT_CanUserBlockUlt( iTargetID ) )
			{
				ULT_RemoveCharge( iTargetID );
			}
			else
			{
				new vOrigin[3];
				get_user_origin( iTargetID, vOrigin );

				new Start[3], End[3];
				Start[0] = vOrigin[0];
				Start[1] = vOrigin[1];
				Start[2] = vOrigin[2] + 600;
				End[0] = vOrigin[0];
				End[1] = vOrigin[1];
				End[2] = vOrigin[2] - 600;
				new ZeusP = ZeusPasive(idUser,iTargetID);
				WC3_Damage(iTargetID, idUser,ZEUS_ULTIMATE_DAMAGE + ZeusP, CSW_ZEUS, -1 );
				Create_TE_BEAMPOINTS(Start, End, g_iSprites[SPR_LIGHTNING],1, 0, 15, 255, 0, 87, 176, 255, 255, 0);	
				emit_sound(iTargetID, CHAN_STATIC, g_szSounds[SOUND_LIGHTNING], 0.5, ATTN_NORM, 0, PITCH_NORM );
				//msg
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
					LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
					LANG_PLAYER,"SKILL_THUNDERGOD_DAMAGE",ZEUS_ULTIMATE_DAMAGE + ZeusP);	
			
				cssbChatColor(iTargetID, szMessage);
				Succ_Use = true;
				
			}			
		}	

	}
	if(Succ_Use)show_cssb_message(idUser,"SKILL_THUNDERGOD_USE") 
	client_cmd(idUser,"mp3 play %s",sznewSound4)
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) * 2 );
}	
ZEUS_SkillsOffensive1( iCaster,iTarget, iHitPlace )
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iCaster, SKILL_ARC_LIGHT );
	if ( iSkillLevel > 0 )
	{
		if ( random_float(0.0, 1.0 ) <= p_zeus_arc[iSkillLevel-1] )		
		{
			// Display the lightning effect
			Zeus_ARC_Effect( iCaster, iTarget, ZEUS_LIGHTNING_LINEWIDTH, ZEUS_LIGHTNING_DAMAGE, iHitPlace );
	

			// Now we need to search for the next "jump"
			new parm[5];
			parm[0] = iTarget;
			parm[1] = ZEUS_LIGHTNING_DAMAGE;
			parm[2] = ZEUS_LIGHTNING_LINEWIDTH;
			parm[3] = iCaster;
			parm[4] = iHitPlace;

			set_task( 0.2, "ZeusLightning", TASK_LIGHTNING_ZEUS + iTarget, parm, 5 );
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_ZEUS - CSW_WAR3_MIN;

			iStatsShots[iCaster][WEAPON]++;
		}
	}
}

ZEUS_SkillsOffensive2( iAttacker, iVictim, iHitPlace )
{
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_LIGHT_BOLT );
	if ( iSkillLevel > 0 )
	{
		if ( random_float(0.0, 1.0 ) <= p_zeus_bolt[iSkillLevel-1] )		
		{
			new vOrigin[3];
			get_user_origin( iVictim, vOrigin );

			new Start[3], End[3];
			Start[0] = vOrigin[0];
			Start[1] = vOrigin[1];
			Start[2] = vOrigin[2] + 600;
			End[0] = vOrigin[0];
			End[1] = vOrigin[1];
			End[2] = vOrigin[2] - 600;
			new ZeusP = ZeusPasive(iAttacker,iVictim);
			WC3_Damage(iVictim, iAttacker,ZEUS_LIGHTNING_DAMAGE_BOLT + ZeusP, CSW_ZEUS, iHitPlace );

			Create_TE_BEAMPOINTS(Start, End, g_iSprites[SPR_LIGHTNING],1, 0, 15, 255, 0, 87, 176, 255, 255, 0);	
			emit_sound(iVictim, CHAN_STATIC, g_szSounds[SOUND_LIGHTNING], 0.5, ATTN_NORM, 0, PITCH_NORM );
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_ZEUS - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
	}
}

public ZeusPasive(idUser,Target)
{
	static iSkillLevel;
	new dmg = 0;
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_STATIC_FIELD  );
	if(iSkillLevel > 0)
	{
		new Health_Target = get_user_health(Target)
		dmg = floatround(float(Health_Target) * p_zeus_field[iSkillLevel-1])
	}
	return dmg;	
}


//Start Arc Lightning
public Zeus_ARC_Effect( iCaster, iTarget, iLineWidth, iDamage, iBodyPart )
{

	// Make sure we set this user as hit, otherwise we'll hit him again
	p_dataZeusArcLightning[iTarget] = true;
	
	// Damage the user
	new ZeusP = ZeusPasive(iCaster,iTarget);
	WC3_Damage( iTarget, iCaster, iDamage + ZeusP, CSW_ZEUS, iBodyPart );
	
	// Create the lightning
	Create_TE_BEAMENTS( iCaster, iTarget, g_iSprites[SPR_LIGHTNING], 0, 15, 10, iLineWidth, 10, 87, 176, 255, 255, 0 );
	
	// Get the target's origin
	new vOrigin[3]
	get_user_origin( iTarget, vOrigin );
	
	// Create an elight on the target
	Create_TE_ELIGHT( iTarget, vOrigin, 100, 255, 255, 255, 10, 0 );

	// Play the lightning sound
	emit_sound( iCaster, CHAN_STATIC, g_szSounds[SOUND_LIGHTNING], 1.0, ATTN_NORM, 0, PITCH_NORM );

	return;
}

public ZeusLightning( parm[5] )
{
	// parm[0] = enemy
	// parm[1] = damage
	// parm[2] = linewidth
	// parm[3] = caster
	// parm[4] = bodypart

	new iEnemy = parm[0];

	if ( !p_data_b[iEnemy][PB_ISCONNECTED] )
	{
		return;
	}

	new iCaster		= parm[3];
	new iBodyPart	= parm[4];
	new iCasterTeam	= get_user_team( iCaster )

	new vOrigin[3];
	get_user_origin( iEnemy, vOrigin );

	new players[32], numberofplayers;
	get_players( players, numberofplayers, "a" );


	new i, iTarget = 0;
	new iClosestTarget = 0, iClosestDistance = 0;
	new iDistanceBetween = 0;
	new vTargetOrigin[3];

	// Loop through every player
	for ( i = 0; i < numberofplayers; i++ )
	{
		iTarget = players[i];
		
		// Make sure our target player isn't on the same team!
		if ( get_user_team( iTarget ) != iCasterTeam )
		{
			get_user_origin( iTarget, vTargetOrigin )
			
			iDistanceBetween = get_distance( vOrigin, vTargetOrigin );

			// Verify the user is within range and has not been previously hit
			if ( iDistanceBetween < 600 && !p_dataZeusArcLightning[iTarget])
			{				
				// This user is closest!! Lets make a note of this...
				if ( iDistanceBetween < iClosestDistance || iClosestTarget == 0 )
				{
					iClosestDistance = iDistanceBetween;
					iClosestTarget = iTarget;
				}

			}//end immune check
		}//end distance/hit check
	}//end team check

	// Then we have a valid target!!!
	if ( iClosestTarget )
	{
		// Damage should be decreased by 2/3 on each jump
		parm[1] = floatround(float(parm[2])*2/3);

		// Decrease line width as well
		parm[2] = floatround(float(parm[2])*2/3);
		
		// Display the actual lightning
		Zeus_ARC_Effect( iCaster, iClosestTarget, parm[2], parm[1], iBodyPart );

		// Lets call this again on our next target!
		parm[0] = iClosestTarget;
		set_task( 0.2, "ZeusLightning", TASK_LIGHTNINGNEXT_ZEUS + iCaster, parm, 5 );
	}

	// No valid target found - reset all lightning hit variables
	else
	{
		for ( i = 0; i < numberofplayers; i++ )
		{
			iTarget = players[i];

			p_dataZeusArcLightning[iTarget] = false;
		}
	}

	return;
}
	