new const weapon_items[][] = { "weapon_m4a1", "weapon_ak47" }
new const armor_items[] = { 25, 50, 100 }
new const grenade_items[][] = { "weapon_hegrenade", "weapon_flashbang", "weapon_smokegrenade" }
new const xp_items[] = { 100, 200, 300, 400, 500 }
new const money_items[] = { 500, 800, 1100, 1400 }
new const item_items[] = { 1, 2, 3, 4, 5 }
new const hp_items[] = { 25, 50, 75, 100 }
new Array:g_weapon_items;
new Array:g_armor_items;
new Array:g_grenade_items;
new Array:g_xp_items;
new Array:g_money_items;
new Array:g_item_items;
new Array:g_hp_items;

public fInitPresent()
{
	fTimeSpawnPresentGlobal = get_pcvar_float( CVAR_wc3_gl_time_spawn_present );
}

fReadMapSpawnsPresent()
{
	new szMap[32], szConfig[32],  szMapFile[256];
	
	get_mapname(szMap, charsmax(szMap));
	get_configsdir(szConfig, charsmax(szConfig));
	format(szMapFile, charsmax(szMapFile), "%s\war3ft\present\%s.cfg",szConfig, szMap);
	
	iTotalSpawnsPresent = 0;
	
	if (file_exists(szMapFile)) 
	{
		new szDataFile[124]; 
		new	iLength;
		new iLine = 0;
		new szPos[4][8];
    		
		while(iTotalSpawnsPresent < MAX_SPAWNS_PRESENT && (iLine = read_file(szMapFile , iLine , szDataFile ,charsmax(szDataFile), iLength) ) != 0 ) 
		{
			if (strlen(szDataFile) < 2) continue;

			parse(szDataFile, szPos[1], 7, szPos[2], 7, szPos[3], 7);
			
			//Координаты
			arrSpawnOriginPresent[iTotalSpawnsPresent][0] = str_to_num(szPos[1]);
			arrSpawnOriginPresent[iTotalSpawnsPresent][1] = str_to_num(szPos[2]);
			arrSpawnOriginPresent[iTotalSpawnsPresent][2] = str_to_num(szPos[3]);
					
			iTotalSpawnsPresent++;
		}
	}

	log_amx("Total Spawns Present: %d | Map: %s",iTotalSpawnsPresent,szMap);
}

public taskCounterLoopPresent()
{
	if(iTotalSpawnsPresent <= 0)//Если нет респаунов для талисмана
		return;

	new iNumPlayers = get_playersnum();
	if (iNumPlayers < get_pcvar_num( CVAR_wc3_pl_present_respawn ) )
		return;
		
	if(!get_pcvar_num(CVAR_wc3_system_present_on_off))
		return;
		
	if (present_count >= get_pcvar_num(CVAR_wc3_present_max_round))
		return;
		
	if (present_num_maps >= get_pcvar_num(CVAR_wc3_present_totalintime))
		return;

	fTimeSpawnPresentGlobal += 1.0;
	set_pcvar_float(CVAR_wc3_gl_time_spawn_present,fTimeSpawnPresentGlobal);	

	if(fTimeSpawnPresentGlobal >= random_float(TIME_SPAWN_PRESENT1,TIME_SPAWN_PRESENT2))
	{
		fTimeSpawnPresentGlobal = 0.0;
		set_pcvar_float(CVAR_wc3_gl_time_spawn_present,fTimeSpawnPresentGlobal);

		present_num_one = 0;
		fCreatePresent();
		
		if (task_exists(TASK_PRESENT_SPAWN)) remove_task(TASK_PRESENT_SPAWN)
		set_task(0.1, "fCreatePresent", TASK_PRESENT_SPAWN, _, _, "b");
		
		new szShowMsgPresent[256];
		format(szShowMsgPresent, charsmax(szShowMsgPresent), "%L",LANG_PLAYER,"WC3_MSG_RESPAWN_PRESENT");
	
		cssbChatColor(0,"%s%s",fTagWar3ft(),szShowMsgPresent);
		
		client_print(0, print_center, "%L", LANG_PLAYER, "WC3_MSG_RESPAWN_PRESENT2");
	}
}


//Создание модели талисмана
public fCreatePresent()
{
	if (present_count >= get_pcvar_num(CVAR_wc3_present_max_round) || present_num_maps >= get_pcvar_num(CVAR_wc3_present_totalintime))
	{
		remove_task(TASK_PRESENT_SPAWN)
		return PLUGIN_HANDLED;
	}
	
	present_count++
	present_num_one++
	present_num_maps++
	
	switch (random_num(0, 2))
	{
	case 0:
	{
	if(g_Present_one == false)
	{
	entPresent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	if (!entPresent) 
		return -1;
	
	new iSelectPoint = random_num(0,iTotalSpawnsPresent-1);

	new Float:origin[3];
	IVecFVec(arrSpawnOriginPresent[iSelectPoint],origin);//перевод целого вектора в float
	
	set_pev(entPresent, pev_classname, szClassNamePresent1);
	set_pev(entPresent, pev_nextthink, get_gametime() + 5.0); 
	set_pev(entPresent, pev_solid, SOLID_TRIGGER);
	set_pev(entPresent, pev_movetype, MOVETYPE_TOSS);
	set_pev(entPresent, pev_sequence, 1);
	set_pev(entPresent, pev_frame, 0);
	set_pev(entPresent,pev_velocity,Float:{0.0,0.0,0.0});
	engfunc(EngFunc_SetModel, entPresent, szModelPresent1);

	origin[2] -= 25;
	set_pev(entPresent, pev_origin, origin);
	}
	}
	
	case 1:
	{
	if(g_Present_two == false)
	{
	entPresent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	if (!entPresent) 
		return -1;
	
	new iSelectPoint = random_num(0,iTotalSpawnsPresent-1);

	new Float:origin[3];
	IVecFVec(arrSpawnOriginPresent[iSelectPoint],origin);//перевод целого вектора в float
	
	set_pev(entPresent, pev_classname, szClassNamePresent2);
	set_pev(entPresent, pev_nextthink, get_gametime() + 5.0); 
	set_pev(entPresent, pev_solid, SOLID_TRIGGER);
	set_pev(entPresent, pev_movetype, MOVETYPE_TOSS);
	set_pev(entPresent, pev_sequence, 1);
	set_pev(entPresent, pev_frame, 0);
	set_pev(entPresent,pev_velocity,Float:{0.0,0.0,0.0});
	engfunc(EngFunc_SetModel, entPresent, szModelPresent2);

	origin[2] -= 25;
	set_pev(entPresent, pev_origin, origin);
	}
	}
	
	case 2:
	{
	if(g_Present_three == false)
	{
	entPresent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	if (!entPresent) 
		return -1;
	
	new iSelectPoint = random_num(0,iTotalSpawnsPresent-1);

	new Float:origin[3];
	IVecFVec(arrSpawnOriginPresent[iSelectPoint],origin);//перевод целого вектора в float
	
	set_pev(entPresent, pev_classname, szClassNamePresent3);
	set_pev(entPresent, pev_nextthink, get_gametime() + 5.0); 
	set_pev(entPresent, pev_solid, SOLID_TRIGGER);
	set_pev(entPresent, pev_movetype, MOVETYPE_TOSS);
	set_pev(entPresent, pev_sequence, 1);
	set_pev(entPresent, pev_frame, 0);
	set_pev(entPresent,pev_velocity,Float:{0.0,0.0,0.0});
	engfunc(EngFunc_SetModel, entPresent, szModelPresent3);

	origin[2] -= 25;
	set_pev(entPresent, pev_origin, origin);
	}
	}
	
	}
	//Сообщение о респауне нового талисмана
	new szShowMsgPresent[256];
	format(szShowMsgPresent, 255, "%L",LANG_PLAYER,"WC3_MSG_RESPAWN_PRESENT_HUD");
	set_dhudmessage(random_num(0,255),random_num(0,255),random_num(0,255),0.0,-0.4,2,1.0,2.0,0.01,0.01);
	show_dhudmessage(0, szShowMsgPresent);
	
	if ((present_num_one >= get_pcvar_num(CVAR_wc3_present_num)) && task_exists(TASK_PRESENT_SPAWN)) 
		remove_task(TASK_PRESENT_SPAWN)
	
	return -1;
}

//Когда игрок прикасается к талисману
public Present_touch1(idEntityTouched, idUserTouch)
{

	if (!pev_valid(idEntityTouched) || !is_user_alive(idUserTouch))
		return FMRES_IGNORED;
	
	new classname[32];
	pev(idEntityTouched, pev_classname, classname, sizeof classname - 1);
	
	if (equali(classname, "war3ft_present1"))
	{
		new g_weap_give[64];
		
		switch (random_num(0, 1))
		{
			case 0:
			{
				ArrayGetString(g_weapon_items, random_num(0, ArraySize(g_weapon_items) - 1), g_weap_give, charsmax(g_weap_give));
				give_item(idUserTouch, g_weap_give);
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_WEAPON");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		
			case 1:
			{
				set_user_armor(idUserTouch, get_user_armor(idUserTouch) + ArrayGetCell(g_armor_items, random_num(0, ArraySize(g_armor_items) - 1)));
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_ARMOR");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		}
		
		new Nick[32];
		get_user_name(idUserTouch, Nick, 31);
				
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
		LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		LANG_PLAYER,"PRESENT_GIVE_ON", Nick);	
		
		new szMessage2[256];
		formatex(szMessage2, charsmax(szMessage2), "%L",LANG_PLAYER,"PRESENT_GIVE_ON_HUD",Nick);
		
		new arrPlayers[32], iNumPlayers;
		get_players( arrPlayers, iNumPlayers );
		for (new i = 0; i < iNumPlayers; i++ )
		{
		
		new idPlayer = arrPlayers[i];
		
		if(idPlayer == idUserTouch)
			continue;

		//cssbColoredPrint(idPlayer, szMessage);
		set_dhudmessage(random_num(0,255),random_num(0,255),random_num(0,255),-1.0,-1.0,2,1.0,2.0,0.01,0.01);
		show_dhudmessage(idPlayer,"%s",szMessage2);
		
		}
		
		present_num_maps--
		
		if (is_valid_ent(idEntityTouched)) 
				engfunc(EngFunc_RemoveEntity, idEntityTouched);
	}

	return FMRES_IGNORED;
}

public Present_touch2(idEntityTouched, idUserTouch)
{

	if (!pev_valid(idEntityTouched) || !is_user_alive(idUserTouch))
		return FMRES_IGNORED;
	
	new classname[32];
	pev(idEntityTouched, pev_classname, classname, sizeof classname - 1);
	
	if (equali(classname, "war3ft_present2"))
	{
		new g_gr_give[64];
		switch (random_num(0, 2))
		{
			case 0:
			{
				ArrayGetString(g_grenade_items, random_num(0, ArraySize(g_grenade_items) - 1), g_gr_give, charsmax(g_gr_give));
				give_item(idUserTouch, g_gr_give);
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_GRENADE");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		
			case 1:
			{
				XP_Give(idUserTouch, ArrayGetCell(g_xp_items, random_num(0, ArraySize(g_xp_items) - 1)));
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_XP");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		
			case 2:
			{
				set_user_health( idUserTouch, get_user_health(idUserTouch) + ArrayGetCell(g_hp_items, random_num(0, ArraySize(g_hp_items) - 1)));
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_HEALTH");	
				cssbColoredPrint(idUserTouch, szMessage);
			
			}
		}
		
		new Nick[32];
		get_user_name(idUserTouch, Nick, 31);
				
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
		LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		LANG_PLAYER,"PRESENT_GIVE_ON", Nick);	
		
		new szMessage2[256];
		formatex(szMessage2, charsmax(szMessage2), "%L",LANG_PLAYER,"PRESENT_GIVE_ON_HUD",Nick);
		
		
		new arrPlayers[32], iNumPlayers;
		get_players( arrPlayers, iNumPlayers );
		for (new i = 0; i < iNumPlayers; i++ )
		{
		
		new idPlayer = arrPlayers[i];
		
		if(idPlayer == idUserTouch)
			continue;

		//cssbColoredPrint(idPlayer, szMessage);
		set_dhudmessage(random_num(0,255),random_num(0,255),random_num(0,255),-1.0,-1.0,2,1.0,2.0,0.01,0.01);
		show_dhudmessage(idPlayer,"%s",szMessage2);
		}
		
		present_num_maps--
		
		if (is_valid_ent(idEntityTouched)) 
				engfunc(EngFunc_RemoveEntity, idEntityTouched);
	}

	return FMRES_IGNORED;
}

public Present_touch3(idEntityTouched, idUserTouch)
{

	if (!pev_valid(idEntityTouched) || !is_user_alive(idUserTouch))
		return FMRES_IGNORED;
	
	new classname[32];
	pev(idEntityTouched, pev_classname, classname, sizeof classname - 1);
	
	if (equali(classname, "war3ft_present3"))
	{
		switch (random_num(0, 1))
		{
			case 0:
			{
				SHARED_SetUserMoney( idUserTouch, SHARED_GetUserMoney( idUserTouch ) + ArrayGetCell(g_money_items, random_num(0, ArraySize(g_money_items) - 1)), 1 );
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_MONEY");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		
			case 1:
			{
				ITEM_GiveItem(idUserTouch, ArrayGetCell(g_item_items, random_num(0, ArraySize(g_item_items) - 1)));
				
				format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
				LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
				LANG_PLAYER,"PRESENT_GIVE_ITEM");	
				cssbColoredPrint(idUserTouch, szMessage);
			}
		}
		
		new Nick[32];
		get_user_name(idUserTouch, Nick, 31);
				
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L %L",
		LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		LANG_PLAYER,"PRESENT_GIVE_ON", Nick);	
			
		new szMessage2[256];
		formatex(szMessage2, charsmax(szMessage2), "%L",LANG_PLAYER,"PRESENT_GIVE_ON_HUD",Nick);
		
		new arrPlayers[32], iNumPlayers;
		get_players( arrPlayers, iNumPlayers );
		for (new i = 0; i < iNumPlayers; i++ )
		{
		
		new idPlayer = arrPlayers[i];
		
		if(idPlayer == idUserTouch)
			continue;

		//cssbColoredPrint(idPlayer, szMessage);
		set_dhudmessage(random_num(0,255),random_num(0,255),random_num(0,255),-1.0,-1.0,2,1.0,2.0,0.01,0.01);
		show_dhudmessage(idPlayer,"%s",szMessage2);
		}
		
		present_num_maps--
		
		if (is_valid_ent(idEntityTouched)) 
				engfunc(EngFunc_RemoveEntity, idEntityTouched);
	}

	return FMRES_IGNORED;
}