
#define NECRO_ARROW_SPEED 300
#define NECRO_ARROW_DEMAGE get_pcvar_num( CVAR_wc3_necro_demage )	//    

public s5_Necro_staff( iAttacker, iVictim )//  events.inl
{
	if(get_user_team( iVictim ) != get_user_team( iAttacker ) )
	{
		Necro_staff(iAttacker);
		ITEM_RemoveCharge(iAttacker, ITEM_NECRO_STAFF );
	}

	return PLUGIN_HANDLED;
}

public Necro_staff(iAttacker)
{
	if (!is_user_alive(iAttacker)) 
		return PLUGIN_HANDLED;	

	new Float: fOrigin[3], Float:fAngle[3],Float: fVelocity[3];
	pev(iAttacker, pev_origin, fOrigin);
	pev(iAttacker, pev_view_ofs, fAngle);
	fm_velocity_by_aim(iAttacker, 2.0, fVelocity, fAngle);
	fAngle[0] *= -1.0;
	
	// create ent
	new entSkullExp = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	set_pev(entSkullExp, pev_classname, "necro_staff");
	engfunc(EngFunc_SetModel, entSkullExp, "models/warcraft3/shop5/necro_bat.mdl");
	set_pev(entSkullExp, pev_mins, Float:{-1.0, -1.0, -1.0});
	set_pev(entSkullExp, pev_maxs, Float:{1.0, 1.0, 1.0});
	set_pev(entSkullExp, pev_origin, fOrigin);
	fOrigin[0] += fVelocity[0];
	fOrigin[1] += fVelocity[1];
	fOrigin[2] += fVelocity[2];

	entity_set_float(entSkullExp,EV_FL_framerate,1.0);//framerate
	entity_set_int(entSkullExp, EV_INT_rendermode, 4);//randermode
	entity_set_float(entSkullExp, EV_FL_renderamt, 255.0);//visable

	set_pev(entSkullExp, pev_movetype, MOVETYPE_NOCLIP);
	set_pev(entSkullExp, pev_gravity, 0.01);
	fVelocity[0] *= NECRO_ARROW_SPEED;
	fVelocity[1] *= NECRO_ARROW_SPEED;
	fVelocity[2] *= NECRO_ARROW_SPEED;
	set_pev(entSkullExp, pev_velocity, fVelocity);
	set_pev(entSkullExp, pev_owner, iAttacker);
	set_pev(entSkullExp, pev_angles, fAngle);
	set_pev(entSkullExp, pev_solid, SOLID_TRIGGER); //store the enitty id

	return PLUGIN_HANDLED;

}

public touch_necro_arrow(entSkullExp,idWorldPlayer) 
{
	//    -  (,  ..)
	if(idWorldPlayer == 0) 
	{
		if (is_valid_ent(entSkullExp)) 
		remove_entity(entSkullExp);
	}
	//    
	else if(is_user_connected(idWorldPlayer))
	{
		//          
		new iAttacker = entity_get_edict(entSkullExp,EV_ENT_owner);
		if(get_user_team(idWorldPlayer) != get_user_team(iAttacker))
		{
			WC3_Damage(idWorldPlayer, iAttacker, NECRO_ARROW_DEMAGE, CSW_SKULL, 0);
			new vOrigin[3];
			
			get_user_origin(idWorldPlayer, vOrigin);
	
			Create_TE_SPRITE( vOrigin, g_iSprites[SPR_NECRO_STAFF], 7, 100 );
			
			//if (is_valid_ent(entSkullExp)) 
 			//remove_entity(entSkullExp);
		}
	} 
	//       
	else
	{
		if (is_valid_ent(entSkullExp)) 
		remove_entity(entSkullExp);
	}
}