
//----------------- ------------------------------------BEGIN {
//     

public InitLangAllMenus()
{
	new iTotalLanguages = get_langsnum();
	new lang[3], menu[256];
	new curMenuId = -1, highestMenuId = -1;
	new iLang, iMenu;

	// Loop through every menu
	for ( iMenu = 0; iMenu < MAX_NUM_MENUS; iMenu++ )
	{
		// Register the menu names for each language
		for ( iLang = 0; iLang < iTotalLanguages; iLang++ )
		{
			get_lang ( iLang, lang );

			if ( lang_exists( lang ) )
			{
				formatex ( menu, 160, "%L", lang, MENU_TITLES[iMenu] );
				curMenuId = register_menuid ( menu );
				
				if ( curMenuId > highestMenuId )
				{
					register_menucmd ( curMenuId, 1023, MENU_CALLBACK_ALL[iMenu] );
					highestMenuId = curMenuId;
				}
			}
		}// End language loop
	}// End menu loop
}

//  
public fDisplay_Menu_ChangeRace( idUser, iRaceXP[MAX_RACES],iRaceXP2[MAX_RACES],iSelectIdMenu)
{
	switch (iSelectIdMenu)
	{
		case MENU_ID_DEFAULT:
		{
			fBuildMenu(idUser,"MENU_SELECT_RACE",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_SELECT_RACE,LIST_ITEM_SELECT_RACE,MENU_ID_DEFAULT);
		}
		case MENU_ID_RACE_DEFAULT:
		{
			fBuildMenu(idUser,"MENU_ID_RACE_DEFAULT",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_RACE_DEFAULT,LIST_ITEM_RACE_DEFAULT,MENU_ID_RACE_DEFAULT);
		}
		case MENU_ID_RACE_VIPS:
		{
			fBuildMenu(idUser,"MENU_ID_RACE_VIPS",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_RACE_VIPS,LIST_ITEM_RACE_VIPS,MENU_ID_RACE_VIPS);
		}		
		case MENU_ID_RACE_THREE:
		{
			fBuildMenu(idUser,"MENU_ID_RACE_THREE",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_RACE_THREE,LIST_ITEM_RACE_THREE,MENU_ID_RACE_THREE);
		}
	}

	return PLUGIN_CONTINUE;
}

//   
//fBuildMenu(idUser,szKeyLangMenu[], iRaceXP[MAX_RACES] = {0},iMaxItemList = 0,const arrListItemId[] = {0})
public fBuildMenu(idUser,szKeyLangMenu[],iRaceXP[MAX_RACES],iRaceXP2[MAX_RACES],iMaxItemList,const arrListItemId[],iMenuID)
{
	new iPos = 0;
	new szMenuData[512],szXP[16],szXP2[16];
	new szColorNumber[5] = "\y";
	new szColorRace[5] = "\r";
//	new szColorXP[5] = "\y";

	new idKeysMenu = (1<<9);
	
	new faketemp[6];
	
	new szRaceName[MAX_RACES+1][30];//  


	//  
	
		//    
	switch(iMenuID)
	{
		case MENU_ID_DEFAULT,MENU_ID_RACE_DEFAULT,MENU_ID_RACE_VIPS,MENU_ID_RACE_THREE:
		{
		    iPos += format(szMenuData[iPos], charsmax(szMenuData)-iPos, "%L",LANG_PLAYER,szKeyLangMenu);
		
			if ( get_pcvar_num( CVAR_wc3_save_xp ) )
		     iPos += formatex( szMenuData[iPos], charsmax(szMenuData)-iPos, "\R%L^t^t^t^t^t^t^t^t%L^n^n", LANG_PLAYER, "MENU_WORD_EXPERIENCE",LANG_PLAYER,"MENU_WORD_EXP" );
            else
		     iPos += formatex( szMenuData[iPos], charsmax(szMenuData)-iPos, "^n" );
			 

		}
	}
	
	//     
	for(new iKeyItemList = 0; iKeyItemList < iMaxItemList; iKeyItemList++)
	{
		new iMenuID = arrListItemId[iKeyItemList];

		if(iMenuID <= MAX_RACES && iMenuID != 0)
		{
			//  
			lang_GetRaceName(iMenuID, idUser, szRaceName[iMenuID], 29 );

			//   XP  
			num_to_str(iRaceXP[iMenuID-1], szXP, 15 );
			num_to_str(iRaceXP2[iMenuID-1], szXP2, 15 );
		}

		switch (iMenuID)
		{	
			case RACE_UNDEAD: //VIP 
			{
				new iUnCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iUnCount = get_race_count_team(RACE_UNDEAD,TEAM_T);
				case TEAM_CT:iUnCount = get_race_count_team(RACE_UNDEAD,TEAM_CT);
				}
				
				if (iUnCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iUnCount, block_undead);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_undead > 0)
				{
				if(vip_r_undead == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_undead == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_HUMAN: //VIP 
			{
				new iHuCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iHuCount = get_race_count_team(RACE_HUMAN,TEAM_T);
				case TEAM_CT:iHuCount = get_race_count_team(RACE_HUMAN,TEAM_CT);
				}
				
				if (iHuCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iHuCount, block_human);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_human > 0)
				{
				if(vip_r_human == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_human == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_ORC: //VIP 
			{
				new iOrcCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iOrcCount = get_race_count_team(RACE_ORC,TEAM_T);
				case TEAM_CT:iOrcCount = get_race_count_team(RACE_ORC,TEAM_CT);
				}
				
				if (iOrcCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iOrcCount, block_orc);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_orc > 0)
				{
				if(vip_r_orc == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_orc == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_ELF: //VIP 
			{
				new ielfCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:ielfCount = get_race_count_team(RACE_ELF,TEAM_T);
				case TEAM_CT:ielfCount = get_race_count_team(RACE_ELF,TEAM_CT);
				}
				
				if (ielfCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", ielfCount, block_elf);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_elf > 0)
				{
				if(vip_r_elf == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_elf == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_BLOOD: //VIP 
			{
				new iBloodCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iBloodCount = get_race_count_team(RACE_BLOOD,TEAM_T);
				case TEAM_CT:iBloodCount = get_race_count_team(RACE_BLOOD,TEAM_CT);
				}
				
				if (iBloodCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iBloodCount, block_blood);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_blood > 0)
				{
				if(vip_r_blood == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_blood == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_SHADOW: //VIP 
			{
				new iShadowCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iShadowCount = get_race_count_team(RACE_SHADOW,TEAM_T);
				case TEAM_CT:iShadowCount = get_race_count_team(RACE_SHADOW,TEAM_CT);
				}
				
				if (iShadowCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iShadowCount, block_shadow);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_shadow > 0)
				{
				if(vip_r_shadow == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_shadow == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_WARDEN: //VIP 
			{
				new iWardenCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iWardenCount = get_race_count_team(RACE_WARDEN,TEAM_T);
				case TEAM_CT:iWardenCount = get_race_count_team(RACE_WARDEN,TEAM_CT);
				}
				
				if (iWardenCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iWardenCount, block_warden);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_warden > 0)
				{
				if(vip_r_warden == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_warden == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_CRYPT: //VIP 
			{
				new iCryptCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iCryptCount = get_race_count_team(RACE_CRYPT,TEAM_T);
				case TEAM_CT:iCryptCount = get_race_count_team(RACE_CRYPT,TEAM_CT);
				}
				
				if (iCryptCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iCryptCount, block_crypt);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_crypt > 0)
				{
				if(vip_r_crypt == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_crypt == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_CHAMELEON: //VIP 
			{
				new iChameleonCount;
			    switch(get_user_team(idUser))
				{
				case TEAM_T:iChameleonCount = get_race_count_team(RACE_CHAMELEON,TEAM_T);
				case TEAM_CT:iChameleonCount = get_race_count_team(RACE_CHAMELEON,TEAM_CT);
				}
				
				if (iChameleonCount > 0)
		        formatex( faketemp, charsmax(faketemp), "(%i/%i)", iChameleonCount, block_chameleon);
		        else
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_chameleon > 0)
				{
				if(vip_r_chameleon == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_chameleon == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_PUDGE:
			{
				new iPudgeCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iPudgeCount = get_race_count_team(RACE_PUDGE,TEAM_T);
				case TEAM_CT:iPudgeCount = get_race_count_team(RACE_PUDGE,TEAM_CT);
				}
				
				if (iPudgeCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iPudgeCount, block_pudge);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_pudge > 0)
				{
				if(vip_r_pudge == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{	
				if(vip_r_pudge == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) %s\R%s^n",szColorNumber,iKeyItemList + 1,szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^n",szColorNumber,iKeyItemList + 1,szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			
			case RACE_ALLERY:
			{
			    new iAlleryCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iAlleryCount = get_race_count_team(RACE_ALLERY,TEAM_T);
				case TEAM_CT:iAlleryCount = get_race_count_team(RACE_ALLERY,TEAM_CT);
				}
				
				if (iAlleryCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iAlleryCount, block_allery);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_allery > 0)
				{
				if(vip_r_allery == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_allery == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) %s\R%s^n",szColorNumber,iKeyItemList + 1,szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^n",szColorNumber,iKeyItemList + 1,szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_FROST_MAGE: //VIP 
			{
				new iFMGCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iFMGCount = get_race_count_team(RACE_FROST_MAGE,TEAM_T);
				case TEAM_CT:iFMGCount = get_race_count_team(RACE_FROST_MAGE,TEAM_CT);
				}
				
				if (iFMGCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iFMGCount, block_frost_mage);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_frost_mage > 0)
				{
				if(vip_r_frost_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_frost_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_STRAJ: //VIP 
			{
				new iStrajCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iStrajCount = get_race_count_team(RACE_STRAJ,TEAM_T);
				case TEAM_CT:iStrajCount = get_race_count_team(RACE_STRAJ,TEAM_CT);
				}
				
				if (iStrajCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iStrajCount, block_straj);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_straj > 0)
				{
				if(vip_r_straj == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_straj == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			
			case RACE_TANKER: //VIP 
			{
				new iTankCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iTankCount = get_race_count_team(RACE_TANKER,TEAM_T);
				case TEAM_CT:iTankCount = get_race_count_team(RACE_TANKER,TEAM_CT);
				}
				
				if (iTankCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iTankCount, block_tanker);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_tanker > 0)
				{
				if(vip_r_tanker == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_tanker == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_DEMONIC: //VIP 
			{
				new iDkCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDkCount = get_race_count_team(RACE_DEMONIC,TEAM_T);
				case TEAM_CT:iDkCount = get_race_count_team(RACE_DEMONIC,TEAM_CT);
				}
				
				if (iDkCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDkCount, block_demonic);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_demonic > 0)
				{
				if(vip_r_demonic == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_demonic == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_NECROUMANT: //VIP 
			{
				new iNecroCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iNecroCount = get_race_count_team(RACE_NECROUMANT,TEAM_T);
				case TEAM_CT:iNecroCount = get_race_count_team(RACE_NECROUMANT,TEAM_CT);
				}
				
				if (iNecroCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iNecroCount, block_necroumant);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_necroumant > 0)
				{
				if(vip_r_necroumant == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_necroumant == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_INFERNAL: //VIP 
			{
				new iInfernoCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iInfernoCount = get_race_count_team(RACE_INFERNAL,TEAM_T);
				case TEAM_CT:iInfernoCount = get_race_count_team(RACE_INFERNAL,TEAM_CT);
				}
				
				if (iInfernoCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iInfernoCount, block_infernal);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_infernal > 0)
				{
				if(vip_r_infernal == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_infernal == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_DWARF: //VIP 
			{
				new iDwarfCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDwarfCount = get_race_count_team(RACE_DWARF,TEAM_T);
				case TEAM_CT:iDwarfCount = get_race_count_team(RACE_DWARF,TEAM_CT);
				}
				
				if (iDwarfCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDwarfCount, block_dwarf);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_dwarf > 0)
				{
				if(vip_r_dwarf == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_dwarf == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_FIREMAGE: //VIP 
			{
				new iFireMagCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iFireMagCount = get_race_count_team(RACE_FIREMAGE,TEAM_T);
				case TEAM_CT:iFireMagCount = get_race_count_team(RACE_FIREMAGE,TEAM_CT);
				}
				
				if (iFireMagCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iFireMagCount, block_firemage);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_firemage > 0)
				{
				if(vip_r_firemage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_firemage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_WATER_MAGE: //VIP 
			{
				new iWaterMagCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iWaterMagCount = get_race_count_team(RACE_WATER_MAGE,TEAM_T);
				case TEAM_CT:iWaterMagCount = get_race_count_team(RACE_WATER_MAGE,TEAM_CT);
				}
				
				if (iWaterMagCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iWaterMagCount, block_water_mage);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_water_mage > 0)
				{
				if(vip_r_water_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_water_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_DUHWAR: //VIP 
			{
				new iDuhWarCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDuhWarCount = get_race_count_team(RACE_DUHWAR,TEAM_T);
				case TEAM_CT:iDuhWarCount = get_race_count_team(RACE_DUHWAR,TEAM_CT);
				}
				
				if (iDuhWarCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDuhWarCount, block_duhwar);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_duhwar > 0)
				{
				if(vip_r_duhwar == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_duhwar == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_KILLER: //VIP 
			{
				new iKillerCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iKillerCount = get_race_count_team(RACE_KILLER,TEAM_T);
				case TEAM_CT:iKillerCount = get_race_count_team(RACE_KILLER,TEAM_CT);
				}
				
				if (iKillerCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iKillerCount, block_killer);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_killer > 0)
				{
				if(vip_r_killer == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_killer == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			
			case RACE_BLACKBOOK: //VIP 
			{
				new iBlackBookCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iBlackBookCount = get_race_count_team(RACE_BLACKBOOK,TEAM_T);
				case TEAM_CT:iBlackBookCount = get_race_count_team(RACE_BLACKBOOK,TEAM_CT);
				}
				
				if (iBlackBookCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iBlackBookCount, block_blackbook);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_blackbook > 0)
				{
				if(vip_r_blackbook == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_blackbook == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_SHAMAN: //VIP 
			{
				new iShamanCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iShamanCount = get_race_count_team(RACE_SHAMAN,TEAM_T);
				case TEAM_CT:iShamanCount = get_race_count_team(RACE_SHAMAN,TEAM_CT);
				}
				
				if (iShamanCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iShamanCount, block_shaman);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_shaman > 0)
				{
				if(vip_r_shaman == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_shaman == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_ALCHEMIST: //VIP 
			{
				new iAlchemistCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iAlchemistCount = get_race_count_team(RACE_ALCHEMIST,TEAM_T);
				case TEAM_CT:iAlchemistCount = get_race_count_team(RACE_ALCHEMIST,TEAM_CT);
				}
				
				if (iAlchemistCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iAlchemistCount, block_alchemist);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_alchemist > 0)
				{
				if(vip_r_alchemist == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_alchemist == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_MINOTAVR: //VIP 
			{
				new iMinotavrCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iMinotavrCount = get_race_count_team(RACE_MINOTAVR,TEAM_T);
				case TEAM_CT:iMinotavrCount = get_race_count_team(RACE_MINOTAVR,TEAM_CT);
				}
				
				if (iMinotavrCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iMinotavrCount, block_minotavr);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_minotavr > 0)
				{
				if(vip_r_minotavr == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_minotavr == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_STRELOK: //VIP 
			{
				new iStrelokCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iStrelokCount = get_race_count_team(RACE_STRELOK,TEAM_T);
				case TEAM_CT:iStrelokCount = get_race_count_team(RACE_STRELOK,TEAM_CT);
				}
				
				if (iStrelokCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iStrelokCount, block_strelok);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_strelok > 0)
				{
				if(vip_r_strelok == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_strelok == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_DRAGON: //VIP 
			{
				new iDragonCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDragonCount = get_race_count_team(RACE_DRAGON,TEAM_T);
				case TEAM_CT:iDragonCount = get_race_count_team(RACE_DRAGON,TEAM_CT);
				}
				
				if (iDragonCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDragonCount, block_dragon);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_dragon > 0)
				{
				if(vip_r_dragon == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_dragon == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_AXE: //VIP 
			{
				new iAxeCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iAxeCount = get_race_count_team(RACE_AXE,TEAM_T);
				case TEAM_CT:iAxeCount = get_race_count_team(RACE_AXE,TEAM_CT);
				}
				
				if (iAxeCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iAxeCount, block_axe);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_axe > 0)
				{
				if(vip_r_axe == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_axe == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_DARK_LORD: //VIP 
			{
				new iDarkLordCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDarkLordCount = get_race_count_team(RACE_DARK_LORD,TEAM_T);
				case TEAM_CT:iDarkLordCount = get_race_count_team(RACE_DARK_LORD,TEAM_CT);
				}
				
				if (iDarkLordCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDarkLordCount, block_dark_lord);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_dark_lord > 0)
				{
				if(vip_r_dark_lord == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_dark_lord == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_MAGE: //VIP 
			{
				new iDdfgdfgdgCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iDdfgdfgdgCount = get_race_count_team(RACE_MAGE,TEAM_T);
				case TEAM_CT:iDdfgdfgdgCount = get_race_count_team(RACE_MAGE,TEAM_CT);
				}
				
				if (iDdfgdfgdgCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iDdfgdfgdgCount, block_mage);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_mage > 0)
				{
				if(vip_r_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_mage == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_FROSTER: //VIP 
			{
				new iFrosterCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iFrosterCount = get_race_count_team(RACE_FROSTER,TEAM_T);
				case TEAM_CT:iFrosterCount = get_race_count_team(RACE_FROSTER,TEAM_CT);
				}
				
				if (iFrosterCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iFrosterCount, block_froster);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_froster > 0)
				{
				if(vip_r_froster == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_froster == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_TECHIES: //VIP 
			{
				new iFrosterCount;
				switch(get_user_team(idUser))
				{
				case TEAM_T:iFrosterCount = get_race_count_team(RACE_TECHIES,TEAM_T);
				case TEAM_CT:iFrosterCount = get_race_count_team(RACE_TECHIES,TEAM_CT);
				}
				
				if (iFrosterCount > 0)
				formatex( faketemp, charsmax(faketemp), "(%i/%i)", iFrosterCount, block_techies);
				else
				formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_techies > 0)
				{
				if(vip_r_techies == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_techies == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				idKeysMenu |= (1<<iKeyItemList)
			}
			case RACE_ZEUS: //VIP 
			{
				
			    formatex( faketemp, charsmax(faketemp), "");
				
				if(g_on_off_block_race && block_zeus > 0)
				{
				if(vip_r_zeus == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP) \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s \w %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				else
				{
				if(vip_r_zeus == 1)
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s\r(VIP)  %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],faketemp,szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				else
					iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "%s%d. %s %s\R%s^t^t^t^t^t^t^t^t\R%s^n",szColorNumber,iKeyItemList + 1, szRaceName[iMenuID],szColorRace,((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP2 : " " ),((get_pcvar_num( CVAR_wc3_save_xp )) ? szXP : " " ));
				}
				
				idKeysMenu |= (1<<iKeyItemList)
			}
			
			
			case MENU_ID_RACE_DEFAULT:
			{
				iPos += formatex( szMenuData[iPos], charsmax(szMenuData)-iPos, "^n\y%d. %L^n^n",iKeyItemList + 1, LANG_PLAYER, "MENU_ID_RACE_DEFAULT" );
				idKeysMenu |= (1<<iKeyItemList)
			}
			case MENU_ID_RACE_VIPS:
			{
				iPos += formatex( szMenuData[iPos], charsmax(szMenuData)-iPos, "^n\y%d. %L^n",iKeyItemList + 1, LANG_PLAYER, "MENU_ID_RACE_VIPS" );
				idKeysMenu |= (1<<iKeyItemList)
			}
			case MENU_ID_RACE_THREE:
			{
				iPos += formatex( szMenuData[iPos], charsmax(szMenuData)-iPos, "\y%d. %L^n^n",iKeyItemList + 1, LANG_PLAYER, "MENU_ID_RACE_THREE" );
				idKeysMenu |= (1<<iKeyItemList)
			}
		}//switch

	}//for


	//    
	switch(iMenuID)
	{
		case MENU_ID_RACE_DEFAULT,MENU_ID_RACE_VIPS,MENU_ID_RACE_THREE:
		{
			iPos += formatex(szMenuData[iPos], charsmax(szMenuData)-iPos, "^n\d0. %L",LANG_PLAYER,"BACK_STRING")
			idKeysMenu |= (1<<9)
		}
	}
	
	switch(iMenuID)
	{
		case MENU_ID_DEFAULT:
		{
			iPos += format(szMenuData[iPos], charsmax(szMenuData)-iPos, "^n\d0. %L",LANG_PLAYER,"WORD_EXIT");
			idKeysMenu |= (1<<9)
		}
	}

	new szMenuName[128];
	format(szMenuName, charsmax(szMenuName), "%L",LANG_PLAYER,szKeyLangMenu);
	show_menu(idUser,idKeysMenu,szMenuData,-1,szMenuName);

	return PLUGIN_CONTINUE;
}

// 
public fSelectRace(idUser,iRace)
{
    new CsTeams:my_team 
    my_team = cs_get_user_team(idUser)

	
	// User currently has a race
	if ( p_data[idUser][P_RACE] != 0 )
	{
		// Change the user's race at the start of next round
		if ( iRace != p_data[idUser][P_RACE] )
		{
		if(g_on_off_block_race)
		{
		switch (my_team)
		{
		case (CS_TEAM_T):
		{
           if ((IsRacePudgeBlockedT(RACE_PUDGE) == true && iRace == 18 && block_pudge > 0) || (IsRaceAlleryBlockedT(RACE_ALLERY) == true && iRace == 23 && block_allery > 0) || (IsRaceUndeadBlockedT(RACE_UNDEAD) == true && iRace == 1 && block_undead > 0) || (IsRaceHumanBlockedT(RACE_HUMAN) == true && iRace == 2 && block_human > 0) || (IsRaceOrcBlockedT(RACE_ORC) == true && iRace == 3 && block_orc > 0) 
		   || (IsRaceElfBlockedT(RACE_ELF) == true && iRace == 4 && block_elf > 0) || (IsRaceBloodBlockedT(RACE_BLOOD) == true && iRace == 5 && block_blood > 0) || (IsRaceShadowBlockedT(RACE_SHADOW) == true && iRace == 6 && block_shadow > 0) || (IsRaceWardenBlockedT(RACE_WARDEN) == true && iRace == 7 && block_warden > 0) || (IsRaceCryptBlockedT(RACE_CRYPT) == true && iRace == 8 && block_crypt > 0) 
		   || (IsRaceFrostMagBlockedT(RACE_FROST_MAGE) == true && iRace == 9 && block_frost_mage > 0) || (IsRaceChameleonBlockedT(RACE_CHAMELEON) == true && iRace == 10 && block_chameleon > 0) || (IsRaceBlackBookBlockedT(RACE_BLACKBOOK) == true && iRace == 11 && block_blackbook > 0) || (IsRaceDwarfBlockedT(RACE_DWARF) == true && iRace == 12 && block_dwarf > 0) 
		   || (IsRaceNecroBlockedT(RACE_NECROUMANT) == true && iRace == 13 && block_necroumant > 0) || (IsRaceShamanBlockedT(RACE_SHAMAN) == true && iRace == 14 && block_shaman > 0) || (IsRaceAlchemistBlockedT(RACE_ALCHEMIST) == true && iRace == 15 && block_alchemist > 0) || (IsRaceDEMONICBlockedT(RACE_DEMONIC) == true && iRace == 16 && block_demonic > 0)
		   || (IsRaceMINOTAVRBlockedT(RACE_MINOTAVR) == true && iRace == 17 && block_minotavr > 0) || (IsRaceINFERNALBlockedT(RACE_INFERNAL) == true && iRace == 19 && block_infernal > 0) || (IsRaceSTRAJBlockedT(RACE_STRAJ) == true && iRace == 20 && block_straj > 0) || (IsRaceSTRELOKBlockedT(RACE_STRELOK) == true && iRace == 21 && block_strelok > 0)
		   || (IsRaceWATER_MAGEBlockedT(RACE_WATER_MAGE) == true && iRace == 22 && block_water_mage > 0) || (IsRaceFIREMAGEBlockedT(RACE_FIREMAGE) == true && iRace == 24 && block_firemage > 0) || (IsRaceDUHWARBlockedT(RACE_DUHWAR) == true && iRace == 25 && block_duhwar > 0) || (IsRaceKILLERBlockedT(RACE_KILLER) == true && iRace == 26 && block_killer > 0)
		   || (IsRaceTankerBlockedT(RACE_TANKER) == true && iRace == 27 && block_tanker > 0) || (IsRaceDragonBlockedT(RACE_DRAGON) == true && iRace == 28 && block_dragon > 0) || (IsRaceDark_lordBlockedT(RACE_DARK_LORD) == true && iRace == 29 && block_dark_lord > 0) || (IsRaceAxeBlockedT(RACE_AXE) == true && iRace == 30 && block_axe > 0)
		   || (IsRaceMageBlockedT(RACE_MAGE) == true && iRace == 31 && block_mage > 0) || (IsRaceFrosterBlockedT(RACE_FROSTER) == true && iRace == 32 && block_froster > 0))
		   {
		   format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
		   LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		   LANG_PLAYER,"RACE_WERY_MANY");	
		   cssbColoredPrint(idUser, szMessage);
		   client_cmd(idUser, "changerace");
		   return;
		   }
        }
		
		case (CS_TEAM_CT):
		{
           if ((IsRacePudgeBlockedCT(RACE_PUDGE) == true && iRace == 18 && block_pudge > 0) || (IsRaceAlleryBlockedCT(RACE_ALLERY) == true && iRace == 23 && block_allery > 0) || (IsRaceUndeadBlockedCT(RACE_UNDEAD) == true && iRace == 1 && block_undead > 0) || (IsRaceHumanBlockedCT(RACE_HUMAN) == true && iRace == 2 && block_human > 0) || (IsRaceOrcBlockedCT(RACE_ORC) == true && iRace == 3 && block_orc > 0) 
		   || (IsRaceElfBlockedCT(RACE_ELF) == true && iRace == 4 && block_elf > 0) || (IsRaceBloodBlockedCT(RACE_BLOOD) == true && iRace == 5 && block_blood > 0) || (IsRaceShadowBlockedCT(RACE_SHADOW) == true && iRace == 6 && block_shadow > 0) || (IsRaceWardenBlockedCT(RACE_WARDEN) == true && iRace == 7 && block_warden > 0) || (IsRaceCryptBlockedCT(RACE_CRYPT) == true && iRace == 8 && block_crypt > 0) 
		   || (IsRaceFrostMagBlockedCT(RACE_FROST_MAGE) == true && iRace == 9 && block_frost_mage > 0) || (IsRaceChameleonBlockedCT(RACE_CHAMELEON) == true && iRace == 10 && block_chameleon > 0) || (IsRaceBlackBookBlockedCT(RACE_BLACKBOOK) == true && iRace == 11 && block_blackbook > 0) || (IsRaceDwarfBlockedCT(RACE_DWARF) == true && iRace == 12 && block_dwarf > 0)
		   || (IsRaceNecroBlockedCT(RACE_NECROUMANT) == true && iRace == 13 && block_necroumant > 0) || (IsRaceShamanBlockedCT(RACE_SHAMAN) == true && iRace == 14 && block_shaman > 0)  || (IsRaceAlchemistBlockedCT(RACE_ALCHEMIST) == true && iRace == 15 && block_alchemist > 0) || (IsRaceDEMONICBlockedCT(RACE_DEMONIC) == true && iRace == 16 && block_demonic > 0)
		   || (IsRaceMINOTAVRBlockedCT(RACE_MINOTAVR) == true && iRace == 17 && block_minotavr > 0) || (IsRaceINFERNALBlockedCT(RACE_INFERNAL) == true && iRace == 19 && block_infernal > 0) || (IsRaceSTRAJBlockedCT(RACE_STRAJ) == true && iRace == 20 && block_straj > 0) || (IsRaceSTRELOKBlockedCT(RACE_STRELOK) == true && iRace == 21 && block_strelok > 0)
		   || (IsRaceWATER_MAGEBlockedCT(RACE_WATER_MAGE) == true && iRace == 22 && block_water_mage > 0) || (IsRaceFIREMAGEBlockedCT(RACE_FIREMAGE) == true && iRace == 24 && block_firemage > 0) || (IsRaceDUHWARBlockedCT(RACE_DUHWAR) == true && iRace == 25 && block_duhwar > 0) || (IsRaceKILLERBlockedCT(RACE_KILLER) == true && iRace == 26 && block_killer > 0)
		   || (IsRaceTankerBlockedCT(RACE_TANKER) == true && iRace == 27 && block_tanker > 0) || (IsRaceDragonBlockedCT(RACE_DRAGON) == true && iRace == 28 && block_dragon > 0) || (IsRaceDark_lordBlockedCT(RACE_DARK_LORD) == true && iRace == 29 && block_dark_lord > 0) || (IsRaceAxeBlockedCT(RACE_AXE) == true && iRace == 30 && block_axe > 0)
		   || (IsRaceMageBlockedCT(RACE_MAGE) == true && iRace == 31 && block_mage > 0) || (IsRaceFrosterBlockedCT(RACE_FROSTER) == true && iRace == 32 && block_froster > 0))
		   {
		   format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
		   LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		   LANG_PLAYER,"RACE_WERY_MANY");	
		   cssbColoredPrint(idUser, szMessage);
		   client_cmd(idUser, "changerace");
		   return;
		   }
        }
		}
		}
			
			// Special message for csdm
			if ( CVAR_csdm_active > 0 && get_pcvar_num( CVAR_csdm_active ) == 1 )
			{
			    if( (IsRaceMapsDKBlocked(RACE_DEMONIC) == true && iRace == 16) || (IsRaceMapsFrsBlocked(RACE_FROSTER) == true && iRace == 32) || (IsRaceMapsBlocked(RACE_PUDGE) == true && iRace == 18) || (IsRaceMapsAlleryBlocked(RACE_ALLERY)== true && iRace == 23) )
			    {
			    format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			    LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			    LANG_PLAYER,"RACE_MAPS_BLOCKED");
			    cssbColoredPrint(idUser, szMessage);
				client_cmd(idUser, "changerace");
			    return;
			    }
			    else
			    {
			    format(szMessage, sizeof(szMessage) - 1, "%L",LANG_PLAYER,"CLIENT_PRINT_MENU_CHANGE_RACE");
			    client_print( idUser, print_center,szMessage);
			    }
				
			}	
			else
			{
			    if( (IsRaceMapsDKBlocked(RACE_DEMONIC) == true && iRace == 16) || (IsRaceMapsFrsBlocked(RACE_FROSTER) == true && iRace == 32) || (IsRaceMapsBlocked(RACE_PUDGE) == true && iRace == 18) || (IsRaceMapsAlleryBlocked(RACE_ALLERY)== true && iRace == 23) )
			    {
			    format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			    LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			    LANG_PLAYER,"RACE_MAPS_BLOCKED");	
			    cssbColoredPrint(idUser, szMessage);
				client_cmd(idUser, "changerace");
			    return;
			    }
			    else
			    {
				format(szMessage, sizeof(szMessage) - 1, "%L",LANG_PLAYER,"CENTER_CHANGED_NEXT");
				client_print( idUser, print_center,szMessage);		
               }				
			}
			
			if( ( (IsRaceMapsDKBlocked(RACE_DEMONIC) == true && iRace == 16) || (IsRaceMapsFrsBlocked(RACE_FROSTER) == true && iRace == 32) || IsRaceMapsBlocked(RACE_PUDGE) == true && iRace == 18) || (IsRaceMapsAlleryBlocked(RACE_ALLERY)== true && iRace == 23) )
			    {
			    format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			    LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			    LANG_PLAYER,"RACE_MAPS_BLOCKED");	
			    cssbColoredPrint(idUser, szMessage);
				client_cmd(idUser, "changerace");
			    return;
		   }
            else
		   {
			    p_data[idUser][P_CHANGERACE] = iRace;
		   }
		}

		// Do nothing
		else
		{
			p_data[idUser][P_CHANGERACE] = 0;
		}
	}

	// User doesn't have a race so give it to him!!!
	else
	{
        if(g_on_off_block_race)
		{
		switch (my_team)
		{
		case (CS_TEAM_T):
		{
           if ((IsRacePudgeBlockedT(RACE_PUDGE) == true && iRace == 18 && block_pudge > 0) || (IsRaceAlleryBlockedT(RACE_ALLERY) == true && iRace == 23 && block_allery > 0) || (IsRaceUndeadBlockedT(RACE_UNDEAD) == true && iRace == 1 && block_undead > 0) || (IsRaceHumanBlockedT(RACE_HUMAN) == true && iRace == 2 && block_human > 0) || (IsRaceOrcBlockedT(RACE_ORC) == true && iRace == 3 && block_orc > 0) 
		   || (IsRaceElfBlockedT(RACE_ELF) == true && iRace == 4 && block_elf > 0) || (IsRaceBloodBlockedT(RACE_BLOOD) == true && iRace == 5 && block_blood > 0) || (IsRaceShadowBlockedT(RACE_SHADOW) == true && iRace == 6 && block_shadow > 0) || (IsRaceWardenBlockedT(RACE_WARDEN) == true && iRace == 7 && block_warden > 0) || (IsRaceCryptBlockedT(RACE_CRYPT) == true && iRace == 8 && block_crypt > 0) 
		   || (IsRaceFrostMagBlockedT(RACE_FROST_MAGE) == true && iRace == 9 && block_frost_mage > 0) || (IsRaceChameleonBlockedT(RACE_CHAMELEON) == true && iRace == 10 && block_chameleon > 0) || (IsRaceBlackBookBlockedT(RACE_BLACKBOOK) == true && iRace == 11 && block_blackbook > 0) || (IsRaceDwarfBlockedT(RACE_DWARF) == true && iRace == 12 && block_dwarf > 0) 
		   || (IsRaceNecroBlockedT(RACE_NECROUMANT) == true && iRace == 13 && block_necroumant > 0) || (IsRaceShamanBlockedT(RACE_SHAMAN) == true && iRace == 14 && block_shaman > 0) || (IsRaceAlchemistBlockedT(RACE_ALCHEMIST) == true && iRace == 15 && block_alchemist > 0) || (IsRaceDEMONICBlockedT(RACE_DEMONIC) == true && iRace == 16 && block_demonic > 0)
		   || (IsRaceMINOTAVRBlockedT(RACE_MINOTAVR) == true && iRace == 17 && block_minotavr > 0) || (IsRaceINFERNALBlockedT(RACE_INFERNAL) == true && iRace == 19 && block_infernal > 0) || (IsRaceSTRAJBlockedT(RACE_STRAJ) == true && iRace == 20 && block_straj > 0) || (IsRaceSTRELOKBlockedT(RACE_STRELOK) == true && iRace == 21 && block_strelok > 0)
		   || (IsRaceWATER_MAGEBlockedT(RACE_WATER_MAGE) == true && iRace == 22 && block_water_mage > 0) || (IsRaceFIREMAGEBlockedT(RACE_FIREMAGE) == true && iRace == 24 && block_firemage > 0) || (IsRaceDUHWARBlockedT(RACE_DUHWAR) == true && iRace == 25 && block_duhwar > 0) || (IsRaceKILLERBlockedT(RACE_KILLER) == true && iRace == 26 && block_killer > 0)
		   || (IsRaceTankerBlockedT(RACE_TANKER) == true && iRace == 27 && block_tanker > 0) || (IsRaceDragonBlockedT(RACE_DRAGON) == true && iRace == 28 && block_dragon > 0) || (IsRaceDark_lordBlockedT(RACE_DARK_LORD) == true && iRace == 29 && block_dark_lord > 0) || (IsRaceAxeBlockedT(RACE_AXE) == true && iRace == 30 && block_axe > 0)
		   || (IsRaceMageBlockedT(RACE_MAGE) == true && iRace == 31 && block_mage > 0) || (IsRaceFrosterBlockedT(RACE_FROSTER) == true && iRace == 32 && block_froster > 0))
		   {
		   format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
		   LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		   LANG_PLAYER,"RACE_WERY_MANY");	
		   cssbColoredPrint(idUser, szMessage);
		   client_cmd(idUser, "changerace");
		   return;
		   }
        }
		
		case (CS_TEAM_CT):
		{
           if ((IsRacePudgeBlockedCT(RACE_PUDGE) == true && iRace == 18 && block_pudge > 0) || (IsRaceAlleryBlockedCT(RACE_ALLERY) == true && iRace == 23 && block_allery > 0) || (IsRaceUndeadBlockedCT(RACE_UNDEAD) == true && iRace == 1 && block_undead > 0) || (IsRaceHumanBlockedCT(RACE_HUMAN) == true && iRace == 2 && block_human > 0) || (IsRaceOrcBlockedCT(RACE_ORC) == true && iRace == 3 && block_orc > 0) 
		   || (IsRaceElfBlockedCT(RACE_ELF) == true && iRace == 4 && block_elf > 0) || (IsRaceBloodBlockedCT(RACE_BLOOD) == true && iRace == 5 && block_blood > 0) || (IsRaceShadowBlockedCT(RACE_SHADOW) == true && iRace == 6 && block_shadow > 0) || (IsRaceWardenBlockedCT(RACE_WARDEN) == true && iRace == 7 && block_warden > 0) || (IsRaceCryptBlockedCT(RACE_CRYPT) == true && iRace == 8 && block_crypt > 0)
		   || (IsRaceFrostMagBlockedCT(RACE_FROST_MAGE) == true && iRace == 9 && block_frost_mage > 0) || (IsRaceChameleonBlockedCT(RACE_CHAMELEON) == true && iRace == 10 && block_chameleon > 0) || (IsRaceBlackBookBlockedCT(RACE_BLACKBOOK) == true && iRace == 11 && block_blackbook > 0) || (IsRaceDwarfBlockedCT(RACE_DWARF) == true && iRace == 12 && block_dwarf > 0) 
		   || (IsRaceNecroBlockedCT(RACE_NECROUMANT) == true && iRace == 13 && block_necroumant > 0) || (IsRaceShamanBlockedCT(RACE_SHAMAN) == true && iRace == 14 && block_shaman > 0) || (IsRaceAlchemistBlockedCT(RACE_ALCHEMIST) == true && iRace == 15 && block_alchemist > 0) || (IsRaceDEMONICBlockedCT(RACE_DEMONIC) == true && iRace == 16 && block_demonic > 0)
		   || (IsRaceMINOTAVRBlockedCT(RACE_MINOTAVR) == true && iRace == 17 && block_minotavr > 0) || (IsRaceINFERNALBlockedCT(RACE_INFERNAL) == true && iRace == 19 && block_infernal > 0) || (IsRaceSTRAJBlockedCT(RACE_STRAJ) == true && iRace == 20 && block_straj > 0) || (IsRaceSTRELOKBlockedCT(RACE_STRELOK) == true && iRace == 21 && block_strelok > 0)
		   || (IsRaceWATER_MAGEBlockedCT(RACE_WATER_MAGE) == true && iRace == 22 && block_water_mage > 0) || (IsRaceFIREMAGEBlockedCT(RACE_FIREMAGE) == true && iRace == 24 && block_firemage > 0) || (IsRaceDUHWARBlockedCT(RACE_DUHWAR) == true && iRace == 25 && block_duhwar > 0) || (IsRaceKILLERBlockedCT(RACE_KILLER) == true && iRace == 26 && block_killer > 0)
		   || (IsRaceTankerBlockedCT(RACE_TANKER) == true && iRace == 27 && block_tanker > 0) || (IsRaceDragonBlockedCT(RACE_DRAGON) == true && iRace == 28 && block_dragon > 0) || (IsRaceDark_lordBlockedCT(RACE_DARK_LORD) == true && iRace == 29 && block_dark_lord > 0) || (IsRaceAxeBlockedCT(RACE_AXE) == true && iRace == 30 && block_axe > 0) 
		   || (IsRaceMageBlockedCT(RACE_MAGE) == true && iRace == 31 && block_mage > 0) || (IsRaceFrosterBlockedCT(RACE_FROSTER) == true && iRace == 32 && block_froster > 0))
		   {
		   format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
		   LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		   LANG_PLAYER,"RACE_WERY_MANY");	
		   cssbColoredPrint(idUser, szMessage);
		   client_cmd(idUser, "changerace");
		   return;
		   }
        }
		}
		}
		
        if( (IsRaceMapsDKBlocked(RACE_DEMONIC) == true && iRace == 16) || (IsRaceMapsFrsBlocked(RACE_FROSTER) == true && iRace == 32) || (IsRaceMapsBlocked(RACE_PUDGE) == true && iRace == 18) || (IsRaceMapsAlleryBlocked(RACE_ALLERY)== true && iRace == 23) )
		{
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
		LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
		LANG_PLAYER,"RACE_MAPS_BLOCKED");	
		cssbColoredPrint(idUser, szMessage);
		client_cmd(idUser, "changerace");
		return;
		}
		else
		{
		WC3_SetRace( idUser, iRace );
		}
	}
	
	if( iRace == 18 )
	{
	fPudgeRestart( idUser );
	}
}

//Froster
bool:IsRaceFrosterBlockedT(iRace)
{
	new bool:bIsRaceFrosterBlocked = false;
    new iFrosterCountTeamT = get_race_count_team(RACE_FROSTER,TEAM_T)
	
	if(g_on_off_block_race && block_froster > 0)
	{
	if( (iFrosterCountTeamT >= block_froster) && iRace == 32)
	{
	bIsRaceFrosterBlocked = true;
	}
	}
	
	return bIsRaceFrosterBlocked;
}

bool:IsRaceFrosterBlockedCT(iRace)
{
	new bool:bIsRaceFrosterBlocked = false;
    new iFrosterCountTeamT = get_race_count_team(RACE_FROSTER,TEAM_CT)
	
	if(g_on_off_block_race && block_froster > 0)
	{
	if( (iFrosterCountTeamT >= block_froster) && iRace == 32)
	{
	bIsRaceFrosterBlocked = true;
	}
	}
	
	return bIsRaceFrosterBlocked;
}

//Mage
bool:IsRaceMageBlockedT(iRace)
{
	new bool:bIsRaceMageBlocked = false;
    new iMageCountTeamT = get_race_count_team(RACE_MAGE,TEAM_T)
	
	if(g_on_off_block_race && block_mage > 0)
	{
	if( (iMageCountTeamT >= block_mage) && iRace == 31)
	{
	bIsRaceMageBlocked = true;
	}
	}
	
	return bIsRaceMageBlocked;
}

bool:IsRaceMageBlockedCT(iRace)
{
	new bool:bIsRaceMageBlocked = false;
    new iMageCountTeamT = get_race_count_team(RACE_MAGE,TEAM_CT)
	
	if(g_on_off_block_race && block_mage > 0)
	{
	if( (iMageCountTeamT >= block_mage) && iRace == 31)
	{
	bIsRaceMageBlocked = true;
	}
	}
	
	return bIsRaceMageBlocked;
}

//Axe
bool:IsRaceAxeBlockedT(iRace)
{
	new bool:bIsRaceAxeBlocked = false;
    new iAxeCountTeamT = get_race_count_team(RACE_AXE,TEAM_T)
	
	if(g_on_off_block_race && block_axe > 0)
	{
	if( (iAxeCountTeamT >= block_axe) && iRace == 30)
	{
	bIsRaceAxeBlocked = true;
	}
	}
	
	return bIsRaceAxeBlocked;
}

bool:IsRaceAxeBlockedCT(iRace)
{
	new bool:bIsRaceAxeBlocked = false;
    new iAxeCountTeamT = get_race_count_team(RACE_AXE,TEAM_CT)
	
	if(g_on_off_block_race && block_axe > 0)
	{
	if( (iAxeCountTeamT >= block_axe) && iRace == 30)
	{
	bIsRaceAxeBlocked = true;
	}
	}
	
	return bIsRaceAxeBlocked;
}

//Dark_lord
bool:IsRaceDark_lordBlockedT(iRace)
{
	new bool:bIsRaceDark_lordBlocked = false;
    new iDark_lordCountTeamT = get_race_count_team(RACE_DARK_LORD,TEAM_T)
	
	if(g_on_off_block_race && block_dark_lord > 0)
	{
	if( (iDark_lordCountTeamT >= block_dark_lord) && iRace == 29)
	{
	bIsRaceDark_lordBlocked = true;
	}
	}
	
	return bIsRaceDark_lordBlocked;
}

bool:IsRaceDark_lordBlockedCT(iRace)
{
	new bool:bIsRaceDark_lordBlocked = false;
    new iDark_lordCountTeamT = get_race_count_team(RACE_DARK_LORD,TEAM_CT)
	
	if(g_on_off_block_race && block_dark_lord > 0)
	{
	if( (iDark_lordCountTeamT >= block_dark_lord) && iRace == 29)
	{
	bIsRaceDark_lordBlocked = true;
	}
	}
	
	return bIsRaceDark_lordBlocked;
}

//Dragon
bool:IsRaceDragonBlockedT(iRace)
{
	new bool:bIsRaceDragonBlocked = false;
    new iDragonCountTeamT = get_race_count_team(RACE_DRAGON,TEAM_T)
	
	if(g_on_off_block_race && block_dragon > 0)
	{
	if( (iDragonCountTeamT >= block_dragon) && iRace == 28)
	{
	bIsRaceDragonBlocked = true;
	}
	}
	
	return bIsRaceDragonBlocked;
}

bool:IsRaceDragonBlockedCT(iRace)
{
	new bool:bIsRaceDragonBlocked = false;
    new iDragonCountTeamT = get_race_count_team(RACE_DRAGON,TEAM_CT)
	
	if(g_on_off_block_race && block_dragon > 0)
	{
	if( (iDragonCountTeamT >= block_dragon) && iRace == 28)
	{
	bIsRaceDragonBlocked = true;
	}
	}
	
	return bIsRaceDragonBlocked;
}

//Tanker
bool:IsRaceTankerBlockedT(iRace)
{
	new bool:bIsRaceTankerBlocked = false;
    new iTankerCountTeamT = get_race_count_team(RACE_TANKER,TEAM_T)
	
	if(g_on_off_block_race && block_tanker > 0)
	{
	if( (iTankerCountTeamT >= block_tanker) && iRace == 27)
	{
	bIsRaceTankerBlocked = true;
	}
	}
	
	return bIsRaceTankerBlocked;
}

bool:IsRaceTankerBlockedCT(iRace)
{
	new bool:bIsRaceTankerBlocked = false;
    new iTankerCountTeamT = get_race_count_team(RACE_TANKER,TEAM_CT)
	
	if(g_on_off_block_race && block_tanker > 0)
	{
	if( (iTankerCountTeamT >= block_tanker) && iRace == 27)
	{
	bIsRaceTankerBlocked = true;
	}
	}
	
	return bIsRaceTankerBlocked;
}

//KILLER
bool:IsRaceKILLERBlockedT(iRace)
{
	new bool:bIsRaceKILLERBlocked = false;
    new iKILLERCountTeamT = get_race_count_team(RACE_KILLER,TEAM_T)
	
	if(g_on_off_block_race && block_killer > 0)
	{
	if( (iKILLERCountTeamT >= block_killer) && iRace == 26)
	{
	bIsRaceKILLERBlocked = true;
	}
	}
	
	return bIsRaceKILLERBlocked;
}

bool:IsRaceKILLERBlockedCT(iRace)
{
	new bool:bIsRaceKILLERBlocked = false;
    new iKILLERCountTeamT = get_race_count_team(RACE_KILLER,TEAM_CT)
	
	if(g_on_off_block_race && block_killer > 0)
	{
	if( (iKILLERCountTeamT >= block_killer) && iRace == 26)
	{
	bIsRaceKILLERBlocked = true;
	}
	}
	
	return bIsRaceKILLERBlocked;
}

//DUHWAR
bool:IsRaceDUHWARBlockedT(iRace)
{
	new bool:bIsRaceDUHWARBlocked = false;
    new iDUHWARCountTeamT = get_race_count_team(RACE_DUHWAR,TEAM_T)
	
	if(g_on_off_block_race && block_duhwar > 0)
	{
	if( (iDUHWARCountTeamT >= block_duhwar) && iRace == 25)
	{
	bIsRaceDUHWARBlocked = true;
	}
	}
	
	return bIsRaceDUHWARBlocked;
}

bool:IsRaceDUHWARBlockedCT(iRace)
{
	new bool:bIsRaceDUHWARBlocked = false;
    new iDUHWARCountTeamT = get_race_count_team(RACE_DUHWAR,TEAM_CT)
	
	if(g_on_off_block_race && block_duhwar > 0)
	{
	if( (iDUHWARCountTeamT >= block_duhwar) && iRace == 25)
	{
	bIsRaceDUHWARBlocked = true;
	}
	}
	
	return bIsRaceDUHWARBlocked;
}

//FIREMAGE
bool:IsRaceFIREMAGEBlockedT(iRace)
{
	new bool:bIsRaceFIREMAGEBlocked = false;
    new iFIREMAGECountTeamT = get_race_count_team(RACE_FIREMAGE,TEAM_T)
	
	if(g_on_off_block_race && block_firemage > 0)
	{
	if( (iFIREMAGECountTeamT >= block_firemage) && iRace == 24)
	{
	bIsRaceFIREMAGEBlocked = true;
	}
	}
	
	return bIsRaceFIREMAGEBlocked;
}

bool:IsRaceFIREMAGEBlockedCT(iRace)
{
	new bool:bIsRaceFIREMAGEBlocked = false;
    new iFIREMAGECountTeamT = get_race_count_team(RACE_FIREMAGE,TEAM_CT)
	
	if(g_on_off_block_race && block_firemage > 0)
	{
	if( (iFIREMAGECountTeamT >= block_firemage) && iRace == 24)
	{
	bIsRaceFIREMAGEBlocked = true;
	}
	}
	
	return bIsRaceFIREMAGEBlocked;
}

//WATER_MAGE
bool:IsRaceWATER_MAGEBlockedT(iRace)
{
	new bool:bIsRaceWATER_MAGEBlocked = false;
    new iWATER_MAGECountTeamT = get_race_count_team(RACE_WATER_MAGE,TEAM_T)
	
	if(g_on_off_block_race && block_water_mage > 0)
	{
	if( (iWATER_MAGECountTeamT >= block_water_mage) && iRace == 22)
	{
	bIsRaceWATER_MAGEBlocked = true;
	}
	}
	
	return bIsRaceWATER_MAGEBlocked;
}

bool:IsRaceWATER_MAGEBlockedCT(iRace)
{
	new bool:bIsRaceWATER_MAGEBlocked = false;
    new iWATER_MAGECountTeamT = get_race_count_team(RACE_WATER_MAGE,TEAM_CT)
	
	if(g_on_off_block_race && block_water_mage > 0)
	{
	if( (iWATER_MAGECountTeamT >= block_water_mage) && iRace == 22)
	{
	bIsRaceWATER_MAGEBlocked = true;
	}
	}
	
	return bIsRaceWATER_MAGEBlocked;
}

//STRELOK
bool:IsRaceSTRELOKBlockedT(iRace)
{
	new bool:bIsRaceSTRELOKBlocked = false;
    new iSTRELOKCountTeamT = get_race_count_team(RACE_STRELOK,TEAM_T)
	
	if(g_on_off_block_race && block_strelok > 0)
	{
	if( (iSTRELOKCountTeamT >= block_strelok) && iRace == 21)
	{
	bIsRaceSTRELOKBlocked = true;
	}
	}
	
	return bIsRaceSTRELOKBlocked;
}

bool:IsRaceSTRELOKBlockedCT(iRace)
{
	new bool:bIsRaceSTRELOKBlocked = false;
    new iSTRELOKCountTeamT = get_race_count_team(RACE_STRELOK,TEAM_CT)
	
	if(g_on_off_block_race && block_strelok > 0)
	{
	if( (iSTRELOKCountTeamT >= block_strelok) && iRace == 21)
	{
	bIsRaceSTRELOKBlocked = true;
	}
	}
	
	return bIsRaceSTRELOKBlocked;
}

//STRAJ
bool:IsRaceSTRAJBlockedT(iRace)
{
	new bool:bIsRaceSTRAJBlocked = false;
    new iSTRAJCountTeamT = get_race_count_team(RACE_STRAJ,TEAM_T)
	
	if(g_on_off_block_race && block_straj > 0)
	{
	if( (iSTRAJCountTeamT >= block_straj) && iRace == 20)
	{
	bIsRaceSTRAJBlocked = true;
	}
	}
	
	return bIsRaceSTRAJBlocked;
}

bool:IsRaceSTRAJBlockedCT(iRace)
{
	new bool:bIsRaceSTRAJBlocked = false;
    new iSTRAJCountTeamT = get_race_count_team(RACE_STRAJ,TEAM_CT)
	
	if(g_on_off_block_race && block_straj > 0)
	{
	if( (iSTRAJCountTeamT >= block_straj) && iRace == 20)
	{
	bIsRaceSTRAJBlocked = true;
	}
	}
	
	return bIsRaceSTRAJBlocked;
}

//INFERNAL
bool:IsRaceINFERNALBlockedT(iRace)
{
	new bool:bIsRaceINFERNALBlocked = false;
    new iINFERNALCountTeamT = get_race_count_team(RACE_INFERNAL,TEAM_T)
	
	if(g_on_off_block_race && block_infernal > 0)
	{
	if( (iINFERNALCountTeamT >= block_infernal) && iRace == 19)
	{
	bIsRaceINFERNALBlocked = true;
	}
	}
	
	return bIsRaceINFERNALBlocked;
}

bool:IsRaceINFERNALBlockedCT(iRace)
{
	new bool:bIsRaceINFERNALBlocked = false;
    new iINFERNALCountTeamT = get_race_count_team(RACE_INFERNAL,TEAM_CT)
	
	if(g_on_off_block_race && block_infernal > 0)
	{
	if( (iINFERNALCountTeamT >= block_infernal) && iRace == 19)
	{
	bIsRaceINFERNALBlocked = true;
	}
	}
	
	return bIsRaceINFERNALBlocked;
}

//MINOTAVR
bool:IsRaceMINOTAVRBlockedT(iRace)
{
	new bool:bIsRaceMINOTAVRBlocked = false;
    new iMINOTAVRCountTeamT = get_race_count_team(RACE_MINOTAVR,TEAM_T)
	
	if(g_on_off_block_race && block_minotavr > 0)
	{
	if( (iMINOTAVRCountTeamT >= block_minotavr) && iRace == 17)
	{
	bIsRaceMINOTAVRBlocked = true;
	}
	}
	
	return bIsRaceMINOTAVRBlocked;
}

bool:IsRaceMINOTAVRBlockedCT(iRace)
{
	new bool:bIsRaceMINOTAVRBlocked = false;
    new iMINOTAVRCountTeamT = get_race_count_team(RACE_MINOTAVR,TEAM_CT)
	
	if(g_on_off_block_race && block_minotavr > 0)
	{
	if( (iMINOTAVRCountTeamT >= block_minotavr) && iRace == 17)
	{
	bIsRaceMINOTAVRBlocked = true;
	}
	}
	
	return bIsRaceMINOTAVRBlocked;
}

//DEMONIC
bool:IsRaceDEMONICBlockedT(iRace)
{
	new bool:bIsRaceDEMONICBlocked = false;
    new iDEMONICCountTeamT = get_race_count_team(RACE_DEMONIC,TEAM_T)
	
	if(g_on_off_block_race && block_demonic > 0)
	{
	if( (iDEMONICCountTeamT >= block_demonic) && iRace == 16)
	{
	bIsRaceDEMONICBlocked = true;
	}
	}
	
	return bIsRaceDEMONICBlocked;
}

bool:IsRaceDEMONICBlockedCT(iRace)
{
	new bool:bIsRaceDEMONICBlocked = false;
    new iDEMONICCountTeamT = get_race_count_team(RACE_DEMONIC,TEAM_CT)
	
	if(g_on_off_block_race && block_demonic > 0)
	{
	if( (iDEMONICCountTeamT >= block_demonic) && iRace == 16)
	{
	bIsRaceDEMONICBlocked = true;
	}
	}
	
	return bIsRaceDEMONICBlocked;
}

//Alchemist
bool:IsRaceAlchemistBlockedT(iRace)
{
	new bool:bIsRaceAlchemistBlocked = false;
    new iAlchemistCountTeamT = get_race_count_team(RACE_ALCHEMIST,TEAM_T)
	
	if(g_on_off_block_race && block_alchemist > 0)
	{
	if( (iAlchemistCountTeamT >= block_alchemist) && iRace == 15)
	{
	bIsRaceAlchemistBlocked = true;
	}
	}
	
	return bIsRaceAlchemistBlocked;
}

bool:IsRaceAlchemistBlockedCT(iRace)
{
	new bool:bIsRaceAlchemistBlocked = false;
    new iAlchemistCountTeamT = get_race_count_team(RACE_ALCHEMIST,TEAM_CT)
	
	if(g_on_off_block_race && block_alchemist > 0)
	{
	if( (iAlchemistCountTeamT >= block_alchemist) && iRace == 15)
	{
	bIsRaceAlchemistBlocked = true;
	}
	}
	
	return bIsRaceAlchemistBlocked;
}

//Shaman
bool:IsRaceShamanBlockedT(iRace)
{
	new bool:bIsRaceShamanBlocked = false;
    new iShamanCountTeamT = get_race_count_team(RACE_SHAMAN,TEAM_T)
	
	if(g_on_off_block_race && block_shaman > 0)
	{
	if( (iShamanCountTeamT >= block_shaman) && iRace == 14)
	{
	bIsRaceShamanBlocked = true;
	}
	}
	
	return bIsRaceShamanBlocked;
}

bool:IsRaceShamanBlockedCT(iRace)
{
	new bool:bIsRaceShamanBlocked = false;
    new iShamanCountTeamT = get_race_count_team(RACE_SHAMAN,TEAM_CT)
	
	if(g_on_off_block_race && block_shaman > 0)
	{
	if( (iShamanCountTeamT >= block_shaman) && iRace == 14)
	{
	bIsRaceShamanBlocked = true;
	}
	}
	
	return bIsRaceShamanBlocked;
}

//Necro
bool:IsRaceNecroBlockedT(iRace)
{
	new bool:bIsRaceNecroBlocked = false;
    new iNecroCountTeamT = get_race_count_team(RACE_NECROUMANT,TEAM_T)
	
	if(g_on_off_block_race && block_necroumant > 0)
	{
	if( (iNecroCountTeamT >= block_necroumant) && iRace == 13)
	{
	bIsRaceNecroBlocked = true;
	}
	}
	
	return bIsRaceNecroBlocked;
}

bool:IsRaceNecroBlockedCT(iRace)
{
	new bool:bIsRaceNecroBlocked = false;
    new iNecroCountTeamT = get_race_count_team(RACE_NECROUMANT,TEAM_CT)
	
	if(g_on_off_block_race && block_necroumant > 0)
	{
	if( (iNecroCountTeamT >= block_necroumant) && iRace == 13)
	{
	bIsRaceNecroBlocked = true;
	}
	}
	
	return bIsRaceNecroBlocked;
}

//Dwarf
bool:IsRaceDwarfBlockedT(iRace)
{
	new bool:bIsRaceDwarfBlocked = false;
    new iDwarfCountTeamT = get_race_count_team(RACE_DWARF,TEAM_T)
	
	if(g_on_off_block_race && block_dwarf > 0)
	{
	if( (iDwarfCountTeamT >= block_dwarf) && iRace == 12)
	{
	bIsRaceDwarfBlocked = true;
	}
	}
	
	return bIsRaceDwarfBlocked;
}

bool:IsRaceDwarfBlockedCT(iRace)
{
	new bool:bIsRaceDwarfBlocked = false;
    new iDwarfCountTeamT = get_race_count_team(RACE_DWARF,TEAM_CT)
	
	if(g_on_off_block_race && block_dwarf > 0)
	{
	if( (iDwarfCountTeamT >= block_dwarf) && iRace == 12)
	{
	bIsRaceDwarfBlocked = true;
	}
	}
	
	return bIsRaceDwarfBlocked;
}

//BlackBook
bool:IsRaceBlackBookBlockedT(iRace)
{
	new bool:bIsRaceBlackBookBlocked = false;
    new iBlackBookCountTeamT = get_race_count_team(RACE_BLACKBOOK,TEAM_T)
	
	if(g_on_off_block_race && block_blackbook > 0)
	{
	if( (iBlackBookCountTeamT >= block_blackbook) && iRace == 11)
	{
	bIsRaceBlackBookBlocked = true;
	}
	}
	
	return bIsRaceBlackBookBlocked;
}

bool:IsRaceBlackBookBlockedCT(iRace)
{
	new bool:bIsRaceBlackBookBlocked = false;
    new iBlackBookCountTeamT = get_race_count_team(RACE_BLACKBOOK,TEAM_CT)
	
	if(g_on_off_block_race && block_blackbook > 0)
	{
	if( (iBlackBookCountTeamT >= block_blackbook) && iRace == 11)
	{
	bIsRaceBlackBookBlocked = true;
	}
	}
	
	return bIsRaceBlackBookBlocked;
}

//Chameleon
bool:IsRaceChameleonBlockedT(iRace)
{
	new bool:bIsRaceChameleonBlocked = false;
    new iChameleonCountTeamT = get_race_count_team(RACE_CHAMELEON,TEAM_T)
	
	if(g_on_off_block_race && block_chameleon > 0)
	{
	if( (iChameleonCountTeamT >= block_chameleon) && iRace == 10)
	{
	bIsRaceChameleonBlocked = true;
	}
	}
	
	return bIsRaceChameleonBlocked;
}

bool:IsRaceChameleonBlockedCT(iRace)
{
	new bool:bIsRaceChameleonBlocked = false;
    new iChameleonCountTeamT = get_race_count_team(RACE_CHAMELEON,TEAM_CT)
	
	if(g_on_off_block_race && block_chameleon > 0)
	{
	if( (iChameleonCountTeamT >= block_chameleon) && iRace == 10)
	{
	bIsRaceChameleonBlocked = true;
	}
	}
	
	return bIsRaceChameleonBlocked;
}

//FrostMag
bool:IsRaceFrostMagBlockedT(iRace)
{
	new bool:bIsRaceFrostMagBlocked = false;
    new iFrostMagCountTeamT = get_race_count_team(RACE_FROST_MAGE,TEAM_T)
	
	if(g_on_off_block_race && block_frost_mage > 0)
	{
	if( (iFrostMagCountTeamT >= block_frost_mage) && iRace == 9)
	{
	bIsRaceFrostMagBlocked = true;
	}
	}
	
	return bIsRaceFrostMagBlocked;
}

bool:IsRaceFrostMagBlockedCT(iRace)
{
	new bool:bIsRaceFrostMagBlocked = false;
    new iFrostMagCountTeamT = get_race_count_team(RACE_FROST_MAGE,TEAM_CT)
	
	if(g_on_off_block_race && block_frost_mage > 0)
	{
	if( (iFrostMagCountTeamT >= block_frost_mage) && iRace == 9)
	{
	bIsRaceFrostMagBlocked = true;
	}
	}
	
	return bIsRaceFrostMagBlocked;
}

//Crypt
bool:IsRaceCryptBlockedT(iRace)
{
	new bool:bIsRaceCryptBlocked = false;
    new iCryptCountTeamT = get_race_count_team(RACE_CRYPT,TEAM_T)
	
	if(g_on_off_block_race && block_crypt > 0)
	{
	if( (iCryptCountTeamT >= block_crypt) && iRace == 8)
	{
	bIsRaceCryptBlocked = true;
	}
	}
	
	return bIsRaceCryptBlocked;
}

bool:IsRaceCryptBlockedCT(iRace)
{
	new bool:bIsRaceCryptBlocked = false;
    new iCryptCountTeamT = get_race_count_team(RACE_CRYPT,TEAM_CT)
	
	if(g_on_off_block_race && block_crypt > 0)
	{
	if( (iCryptCountTeamT >= block_crypt) && iRace == 8)
	{
	bIsRaceCryptBlocked = true;
	}
	}
	
	return bIsRaceCryptBlocked;
}

//Warden
bool:IsRaceWardenBlockedT(iRace)
{
	new bool:bIsRaceWardenBlocked = false;
    new iWardenCountTeamT = get_race_count_team(RACE_WARDEN,TEAM_T)
	
	if(g_on_off_block_race && block_warden > 0)
	{
	if( (iWardenCountTeamT >= block_warden) && iRace == 7)
	{
	bIsRaceWardenBlocked = true;
	}
	}
	
	return bIsRaceWardenBlocked;
}

bool:IsRaceWardenBlockedCT(iRace)
{
	new bool:bIsRaceWardenBlocked = false;
    new iWardenCountTeamT = get_race_count_team(RACE_WARDEN,TEAM_CT)
	
	if(g_on_off_block_race && block_warden > 0)
	{
	if( (iWardenCountTeamT >= block_warden) && iRace == 7)
	{
	bIsRaceWardenBlocked = true;
	}
	}
	
	return bIsRaceWardenBlocked;
}

bool:IsRaceMapsBlocked(iRace)
{
    new bool:bIsRacePudgeBlocked = false;
	
	if( g_PudgeDisabled == true && iRace == 18)
	{
	bIsRacePudgeBlocked = true;
	}
	
	return bIsRacePudgeBlocked;
}

bool:IsRaceMapsFrsBlocked(iRace)
{
    new bool:bIsRaceFrosterBlocked = false;
	
	if( g_FrosterDisabled == true && iRace == 32)
	{
	bIsRaceFrosterBlocked = true;
	}
	
	return bIsRaceFrosterBlocked;
}

bool:IsRaceMapsDKBlocked(iRace)
{
    new bool:bIsRaceDKBlocked = false;
	
	if( g_d_DKnight == true && iRace == 16)
	{
	bIsRaceDKBlocked = true;
	}
	
	return bIsRaceDKBlocked;
}

bool:IsRaceMapsAlleryBlocked(iRace)
{
    new bool:bIsRacePudgeBlocked = false;
	
	if( g_AlleryDisabled == true && iRace == 23)
	{
	bIsRacePudgeBlocked = true;
	}
	
	return bIsRacePudgeBlocked;
}

//undead
bool:IsRaceUndeadBlockedT(iRace)
{
	new bool:bIsRaceUndeadBlocked = false;
    new iUndeadCountTeamT = get_race_count_team(RACE_UNDEAD,TEAM_T)
	
	if(g_on_off_block_race && block_undead > 0)
	{
	if( (iUndeadCountTeamT >= block_undead) && iRace == 1)
	{
	bIsRaceUndeadBlocked = true;
	}
	}
	
	return bIsRaceUndeadBlocked;
}

bool:IsRaceUndeadBlockedCT(iRace)
{
	new bool:bIsRaceUndeadBlocked = false;
    new iUndeadCountTeamT = get_race_count_team(RACE_UNDEAD,TEAM_CT)
	
	if(g_on_off_block_race && block_undead > 0)
	{
	if( (iUndeadCountTeamT >= block_undead) && iRace == 1)
	{
	bIsRaceUndeadBlocked = true;
	}
	}
	
	return bIsRaceUndeadBlocked;
}

//human
bool:IsRaceHumanBlockedT(iRace)
{
	new bool:bIsRaceHumanBlocked = false;
    new iHumanCountTeamT = get_race_count_team(RACE_HUMAN,TEAM_T)
	
	if(g_on_off_block_race && block_human > 0)
	{
	if( (iHumanCountTeamT >= block_human) && iRace == 2)
	{
	bIsRaceHumanBlocked = true;
	}
	}
	
	return bIsRaceHumanBlocked;
}

bool:IsRaceHumanBlockedCT(iRace)
{
	new bool:bIsRaceHumanBlocked = false;
    new iHumanCountTeamT = get_race_count_team(RACE_HUMAN,TEAM_CT)
	
	if(g_on_off_block_race && block_human > 0)
	{
	if( (iHumanCountTeamT >= block_human) && iRace == 2)
	{
	bIsRaceHumanBlocked = true;
	}
	}
	
	return bIsRaceHumanBlocked;
}

//orc
bool:IsRaceOrcBlockedT(iRace)
{
	new bool:bIsRaceOrcBlocked = false;
    new iOrcCountTeamT = get_race_count_team(RACE_ORC,TEAM_T)
	
	if(g_on_off_block_race && block_orc > 0)
	{
	if( (iOrcCountTeamT >= block_orc) && iRace == 3)
	{
	bIsRaceOrcBlocked = true;
	}
	}
	
	return bIsRaceOrcBlocked;
}

bool:IsRaceOrcBlockedCT(iRace)
{
	new bool:bIsRaceOrcBlocked = false;
    new iOrcCountTeamT = get_race_count_team(RACE_ORC,TEAM_CT)
	
	if(g_on_off_block_race && block_orc > 0)
	{
	if( (iOrcCountTeamT >= block_orc) && iRace == 3)
	{
	bIsRaceOrcBlocked = true;
	}
	}
	
	return bIsRaceOrcBlocked;
}

//elf
bool:IsRaceElfBlockedT(iRace)
{
	new bool:bIsRaceelfBlocked = false;
    new ielfCountTeamT = get_race_count_team(RACE_ELF,TEAM_T)
	
	if(g_on_off_block_race && block_elf > 0)
	{
	if( (ielfCountTeamT >= block_elf) && iRace == 4)
	{
	bIsRaceelfBlocked = true;
	}
	}
	
	return bIsRaceelfBlocked;
}

bool:IsRaceElfBlockedCT(iRace)
{
	new bool:bIsRaceelfBlocked = false;
    new ielfCountTeamT = get_race_count_team(RACE_ELF,TEAM_CT)
	
	if(g_on_off_block_race && block_elf > 0)
	{
	if( (ielfCountTeamT >= block_elf) && iRace == 4)
	{
	bIsRaceelfBlocked = true;
	}
	}
	
	return bIsRaceelfBlocked;
}

//blood
bool:IsRaceBloodBlockedT(iRace)
{
	new bool:bIsRaceBloodBlocked = false;
    new iBloodCountTeamT = get_race_count_team(RACE_BLOOD,TEAM_T)
	
	if(g_on_off_block_race && block_blood > 0)
	{
	if( (iBloodCountTeamT >= block_blood) && iRace == 5)
	{
	bIsRaceBloodBlocked = true;
	}
	}
	
	return bIsRaceBloodBlocked;
}

bool:IsRaceBloodBlockedCT(iRace)
{
	new bool:bIsRaceBloodBlocked = false;
    new iBloodCountTeamT = get_race_count_team(RACE_BLOOD,TEAM_CT)
	
	if(g_on_off_block_race && block_blood > 0)
	{
	if( (iBloodCountTeamT >= block_blood) && iRace == 5)
	{
	bIsRaceBloodBlocked = true;
	}
	}
	
	return bIsRaceBloodBlocked;
}

//Shadow
bool:IsRaceShadowBlockedT(iRace)
{
	new bool:bIsRaceShadowBlocked = false;
    new iShadowCountTeamT = get_race_count_team(RACE_SHADOW,TEAM_T)
	
	if(g_on_off_block_race && block_shadow > 0)
	{
	if( (iShadowCountTeamT >= block_shadow) && iRace == 6)
	{
	bIsRaceShadowBlocked = true;
	}
	}
	
	return bIsRaceShadowBlocked;
}

bool:IsRaceShadowBlockedCT(iRace)
{
	new bool:bIsRaceShadowBlocked = false;
    new iShadowCountTeamT = get_race_count_team(RACE_SHADOW,TEAM_CT)
	
	if(g_on_off_block_race && block_shadow > 0)
	{
	if( (iShadowCountTeamT >= block_shadow) && iRace == 6)
	{
	bIsRaceShadowBlocked = true;
	}
	}
	
	return bIsRaceShadowBlocked;
}

//Pudge & Allery
bool:IsRacePudgeBlockedT(iRace)
{
    new bool:bIsRacePudgeBlocked = false;
    new iPudgeCountTeamT = get_race_count_team(RACE_PUDGE,TEAM_T)
	
	if( (iPudgeCountTeamT >= block_pudge) && iRace == 18)
	{
	bIsRacePudgeBlocked = true;
	}
	
	return bIsRacePudgeBlocked;
}

bool:IsRaceAlleryBlockedT(iRace)
{
    new bool:bIsRaceAlleryBlocked = false;
    new iAlleryCountTeamT = get_race_count_team(RACE_ALLERY,TEAM_T)
	
	if( (iAlleryCountTeamT >= block_allery) && iRace == 23)
	{
	bIsRaceAlleryBlocked = true;
	}
	
	return bIsRaceAlleryBlocked;
}

bool:IsRaceAlleryBlockedCT(iRace)
{
    new bool:bIsRaceAlleryBlocked = false;
	new iAlleryCountTeamCT = get_race_count_team(RACE_ALLERY,TEAM_CT)
	
	if( (iAlleryCountTeamCT >= block_allery) && iRace == 23)
	{
	bIsRaceAlleryBlocked = true;
	}
	
	return bIsRaceAlleryBlocked;
}

bool:IsRacePudgeBlockedCT(iRace)
{
    new bool:bIsRacePudgeBlocked = false;
	new iPudgeCountTeamCT = get_race_count_team(RACE_PUDGE,TEAM_CT)
	
	if( (iPudgeCountTeamCT >= block_pudge) && iRace == 18)
	{
	bIsRacePudgeBlocked = true;
	}
	
	return bIsRacePudgeBlocked;
}

//       (     )
public fSelectKeyMenu(idUser,iMenuID)
{
	switch (iMenuID)
	{
		case RACE_UNDEAD: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_UNDEAD) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_HUMAN: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_HUMAN) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_ORC: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_ORC) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_ELF: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_ELF) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_BLOOD: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_BLOOD) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_SHADOW: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_SHADOW) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_WARDEN: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_WARDEN) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_CRYPT: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_CRYPT) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_CHAMELEON: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_CHAMELEON) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_FROST_MAGE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_FROST_MAGE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_TANKER: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_TANKER) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_DEMONIC: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_DEMONIC) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_NECROUMANT: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_NECROUMANT) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_INFERNAL: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_INFERNAL) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_DWARF: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_DWARF) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_FIREMAGE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_FIREMAGE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_WATER_MAGE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_WATER_MAGE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_DUHWAR: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_DUHWAR) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_KILLER: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_KILLER) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_STRAJ: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_STRAJ) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_BLACKBOOK: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_BLACKBOOK) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_SHAMAN: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_SHAMAN) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_ALCHEMIST: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_ALCHEMIST) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_MINOTAVR: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_MINOTAVR) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_STRELOK: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_STRELOK) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_DRAGON: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_DRAGON) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_AXE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_AXE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_DARK_LORD: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_DARK_LORD) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_MAGE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_MAGE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_PUDGE: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_PUDGE) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_ALLERY: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_ALLERY) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_FROSTER: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_FROSTER) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_TECHIES: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_TECHIES) == false)
				fSelectRace(idUser,iMenuID);
		}
		case RACE_ZEUS: //V.I.P.
		{
			if(isPlayerSelectRaceVIP(idUser,RACE_ZEUS) == false)
				fSelectRace(idUser,iMenuID);
		}
		case MENU_ID_RACE_DEFAULT:
		{
			DB_GetAllXP( idUser,MENU_ID_RACE_DEFAULT );
		}
		case MENU_ID_RACE_VIPS:
		{
			DB_GetAllXP( idUser,MENU_ID_RACE_VIPS );
		}
		case MENU_ID_RACE_THREE:
		{
			DB_GetAllXP( idUser,MENU_ID_RACE_THREE );
		}
	}//switch
	
}

//   VIP  
bool:isPlayerSelectRaceVIP(idUser,iRaceVip)
{
	new szRaceName[64];
	lang_GetRaceName(iRaceVip, idUser, szRaceName, 63 );

	new bool:bIsPlayerVIP = false;
	
	if(g_iRace_Active[iRaceVip]) 
	{ 
		format(szMessage, sizeof(szMessage) - 1, "^x01%L^x03%L^x01%L ^x04%L",
			LANG_PLAYER,"WC3_BRACKET_LEFT",LANG_PLAYER,"WC3_MODCLIENT",LANG_PLAYER,"WC3_BRACKET_RIGHT",
			LANG_PLAYER,"WC3_RACE_DISABLE");	
			
		cssbColoredPrint(idUser, szMessage);
		bIsPlayerVIP = true;
	}

	switch(iRaceVip)
	{
		case RACE_UNDEAD: //V.I.P.
		{
			if(vip_r_undead == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_UNDEAD)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_undead, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_HUMAN: //V.I.P.
		{
			if(vip_r_human == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_HUMAN)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_human, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_ORC: //V.I.P.
		{
			if(vip_r_orc == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_ORC)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_orc, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_ELF: //V.I.P.
		{
			if(vip_r_elf == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_ELF)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_elf, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_BLOOD: //V.I.P.
		{
			if(vip_r_blood == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_BLOOD)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_blood, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_SHADOW: //V.I.P.
		{
			if(vip_r_shadow == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_SHADOW)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_shadow, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_WARDEN: //V.I.P.
		{
			if(vip_r_warden == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_WARDEN)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_warden, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_CRYPT: //V.I.P.
		{
			if(vip_r_crypt == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_CRYPT)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_crypt, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		
		case RACE_CHAMELEON: //V.I.P.
		{
			if(vip_r_chameleon == 1)
			{
			   if(!p_data_flags[idUser][10])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_chameleon, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_FROST_MAGE: //V.I.P.
		{
			if(vip_r_frost_mage == 1)
			{
			   if(!(get_user_flags(idUser) & VipRaceFlags(RACE_FROST_MAGE)))
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_frost_mage, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}

		}
		case RACE_TANKER: //V.I.P.
		{
			if(vip_r_tanker == 1)
			{
			   if(!p_data_flags[idUser][27])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_tanker, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_DEMONIC: //V.I.P.
		{
			if(vip_r_demonic == 1)
			{
			   if(!p_data_flags[idUser][16])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_demonic, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_NECROUMANT: //V.I.P.
		{
			if(vip_r_necroumant == 1)
			{
			   if(!p_data_flags[idUser][13])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_necroumant, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_INFERNAL: //V.I.P.
		{
			if(vip_r_infernal == 1)
			{
			   if(!p_data_flags[idUser][13])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_infernal, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_DWARF: //V.I.P.
		{
			if(vip_r_dwarf == 1)
			{
				if(!p_data_flags[idUser][12])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_dwarf, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_FIREMAGE: //V.I.P.
		{
			if(vip_r_firemage == 1)
			{
			   if(!p_data_flags[idUser][24])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_firemage, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_WATER_MAGE: //V.I.P.
		{
			if(vip_r_water_mage == 1)
			{
			   if(!p_data_flags[idUser][22])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_water_mage, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_DUHWAR: //V.I.P.
		{
			if(vip_r_duhwar == 1)
			{
			   if(!p_data_flags[idUser][25])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_duhwar, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_KILLER: //V.I.P.
		{
			if(vip_r_killer == 1)
			{
			   if(!p_data_flags[idUser][26])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_killer, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_STRAJ: //V.I.P.
		{
			if(vip_r_straj == 1)
			{
			   if(!p_data_flags[idUser][20])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_straj, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_BLACKBOOK: //V.I.P.
		{
			if(vip_r_blackbook == 1)
			{
			   if(!p_data_flags[idUser][11])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_blackbook, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}

		}
		case RACE_SHAMAN: //V.I.P.
		{
			if(vip_r_shaman == 1)
			{
			   if(!p_data_flags[idUser][14])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_shaman, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_ALCHEMIST: //V.I.P.
		{
			if(vip_r_alchemist == 1)
			{
			   if(!p_data_flags[idUser][15])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_alchemist, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_MINOTAVR: //V.I.P.
		{
			if(vip_r_minotavr == 1)
			{
			   if(!p_data_flags[idUser][17])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_minotavr, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_STRELOK: //V.I.P.
		{
			if(vip_r_strelok == 1)
			{
			   if(!p_data_flags[idUser][21])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_strelok, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_DRAGON: //V.I.P.
		{
			if(vip_r_dragon == 1)
			{
			   if(!p_data_flags[idUser][28])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_dragon, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_AXE: //V.I.P.
		{
			if(vip_r_axe == 1)
			{
			   if(!p_data_flags[idUser][30])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_axe, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_DARK_LORD: //V.I.P.
		{
			if(vip_r_dark_lord == 1)
			{
			   if(!p_data_flags[idUser][29])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_dark_lord, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_MAGE: //V.I.P.
		{
			if(vip_r_mage == 1)
			{
			   if(!p_data_flags[idUser][31])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_mage, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_PUDGE: //V.I.P.
		{
			if(vip_r_pudge == 1)
			{
			   if(!p_data_flags[idUser][18])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_pudge, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_ALLERY: //V.I.P.
		{
			if(vip_r_allery == 1)
			{
			   if(!p_data_flags[idUser][23])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_allery, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_FROSTER: //V.I.P.
		{
			if(vip_r_froster == 1)
			{
			   if(!p_data_flags[idUser][32])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_froster, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_TECHIES: //V.I.P.
		{
			if(vip_r_techies == 1)
			{
			   if(!p_data_flags[idUser][33])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_techies, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
		case RACE_ZEUS: //V.I.P.
		{
			if(vip_r_zeus == 1)
			{
			   if(!p_data_flags[idUser][34])
			   {
					if(g_on_off_motd_vip_race == 1)
					{
					show_motd(idUser, motd_vip_r_zeus, szRaceName);
					}
					bIsPlayerVIP = true;
			   }
			}
		}
	}

	if(bIsPlayerVIP == true && !g_iRace_Active[iRaceVip])
	{
		formatex(szMessage, sizeof(szMessage) - 1, "%L",LANG_PLAYER,"YOU_HAVE_NO_ACCESS");	
		client_print( idUser, print_console,szMessage);
		cssbChatColor(idUser,"%s%s",fTagWar3ft(),szMessage);
					
		WC3_ChangeRaceStart(idUser);
	}


	return bIsPlayerVIP;
}


//=============================================================================
//=============================================================================
//=============================================================================
//----------------- -----------------------------------------------END }


//-----------------   -----------------------BEGIN {
//      		
public _Callback_MENU_SelectRace(idUser,iKey)
{
	if ( !WC3_Check() )
		return PLUGIN_HANDLED;

	if(iKey == 9) //
		return PLUGIN_HANDLED;

	fSelectKeyMenu(idUser,LIST_ITEM_SELECT_RACE[iKey]);
	
	return PLUGIN_HANDLED;
}
//      
public _Callback_SUB_MENU_ID_Default(idUser,iKey)
{
	if ( !WC3_Check() )
		return PLUGIN_HANDLED;

//	client_print(idUser,print_chat,"iKey: %d",iKey);

	if(iKey == 9) //
	{
        new iRaceXP[MAX_RACES],iRaceXP2[MAX_RACES];
		fBuildMenu(idUser,"MENU_SELECT_RACE",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_SELECT_RACE,LIST_ITEM_SELECT_RACE,MENU_ID_DEFAULT);
		return PLUGIN_HANDLED;
	}

	fSelectKeyMenu(idUser,LIST_ITEM_RACE_DEFAULT[iKey]);

	return PLUGIN_HANDLED;
}

//      VIP 
public _Callback_SUB_MENU_ID_VIPs(idUser,iKey)
{
	if ( !WC3_Check() )
		return PLUGIN_HANDLED;

	if(iKey == 9) //
	{
        new iRaceXP[MAX_RACES],iRaceXP2[MAX_RACES];
		fBuildMenu(idUser,"MENU_SELECT_RACE",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_SELECT_RACE,LIST_ITEM_SELECT_RACE,MENU_ID_DEFAULT);
		return PLUGIN_HANDLED;
	}

	fSelectKeyMenu(idUser,LIST_ITEM_RACE_VIPS[iKey]);

	return PLUGIN_HANDLED;
}

//      VIP 
public _Callback_SUB_MENU_ID_THREE(idUser,iKey)
{
	if ( !WC3_Check() )
		return PLUGIN_HANDLED;

	if(iKey == 9) //
	{
        new iRaceXP[MAX_RACES],iRaceXP2[MAX_RACES];
		fBuildMenu(idUser,"MENU_SELECT_RACE",iRaceXP,iRaceXP2,MAX_ITEM_LIST_ITEM_SELECT_RACE,LIST_ITEM_SELECT_RACE,MENU_ID_DEFAULT);
		return PLUGIN_HANDLED;
	}

	fSelectKeyMenu(idUser,LIST_ITEM_RACE_THREE[iKey]);

	return PLUGIN_HANDLED;
}
