new ARCHER_ARROW_DAMAGE_PLUS = 50;
new Float:BOW_ULTIMATE_SPEED = 0.7;
new Float:ARCHER_ULTIMATE_FREEZE_TIME = 5.0;
new Float:ARCHER_FLIGHT_DURATION = 7.0;

new mass_bow[33];
new mass_spd[33];
new mass_inv[33];

public on_Bow(idUser)
{
	if (!is_user_alive(idUser) || !is_user_connected(idUser))
		return PLUGIN_HANDLED

	if (p_data[idUser][P_RACE] != RACE_ALLERY)
		return PLUGIN_CONTINUE

	if (is_user_alive(idUser) && is_user_connected(idUser))
	{
		if (get_user_weapon(idUser) == CSW_KNIFE && p_data[idUser][P_RACE] == RACE_ALLERY)
		{
			if (!mass_bow[idUser])
			{
				mass_bow[idUser] = true
				set_pev(idUser, pev_viewmodel2, szModel_V_ALLERY)
				set_pev(idUser, pev_weaponmodel2, szModel_P_ALLERY)
				UTIL_PlayWeaponAnimation(idUser, 3)
				return PLUGIN_HANDLED
			}
			else if (mass_bow[idUser])
			{
				mass_bow[idUser] = false
				set_pev(idUser, pev_viewmodel2, szModelal_V)
				set_pev(idUser, pev_weaponmodel2, szModelal_P)
				UTIL_PlayWeaponAnimation(idUser, 3)
				return PLUGIN_HANDLED
			}
		}

		if (p_data[idUser][P_RACE] != RACE_ALLERY)
		{
			mass_bow[idUser] = false
		}

	}
	return PLUGIN_CONTINUE
}

public fwTraceAttack_b(victim, attacker, Float:damage, Float:direction[3], tracehandle, damage_type)
{
	if(!is_user_alive(attacker) || !is_user_connected(attacker))
		return HAM_IGNORED;
	
	if (get_user_weapon(attacker) == CSW_KNIFE && mass_bow[attacker] && p_data[attacker][P_RACE] == RACE_ALLERY)
	{
		return HAM_SUPERCEDE;
	}
	
	return HAM_IGNORED;
}

public fwd_bow_d(id, channel, const sound[])
{	
	if (!is_user_alive(id) || !is_user_connected(id))
		return FMRES_IGNORED;
	
	for(new i = 0; i < sizeof oldknife_sounds; i++)
	{
		if(equal(sound, oldknife_sounds[i]))
		{
			if (mass_bow[id] && get_user_weapon(id) == CSW_KNIFE && p_data[id][P_RACE] == RACE_ALLERY)
			{
				return FMRES_SUPERCEDE
			}
		}
	}
	return FMRES_IGNORED
}

public fw_crossbow_PrimaryAttack_Post(Weapon)
{
	if(!pev_valid(Weapon))
       return HAM_IGNORED
	   
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if(!is_user_connected(Player))
       return HAM_IGNORED
	
	if(p_data[Player][P_RACE] == RACE_ALLERY && mass_bow[Player])
	{
		UTIL_PlayWeaponAnimation(Player, 1)
		
		emit_sound(Player, CHAN_AUTO, g_szSounds[SOUND_ALLERY_SHOT], 1.0, ATTN_NORM, 0, PITCH_NORM);
	
		make_strela(Player)
	}
	
	return HAM_IGNORED
}

public make_strela(id)
{
	if (!is_user_connected(id))
		return PLUGIN_HANDLED;
	
	static Float:origin[3], Float:angles[3], Float:v_forward[3], Float:v_right[3], Float:v_up[3], Float:gun_position[3], Float:player_origin[3], Float:player_view_offset[3];
	static Float:OriginX[3], originplayerent[3], Float:originend[3];
	get_user_origin(id,originplayerent,3)
	originend[0] = float(originplayerent[0]);
	originend[1] = float(originplayerent[1]);
	originend[2] = float(originplayerent[2]);
	pev(id, pev_v_angle, angles);
	pev(id, pev_origin, OriginX);
	engfunc(EngFunc_MakeVectors, angles);

	global_get(glb_v_forward, v_forward);
	global_get(glb_v_right, v_right);
	global_get(glb_v_up, v_up);

	pev(id, pev_origin, player_origin);
	pev(id, pev_view_ofs, player_view_offset);
	xs_vec_add(player_origin, player_view_offset, gun_position);

	xs_vec_mul_scalar(v_forward, 13.0, v_forward);
	xs_vec_mul_scalar(v_right, 0.0, v_right);
	xs_vec_mul_scalar(v_up, 0.0, v_up);

	xs_vec_add(gun_position, v_forward, origin);
	xs_vec_add(origin, v_right, origin);
	xs_vec_add(origin, v_up, origin);

	new Float:StartOrigin[3], Float:Angle[3];
			
	StartOrigin[0] = origin[0];
	StartOrigin[1] = origin[1];
	StartOrigin[2] = origin[2];
			
	entity_get_vector(id, EV_VEC_v_angle, Angle);

	new strela = create_entity("info_target");
	if (!pev_valid(strela) || !is_user_alive(id) )
		return PLUGIN_HANDLED;
	entity_set_string(strela, EV_SZ_classname, "CROSS_BOW");
	entity_set_model(strela, "models/allery_arrow.mdl");
	entity_set_origin(strela, StartOrigin);
	entity_set_vector(strela, EV_VEC_angles, Angle);
		
	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	
	entity_set_vector(strela, EV_VEC_mins, MinBox);
	entity_set_vector(strela, EV_VEC_maxs, MaxBox);

	entity_set_int(strela, EV_INT_solid, 2);
	entity_set_int(strela, EV_INT_movetype, 5);

	entity_set_edict(strela, EV_ENT_owner , id);
		
	static Float:vec[3];
	aim_at_origin(strela, originend ,vec);
	engfunc(EngFunc_MakeVectors, vec);
	global_get(glb_v_forward, vec);
	vec[0] *= 2000;
	vec[1] *= 2000;
	vec[2] *= 2000;
	set_pev(strela, pev_velocity, vec);
	Create_TE_BEAMFOLLOW( strela, g_iSprites[SPR_TRAIL], 10, 3, 132, 112, 255, 255 );
	entity_set_float(strela, EV_FL_nextthink, get_gametime() + 2.5)
	
	return PLUGIN_HANDLED;
}

public strela_touch(iAttacker, iVictim)
{
	//Если стрела попадает в какое-нибудь место (стена,пол и т.д.)
	if(iVictim == 0) 
	{
	if (is_valid_ent(iAttacker))
	remove_entity(iAttacker);
	}
	
	else if(is_user_connected(iVictim) && p_data_b[iVictim][PB_ISFROZENPLAYER] == false)
	{

	new attacker = entity_get_edict(iAttacker, EV_ENT_owner)

	if(get_user_team(iVictim) != get_user_team(attacker)) 
    {
		static iSkillLevel2;
        iSkillLevel2 = SM_GetSkillLevel(attacker, SKILL_CRITICAL_SHOT)
		if(iSkillLevel2 > 0  && p_data[attacker][P_RACE] == RACE_ALLERY)
		{
		static iTempDamage_a;
		iTempDamage_a = ARCHER_ARROW_DAMAGE_PLUS + p_crit_shot_damage[iSkillLevel2-1];
		
		WC3_Damage(iVictim, attacker, iTempDamage_a, CSW_KRIT_SHOT, 0);
		}
		else
		{
		WC3_Damage(iVictim, attacker, ARCHER_ARROW_DAMAGE_PLUS, CSW_KRIT_SHOT, 0);
		}
		if (is_valid_ent(iAttacker))
		remove_entity(iAttacker);
	}
	else
	{
	if (is_valid_ent(iAttacker))
	remove_entity(iAttacker);
	}
	}
	else
	{
	if (is_valid_ent(iAttacker))
	remove_entity(iAttacker);
	}
}

public fw_Item_deploy_knf_a(weapon)
{
	if(!pev_valid(weapon))
	return HAM_IGNORED

	new iPlayer = get_pdata_cbase(weapon, 41, 4)
 
	if(p_data[iPlayer][P_RACE] == RACE_ALLERY && mass_bow[iPlayer])
	{
	set_pev(iPlayer, pev_viewmodel2, szModel_V_ALLERY)
	set_pev(iPlayer, pev_weaponmodel2, szModel_P_ALLERY)
	}
	else if(p_data[iPlayer][P_RACE] == RACE_ALLERY && !mass_bow[iPlayer])
	{
	set_pev(iPlayer, pev_viewmodel2, szModelal_V)
	set_pev(iPlayer, pev_weaponmodel2, szModelal_P)
	}
	
 	return HAM_IGNORED
}

/*
* Ультиматум аллерии аура меткости
*/

public AL_ULT_FREEZE( iCaster, iTarget, iBodyPart )
{
	
	if ( !SHARED_IsPlayerSlowed( iTarget ) )
		{		

			p_data_b[iTarget][PB_STUNNED] = true;
			SHARED_SetSpeed( iTarget );
			
			set_task( ARCHER_ULTIMATE_FREEZE_TIME, "SHARED_ResetMaxSpeed", TASK_RESETSPEED + iTarget );

			// Make the user glow!
			SHARED_GlowShell( iTarget, 0, 255, 255, 2.0, 16 );
			
			// Create a screen fade
			Create_ScreenFade( iTarget, (1<<10), (1<<10), (1<<12), 255, 255, 255, 100 )

	        new vVictimOrigin[3],vAxisOrigin[3];
		    get_user_origin( iTarget, vVictimOrigin );

			vAxisOrigin[2] += vVictimOrigin[2] + 100;
			Create_TE_BEAMCYLINDER( vVictimOrigin, vVictimOrigin, vAxisOrigin, g_iSprites[SPR_SHOCKWAVE], 0, 0, 4, 60, 0, 41, 138, 255, 255, 0 );
		}	   

	    ULT_ResetCooldown(iCaster, get_pcvar_num( CVAR_wc3_ult_cooldown ));
}

public weapon_speed(weapon) 
{ 
	if(!pev_valid(weapon))
       return HAM_IGNORED
	
	new Player = get_pdata_cbase(weapon, 41, 4)

	if(pev_valid(weapon) && p_data[Player][P_RACE] == RACE_ALLERY && mass_bow[Player])
	{
	set_pdata_float(weapon, 46, BOW_ULTIMATE_SPEED, 4)
	}
	
	return HAM_IGNORED
}

/*
* Навык аллерии: Ясновидение
*/
Allery_run( iVictim )
{
	if(!is_user_alive( iVictim ))
		return;

	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_FAST_SHOT );

	if( iSkillLevel > 0 && p_data_b[iVictim][PB_ISFROZENSKILL] == false)
	{
	
	if ( random_float(0.0, 1.0 ) <= p_allery_run[iSkillLevel-1] )		
	{
	mass_spd[iVictim] = true;
	mass_inv[iVictim] = true;
	SHARED_INVIS_Set(iVictim);
	SHARED_SetSpeed(iVictim);
	set_task(ARCHER_FLIGHT_DURATION, "remove_invis_allery", TASK_AL_RUN + iVictim );
	}
	}
}

public remove_invis_allery(idUser)
{
	if ( idUser >= TASK_AL_RUN )
	{
		idUser -= TASK_AL_RUN;
	}
	
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
		return;
		
	mass_spd[idUser] = false;
	mass_inv[idUser] = false;
	SHARED_INVIS_Set( idUser );
	SHARED_SetSpeed(idUser);
	
	return;
}

public AlleryFlash(id)
{	
	if(!is_user_alive(id))
	{
	return;
	}
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel(id, SKILL_ANTI_FLASH);

	new Duration, HoldTime, Fade;
	Duration = read_data(1)
	HoldTime = read_data(2)
	Fade = read_data(3)
	
	if(iSkillLevel > 0 && (random_float(0.0, 1.0) <= p_allery_flash[iSkillLevel-1]))
	{
	message_begin(MSG_ONE, gmsgScreenFade, {0,0,0}, id)
	write_short(Duration)	// Duration
	write_short(HoldTime)	// Hold time
	write_short(Fade)	// Fade type
	write_byte(0)		// Red
	write_byte(0)		// Green
	write_byte(0)		// Blue
	write_byte(0)	// Alpha
	message_end()
	}
}