new g_FireCount[33];
new DARKLORD_ULT_DAMAGE = 20
new HP_REGEN = 50
new DARKLORD_DAMAGE_SKILL3 = 10
new DARKLORD_SKILL1_DAMAGE = 5

DARKLORD_SkillsOffensive1( iAttacker, iVictim, iHitPlace )
{

	static iSkillLevel;

	// Shadow Strike
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_1_DARKLORD );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		g_FireCount[iAttacker]+=1;
		
		if ( random_float(0.0, 1.0 ) <= p_darklord_skill1[iSkillLevel-1] )		
		{
			new vVictimOrigin[3], vAttackerOrigin[3]
			get_user_origin( iVictim, vVictimOrigin );
			get_user_origin( iAttacker, vAttackerOrigin );
			
			
			new damage;
			if(g_FireCount[iAttacker]>=20)damage = DARKLORD_SKILL1_DAMAGE+3;
			if(g_FireCount[iAttacker]>=15)damage = DARKLORD_SKILL1_DAMAGE+2;
			if(g_FireCount[iAttacker]>=10)damage = DARKLORD_SKILL1_DAMAGE+1;
			if(g_FireCount[iAttacker]<10)damage = DARKLORD_SKILL1_DAMAGE;
			
			WC3_Damage( iVictim, iAttacker, damage, CSW_SHADOW, iHitPlace );
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_SHADOW - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
	}
}

DARKLORD_SkillsOffensive3( iAttacker, iVictim, iHitPlace )
{
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_3_DARKLORD );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		
		if ( random_float(0.0,1.0 ) <= p_darklord_skill3[iSkillLevel-1] )		
		{
				new vVictimOrigin[3], vAttackerOrigin[3]
					get_user_origin( iVictim, vVictimOrigin );
					get_user_origin( iAttacker, vAttackerOrigin );
					vAttackerOrigin[2] +=50;
					vVictimOrigin[2] +=50;
					Create_TE_SPRITETRAIL( vAttackerOrigin, vVictimOrigin, g_iSprites[SPR_NEW_SKILL3], 50, 15, 1, 2, 6 );
					
					
					emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_SHADOWSTRIKE], 1.0, ATTN_NORM, 0, PITCH_NORM );
					
					WC3_Damage( iVictim, iAttacker, DARKLORD_DAMAGE_SKILL3, CSW_SHADOW, iHitPlace );
			}		
		}
		
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_SHADOW - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
}

public DARK_ULT_Immolate( iCaster, iTarget )
{
	// Emit sound and create the fire exploding effect on the player

	new origin[3]      
	get_user_origin( iTarget, origin ) 
	new vStartOrigin[3];
	vStartOrigin[0] = origin[0];
	vStartOrigin[1] = origin[1];
	vStartOrigin[2] = origin[2] + 50;
	Create_TE_SPRITETRAIL( vStartOrigin, origin, g_iSprites[SPR_DARKLORD_ULTIMATE], 30, 10, 1, 50, 10 );
	new Origin[3];
	get_user_origin( iTarget, Origin );
	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_NEW_ULT], 20, 24, 4 );
	Create_ScreenFade( iTarget, (1<<10), (1<<10), (1<<12), 0, 72, 255, 160 );

	// Do initial immolate damage and make their screen shake a little

	WC3_Damage( iTarget, iCaster, 10, CSW_SHADOW, -1 );

	new parm_DoTs[3];
	parm_DoTs[0] = iCaster;
	parm_DoTs[1] = iTarget;
	parm_DoTs[2] = 1;

	// Start the ultimate DoT

	new TaskId = TASK_DR_ULT + iTarget;
	set_task( 1.0, "DARK_ULT_Immolate_DoT", TaskId, parm_DoTs, 3 );
	
	return PLUGIN_HANDLED;
}

public DARK_ULT_Immolate_DoT( parm_DoTs[3] )
{
	new iCaster = parm_DoTs[0];
    new iTarget = parm_DoTs[1];
	new iCounter = parm_DoTs[2];
	
	// Stop DoT if the max number of ticks is reached

	if ( iCounter > 5 ) 
	{
		DARK_ULT_Immolate_Remove( iTarget );
		return PLUGIN_HANDLED;
	}

	// Emit sound and show the burning effect on the player

	new origin[3]      
	get_user_origin( iTarget, origin ) 
	new vStartOrigin[3];
	vStartOrigin[0] = origin[0];
	vStartOrigin[1] = origin[1];
	vStartOrigin[2] = origin[2] + 50;
	Create_TE_SPRITETRAIL( vStartOrigin, origin, g_iSprites[SPR_DARKLORD_ULTIMATE], 30, 10, 1, 50, 10 );
	new Origin[3];
	get_user_origin( iTarget, Origin );
	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_NEW_ULT], 20, 24, 4 );
	Create_ScreenFade( iTarget, (1<<10), (1<<10), (1<<12), 0, 72, 255, 160 );

	// Do the DoT damage

	WC3_Damage( iTarget, iCaster, 10, CSW_SHADOW, -1 );

	// If the target is still alive after this, make their screen glow orange and start the task again

    if ( is_user_alive( iTarget ) )
    {
		p_data[iTarget][PB_ISBURNING] = true;

        Create_ScreenFade( iTarget, (1<<10), (1<<10), (1<<12), 0, 72, 255, 160 );

		parm_DoTs[2]++;

		set_task( 1.0, "DARK_ULT_Immolate_DoT", TASK_DR_ULT + iTarget, parm_DoTs, 3 );

	}

	return PLUGIN_HANDLED;
}


DARK_ULT_Immolate_Remove( iTarget ) 
{
	// Clear global variables and stop the DoT task

	p_data[iTarget][PB_ISBURNING] = false;

	new TaskId = TASK_DR_ULT + iTarget;
    remove_task( TaskId, 0 );

    return PLUGIN_HANDLED;
}

public DARKLORD_HEALING( idUser )
{
	if ( task_exists( idUser + TASK_DR_H ) == 0 )
	{
		_DARKLORD_HEALING( idUser );
	}
}
		
public _DARKLORD_HEALING(idUser){

	if ( idUser >= TASK_DR_H )
	{
		idUser -= TASK_DR_H;
	}
	
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	if ( is_user_alive( idUser ) )
	{
		return;
	}
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( idUser, SKILL_2_DARKLORD );

	if ( iSkillLevel > 0 && p_data_b[idUser][PB_ISFROZENSKILL] == false )
	{
		
	if ( is_user_alive( idUser ) )
	{
		set_task( p_darklord_skill2[iSkillLevel-1], "DARKLORD_HEALING", TASK_DR_H + idUser );
	}
	
	if ( get_user_health( idUser ) < get_user_maxhealth( idUser ) )
	{
	if ( get_user_health( idUser ) + HP_REGEN > get_user_maxhealth( idUser ) )
	{
	set_user_health( idUser, get_user_maxhealth( idUser ) );
	}
	else
	{
	set_user_health( idUser, get_user_health( idUser ) + HP_REGEN );
	
	new origin[3]      
	get_user_origin( idUser, origin ) 
	new vStartOrigin[3];
	vStartOrigin[0] = origin[0];
	vStartOrigin[1] = origin[1];
	vStartOrigin[2] = origin[2] + 20;
	Create_TE_SPRITETRAIL( vStartOrigin, origin, g_iSprites[SPR_DARKLORD_ULTIMATE], 30, 10, 1, 50, 10 );
	}
	}
	}
	
	return;
}