new FIRE_DAMAGE = 5;
new DEATHMARK_DAMAGE = 2;
new Float:DEATHMARK_TIME = 5.0;
new FIRE_ULTIMATE_DAMAGE = 50;

DRAGON_ULT( iAttacker, iVictim)
{
	if ( !p_data_b[iAttacker][PB_ISCONNECTED] || !p_data_b[iVictim][PB_ISCONNECTED] )
	{
		return;
	}
	
	new Origin[3];
	get_user_origin( iVictim, Origin );
	new Origin_Att[3];
	get_user_origin( iAttacker, Origin_Att );
	emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE], 0.5, ATTN_NORM, 0, PITCH_NORM );
	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_IMMOLATE], 20, 24, 4 );
	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_BURNING], 30, 24, 4 );
	Create_TE_SPRITETRAIL( Origin_Att, Origin, g_iSprites[SPR_IMMOLATE], 50, 15, 1, 2, 6 );
	Create_ScreenShake( iVictim, (10<<12), (2<<12), (5<<12) );
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_3_DRAGON );
	if(iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false)
	{
	new damage = floatround(FIRE_ULTIMATE_DAMAGE * p_dragon3[iSkillLevel-1])
	WC3_Damage( iVictim, iAttacker, damage, CSW_IMMOLATE, -1 )
	}
	else
	{
	WC3_Damage( iVictim, iAttacker, FIRE_ULTIMATE_DAMAGE, CSW_IMMOLATE, -1 )
	}
	
	static Float:Velocity[3]
	pev(iVictim, pev_velocity, Velocity)
	Velocity[2] += 300.0
	Velocity[0] += 500.0
	set_pev(iVictim, pev_velocity, Velocity)
	ULT_ResetCooldown( iAttacker, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	
}	

public DEATHMARK(idUser)
{
	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	if ( is_user_alive( idUser ) )
	{
		set_task( DEATHMARK_TIME, "DEATHMARK", idUser );
	}
	
	new Origin[3];
	get_user_origin( idUser, Origin );
	
	Create_ScreenShake( idUser, (10<<12), (2<<12), (5<<12) );
	Create_TE_EXPLOSION( Origin, Origin, g_iSprites[SPR_BURNING], 30, 24, 4 );
	emit_sound( idUser, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE], 0.5, ATTN_NORM, 0, PITCH_NORM );
	WC3_Damage( idUser, idUser, DEATHMARK_DAMAGE, CSW_IMMOLATE, -1 )
}	

DRAGON_SkillsOffensive2( iAttacker, iVictim )
{
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_2_DRAGON );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if ( random_float(0.0,1.0 ) <= p_dragon2[iSkillLevel-1] )		
		{
			DEATHMARK(iVictim)
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_SHADOW - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
	}
}	

DRAGON_SkillsOffensive1( iAttacker, iVictim, iHitPlace )
{
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_1_DRAGON );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if ( random_float(0.0,1.0 ) <= p_dragon1[iSkillLevel-1] )		
		{
				new vVictimOrigin[3], vAttackerOrigin[3]
				get_user_origin( iVictim, vVictimOrigin );
				get_user_origin( iAttacker, vAttackerOrigin );
				Create_TE_SPRITETRAIL( vAttackerOrigin, vVictimOrigin, g_iSprites[SPR_BURNING], 50, 15, 1, 2, 6 );
					
				emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_IMMOLATE], 1.0, ATTN_NORM, 0, PITCH_NORM );
					
				WC3_Damage( iVictim, iAttacker, FIRE_DAMAGE, CSW_SHADOW, iHitPlace );		
		}
	}
}	