new block_ult_radius_duh = 300;
new DUH_DAMAGE = 15;

public DH_Ult_BigBadVoodoo( idUser )
{

	new iHealthMax = get_user_maxhealth( idUser );

	if ( !p_data_b[idUser][PB_ISCONNECTED] )
	{
		return;
	}
	
	new bool:bCanBlockUltimate = false;
 
	new iOrigin[3], iPlayersOrigin[3], players[32], idWorldPlayer, numberofplayers;
	get_user_origin( idUser, iOrigin );
 
	get_players( players, numberofplayers, "a" );
	for ( new i = 0; i < numberofplayers; i++ )
	{
	idWorldPlayer = players[i];
	get_user_origin( idWorldPlayer, iPlayersOrigin );
		if( get_distance( iOrigin, iPlayersOrigin ) < block_ult_radius_duh )
		{
			if( get_user_team( idUser ) != get_user_team( idWorldPlayer ) )
			{
				if( ULT_CanUserBlockUlt( idWorldPlayer ) )
				{
					bCanBlockUltimate = true;
				}
			}
		}
	}
	
	if( bCanBlockUltimate == true )
	{
		ULT_Blocked( idUser );
		ULT_RemoveCharge(idWorldPlayer)
		ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	}
	
	if( bCanBlockUltimate == false )
	{
	ULT_Icon( idUser, ICON_HIDE );
	
	SHARED_SetUserHealth( idUser, iHealthMax );
	
	if (get_user_health(idUser) > 255)
	{
		SHARED_SetUserHealth(idUser, 255 );
	}
	
	emit_sound(idUser, CHAN_STATIC, g_szSounds[SOUND_HEALTH_POTION], 1.0, ATTN_NORM, 0, PITCH_NORM );

	new vOrigin[3];
	get_user_origin( idUser, vOrigin );

	Create_TE_SPRITE( vOrigin, g_iSprites[SPR_HEALTH_POTION], 15, 200 );

	Create_ScreenFade( idUser, (1<<10), (1<<10), (1<<12), 0, 250, 0, 100 );
	
	ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
	}

	return;
}

//Навык: Шипастая аура (Thorns Aura), Раса: Ночные Эльфы (Night Elves of Kalimdor)
//Скилл 2 уровня
DH_SkillsDefensive ( iAttacker, iVictim, iDamage, iHitPlace )
{
	static iSkillLevel;

	iSkillLevel = SM_GetSkillLevel( iVictim, SKILL_DUHFIRE );
	if ( iSkillLevel > 0 && is_user_alive( iVictim ) && p_data_b[iVictim][PB_ISFROZENSKILL] == false)
	{
		static iAdditionalDamage;
		iAdditionalDamage = floatround( float( iDamage ) * p_duhthorns[iSkillLevel-1] );
		
		// Damage the user
		WC3_Damage( iAttacker, iVictim, iAdditionalDamage, CSW_THORNS, iHitPlace );

		// Make the user glow!
		SHARED_Glow( iAttacker, ( 3 * iAdditionalDamage ), 0, 0, 0 );
		
		new vAttackerOrigin[3];
		get_user_origin( iAttacker, vAttackerOrigin );
		// Create a screen fade
		Create_TE_SPRITE( vAttackerOrigin, g_iSprites[SPR_DUHFIRE], 10, 200 );
	}
}

DH_SkillsOffensive( iAttacker, iVictim, iDamage, iHitPlace )
{
	static iSkillLevel;

	// Shadow Strike
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_DUHIMPALE );
	if ( iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		if ( random_float(MIN_PERCENT_SHADOW, MAX_PERCENT_SHADOW ) <= p_duhimpale[iSkillLevel-1] )		
		{
			new vOrigin[3], pos[3], end[3]; 

   get_user_origin( iVictim, vOrigin); 

   pos[ 0 ] = vOrigin[ 0 ]; 
   pos[ 1 ] = vOrigin[ 1 ]; 
   pos[ 2 ] = vOrigin[ 2 ] + 600; 

   end[0] = vOrigin[0] 
   end[1] = vOrigin[1] 
   end[2] = vOrigin[2] - 600
   
   	Create_TE_BEAMPOINTS( pos, end, g_iSprites[SPR_DUHIMP], 5, 1, 9, 500, 0,  255, 255, 255, 255, 0 );

			// Damage the user
			WC3_Damage( iVictim, iAttacker, DUH_DAMAGE, CSW_SHADOW, iHitPlace );
		}
		else if ( get_pcvar_num( CVAR_wc3_psychostats ) )
		{
			new WEAPON = CSW_SHADOW - CSW_WAR3_MIN;

			iStatsShots[iAttacker][WEAPON]++;
		}
	}
	
	// Siphon Mana
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_DUHMONEY );
	if ( iSkillLevel > 0 && ((get_user_team( iAttacker ) != get_user_team( iVictim ))) && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
		
		new iMoney = floatround( p_duhmoney[iSkillLevel-1] * SHARED_GetUserMoney(iVictim) );
		
		// Remove the money from the victim
		SHARED_SetUserMoney( iVictim, SHARED_GetUserMoney( iVictim ) - iMoney, 1 );
		
		// Give the money to the attacker
		SHARED_SetUserMoney( iAttacker, SHARED_GetUserMoney( iAttacker ) + iMoney, 1 );

		// Make the user glow!
		SHARED_Glow( iVictim, 0, iDamage, 0, 0 );
		
		// Create a screen fade (purplish)
		Create_ScreenFade( iAttacker, (1<<10), (1<<10), (1<<12), 144, 58, 255, g_GlowLevel[iAttacker][1] );
	}
}
