
public dwarf_ammo_grenade(id)
{
    static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( id, SKILL_GRENADES );
	if(is_user_alive(id) && iSkillLevel > 0 && g_bGrenadeDisabled == false && p_data_b[id][PB_ISFROZENSKILL] == false)
	{
		new iParm[2]
		iParm[0] = id
		iParm[1] = -1
		
		new iGrenadeType = read_data(1)
		new iGrenadeCount = read_data(2)
		
		if((iGrenadeType == 12 || iGrenadeType == 11) && iGrenadeCount == 0 && g_bGrenadeDisabled == false)
		{
			if(iGrenadeType == 12 && iDwarfGrenades[id][0] < p_grenades[iSkillLevel-1])
				iParm[1] = 1
			else if(iGrenadeType == 11 && iDwarfGrenades[id][1] < p_grenades[iSkillLevel-1])
				iParm[1] = 2
			
			if(iParm[1] != -1)
				set_task(dw_gr_give_time, "dwarf_ammogrenade_give", TASK_DWARFNADE+id, iParm,2)
		}
	}
	
	return;
}
public dwarf_ammogrenade_give(iParm[2])
{
	if(is_user_alive(iParm[0]) && g_bGrenadeDisabled == false)
	{
		if(iParm[1])
			iDwarfGrenades[iParm[0]][iParm[1]-1]++
			
		if(iParm[1] == 0)
		{
			give_item(iParm[0],"weapon_hegrenade")
			give_item(iParm[0],"weapon_flashbang")
		}
		else if(iParm[1] == 1)
			give_item(iParm[0],"weapon_hegrenade")
		else if(iParm[1] == 2)
			give_item(iParm[0],"weapon_flashbang")
	}
	return;
}

DW_ULT_Freeze(id,victim)
{
	
	if( !is_user_alive(id) || !is_user_alive(victim) )
	return;
	
	new Float:velocity[3]
	
	Entvars_Get_Vector(victim, EV_VEC_velocity, velocity)
	velocity[2] = velocity[2] + 125;

	// Give em an upwards Jolt
	Entvars_Set_Vector(victim, EV_VEC_velocity, velocity)

	new iweapons[32], inum, weapname[24]
	get_user_weapons(victim,iweapons,inum)

	for(new a = 0; a < inum; a++) 
	{
		//Don't want to do anything with some weapons
		if ( !SHARED_IsPrimaryWeapon(id) && (iweapons[a] == CSW_C4 || iweapons[a] == CSW_KNIFE || iweapons[a] == CSW_HEGRENADE || iweapons[a] == CSW_SMOKEGRENADE || iweapons[a] == CSW_FLASHBANG )) 
		{
			continue;
		}

		get_weaponname(iweapons[a], weapname, 23)

		engclient_cmd(victim,"drop", weapname)
		give_item(id,weapname);
	}

	new iCurrent = -1
	new Float:weapvel[3]

	while ( (iCurrent = FindEntity(iCurrent, "weaponbox")) > 0 ) 
	{

		//Skip anything not owned by this client
		if ( Entvars_Get_Edict(iCurrent, EV_ENT_owner) != victim) continue

		Entvars_Get_Vector(iCurrent, EV_VEC_velocity, weapvel)

		//If Velocities are all Zero its on the ground already and should stay there
		if (weapvel[0] == 0.0 && weapvel[1] == 0.0 && weapvel[2] == 0.0) continue

		RemoveEntity(iCurrent)
	}
	engclient_cmd(victim,"weapon_knife")
	emit_sound( id, CHAN_STATIC, g_szSounds[SOUND_GNOME_CARTRINGE], 1.0, ATTN_NORM, 0, PITCH_NORM );
	lightning_effect(id, victim, 10)
}

public melt_ice(id)
{
    if( id >= TASK_DWARFICE )
	{
	id -= TASK_DWARFICE;
	}
	
	if (is_user_connected(id) && is_user_alive(id))
	{
		Entvars_Set_Float(id,EV_FL_friction,1.0)
	}
}

DW_SkillsOffensive( iAttacker, iVictim, iWeapon )
{
	if (p_data[iAttacker][P_RACE] != RACE_DWARF || !is_user_alive(iAttacker) || !is_user_alive(iVictim)) return;
	
	if (!(SHARED_IsGrenade( iWeapon ))) return;
	
	static iSkillLevel;
	iSkillLevel = SM_GetSkillLevel( iAttacker, SKILL_GRENADES );
	if (iSkillLevel > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false)
	{
		if (gIndex[iAttacker] == -1) return;
		new Float:aorigin[3], vorigin[3], parm[4], distance;
		get_user_origin(iVictim, vorigin);
		emit_sound( iVictim, CHAN_STATIC, g_szSounds[SOUND_DWARFF], 1.0, ATTN_NORM, 0, PITCH_NORM );
		
		entity_get_vector(iAttacker,EV_VEC_origin,aorigin);
		
		new iAttackerOrigin[3];
		iAttackerOrigin[0] = floatround(aorigin[0]);
		iAttackerOrigin[1] = floatround(aorigin[0]);
		
		distance = get_distance( iAttackerOrigin, vorigin)
		distance = distance ? distance : 1	// Avoid dividing by 0
		
		parm[0] = ((floatround(aorigin[0])-vorigin[0])/ distance) * 400
		parm[1] = ((floatround(aorigin[1])-vorigin[1])/ distance) * 400
		parm[2] = iVictim
		parm[3] = iAttacker

		// First lift them
		set_pev(iVictim, pev_velocity, {0.0, 0.0, 250.0});

		// Then push them back in x seconds after lift and do some damage
		set_task(0.1, "move_enemy", TASK_DWARPUSHISH+iVictim, parm, 4)
	}
	
}


public move_enemy(parm[])
{
	new victim = parm[2];
	
	if(!is_user_alive( victim ))
	return;

	new Float:fl_velocity[3];
	fl_velocity[0] = float(parm[0]);
	fl_velocity[1] = float(parm[1]);
	fl_velocity[2] = 250.0;
	set_pev(victim, pev_velocity, fl_velocity)
	
	Entvars_Set_Float(victim,EV_FL_friction,0.15)
	set_task(1.5,"melt_ice",TASK_DWARFICE+victim)
	
}

lightning_effect(id, targetid, linewidth)
{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( 8 )
	write_short(id)			// start entity
	write_short(targetid)	// entity
	write_short(g_iSprites[SPR_LIGHTNING] )	// model
	write_byte( 0 ) 		// starting frame
	write_byte( 15 )  		// frame rate
	write_byte( 2 )  		// life
	write_byte( linewidth )	// line width
	write_byte( 10 )  		// noise amplitude
	write_byte( 255 )		// r, g, b
	write_byte( 255 )		// r, g, b
	write_byte( 255 )		// r, g, b
	write_byte( 255 )		// brightness
	write_byte( 0 )			// scroll speed
	message_end()
}
