//#define PLAYERS_BLOCK_ULTIMATE 300 // Какая дистанция блокирует ультимэйт

public fRemoveWeaponsPlayers(idUser)
{
   if( is_user_alive( idUser ) )
	{
	 if( p_data[idUser][P_RACE] == RACE_STRELOK )
	 {
	  new iAmmo, iClip;
	  new iWeapon = get_user_weapon( idUser, iAmmo, iClip );
	  
	  if ( SHARED_IsStrelokWeapon( iWeapon ))
	{
        //Получение id оружия
        new pl_weapon = get_user_weapon(idUser)
 
        new weapon_name[24]; 
		
        //Получение названия оружия
        get_weaponname(pl_weapon,weapon_name,24)
                 
        //Вызов функции
        ham_strip_weapon(idUser,weapon_name)
	 }
	 }
	}
}

public knok_strel(iAttacker, iVictim)
{
	
	static iSkillLevelSpecial;
	iSkillLevelSpecial = SM_GetSkillLevel( iAttacker, SKILL_SPECIAL_BULLETS );
	
	if(iSkillLevelSpecial > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
	{
	if( random_float( 0.0, 1.0 ) <= p_special_bullets[iSkillLevelSpecial-1] )
	{
		new Float:vec[3];
		new Float:oldvelo[3];
		get_user_velocity(iVictim, oldvelo);
		create_velocity_vector(iVictim , iAttacker , vec);
		vec[0] += oldvelo[0];
		vec[1] += oldvelo[1];
		set_user_velocity(iVictim , vec);
	}
	}
	
	return PLUGIN_CONTINUE;
}

stock create_velocity_vector(victim, attacker, Float:velocity[3])
{
	new Float:vicorigin[3];
	new Float:attorigin[3];
	entity_get_vector(victim   , EV_VEC_origin , vicorigin);
	entity_get_vector(attacker , EV_VEC_origin , attorigin);

	new Float:origin2[3]
	origin2[0] = vicorigin[0] - attorigin[0];
	origin2[1] = vicorigin[1] - attorigin[1];

	new Float:largestnum = 0.0;

	if(floatabs(origin2[0])>largestnum) largestnum = floatabs(origin2[0]);
	if(floatabs(origin2[1])>largestnum) largestnum = floatabs(origin2[1]);

	origin2[0] /= largestnum;
	origin2[1] /= largestnum;
	
	velocity[0] = ( origin2[0] * (kn_w_Strelok * 3000) ) / get_entity_distance(victim , attacker);
	velocity[1] = ( origin2[1] * (kn_w_Strelok * 3000) ) / get_entity_distance(victim , attacker);
	
	if(velocity[0] <= 20.0 || velocity[1] <= 20.0)
		velocity[2] = random_float(200.0 , 275.0);
	
	return 1;  
}

StrelokSkillsOffensive( iAttacker, iVictim, iDamage, iWeapon, iHitPlace )
{

  if(!is_user_alive( iAttacker ) || !is_user_alive( iVictim ))
	return;
	
	static iSkillLevelDamage;
    iSkillLevelDamage = SM_GetSkillLevel( iAttacker, SKILL_ACCURACY );
    if( iSkillLevelDamage > 0 && p_data_b[iAttacker][PB_ISFROZENSKILL] == false )
    {
     new iAttackerOrigin[3], iVictimOrigin[3];
     get_user_origin( iAttacker, iAttackerOrigin );
     get_user_origin( iVictim, iVictimOrigin );
     new iAmmo, iClip;
     new iCurWeapon = get_user_weapon( iAttacker, iAmmo, iClip );
	 
     if( iCurWeapon == CSW_XM1014 || iCurWeapon == CSW_M3 )
     { 
	  static iStrelokDamage;
	  iStrelokDamage = floatround( float( iDamage ) * p_accuracy[iSkillLevelDamage-1] );
	  WC3_Damage( iVictim, iAttacker, iStrelokDamage, iWeapon, iHitPlace );
      Create_ScreenFade( iVictim, ( 1<<10 ), ( 1<<10 ), ( 1<<12 ), 100, 0, 0, 100 );
    }
   }
}

public fStrelokSkinSet(idUser)
{
static iSkillLevel;
iSkillLevel = SM_GetSkillLevel( idUser, SKILL_MASTER_CLOAKING );
if( iSkillLevel > 0 && p_data_b[idUser][PB_ISFROZENSKILL] == false )
{
if( random_float( 0.0, 1.0 ) <= p_master_cloaking[iSkillLevel-1] )
{
SHARED_ChangeSkin( idUser, SKIN_SWITCH );
client_print( idUser, print_center, "Skin Switched" );
}
}
}

public fStrelokSkinReset(idUser)
{

if(!is_user_alive( idUser ))
	return;

static iSkillLevel;
iSkillLevel = SM_GetSkillLevel( idUser, SKILL_MASTER_CLOAKING );
if( iSkillLevel > 0 && p_data_b[idUser][PB_ISFROZENSKILL] == false )
{
SHARED_ChangeSkin( idUser, SKIN_RESET );
client_print( idUser, print_center, "Skin Reset" );
}
}


public fStrelokUltimateBottleHealth(idUser)
{
 if( !is_user_alive(idUser) )
 return;
 
 new iHealth = get_user_health( idUser );
 new iMaxHealth = get_user_maxhealth( idUser );
 
 if( iHealth == iMaxHealth )
 {
 WC3_StatusText( idUser, 0, "%L", LANG_PLAYER, "STRELOK_MAX_HP" );
 return;
 }
 
 new bool:bCanBlockUltimate = false;
 
 new iOrigin[3], iPlayersOrigin[3], players[32], idWorldPlayer, numberofplayers;
 get_user_origin( idUser, iOrigin );
 
 get_players( players, numberofplayers, "a" );
 for ( new i = 0; i < numberofplayers; i++ )
 {
   idWorldPlayer = players[i];
   get_user_origin( idWorldPlayer, iPlayersOrigin );
   if( get_distance( iOrigin, iPlayersOrigin ) < bur_Strelok )
  {
    if( get_user_team( idUser ) != get_user_team( idWorldPlayer ) )
    {
	 if( ULT_CanUserBlockUlt( idWorldPlayer ) )
	 {
       bCanBlockUltimate = true;
	 }
    }
  }
 }
 
 if( bCanBlockUltimate == true )
 {
 ULT_Blocked( idUser );
 ULT_RemoveCharge(idWorldPlayer)
 ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) );
 }
 
 if( bCanBlockUltimate == false )
 {
 if( is_user_alive( idUser ) )
 {
 set_task( ht_Strelok, "fStrelokGetHealth", TASK_STRELOK_GET_HEALTH + idUser, _, _, "a", num_heal_ult_Strelok );
 ULT_ResetCooldown( idUser, get_pcvar_num( CVAR_wc3_ult_cooldown ) ); 
 }
 }
 
}

public fStrelokGetHealth( idUser )
{

 if( idUser >= TASK_STRELOK_GET_HEALTH )
 {
 idUser -= TASK_STRELOK_GET_HEALTH;
 }
 
 if( is_user_alive(idUser))
 {
 
 new iHealth = get_user_health( idUser );
 new iMaxHealth = get_user_maxhealth( idUser );
 if( iHealth < iMaxHealth )
 {
 set_user_health( idUser, get_user_health(idUser) + hp_ult_p_Strelok );
 }
 }
}





















